<?php
    class Stream_control
    {
        var $mysqli;
	    var $dbpref;
        var $load;
        
        function __construct($arr)
        {
            $this->mysqli=$arr['mysqli'];
            $this->dbpref=$arr['dbpref'];
            if(isset($arr['load']))
            {
                $this->load=$arr['load'];
            }
            $this->media= false;
        }
        function setMedia($media)
        {
            $media->ext= pathinfo($media->file_path, PATHINFO_EXTENSION);
            $this->media= $media;
        }
        function hasPermission()
        {
            $media= $this->media;
            if($media->permission =='public' || isset($_SESSION['qfnl_media_lock_'.get_option('site_token')]) || isset($_SESSION['user'.get_option('site_token')]) )
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        function readFile($file)
        {
            global $is_gcp;
            if(is_file($file))
            {
                if(!$is_gcp)
                {	  
                    $fp=fopen($file,'r');
                    $data=fread($fp,filesize($file));
                    fclose($fp);
                }
                else
                {
                    $data=gcp_files_get_content($file);	  	  
                }
                return $data;
            }
            return false;
        }
        function doStreaming()
        {
            if(!$this->hasPermission())
            {
                die('Unauthorized access');
            }
            if($this->media)
            {
                $media= $this->media;

                header('content-type: '.$media->file_type);
                if(in_array($media->type, array('document', 'other')))
                {
                    $title= str_replace(" ", "_", urlencode($media->title));
                    if(strpos(strrev($title), strrev('.'.$media->ext)) !==0)
                    {
                        $title .= '.'.$media->ext; 
                    }

                    header('content-disposition: inline; filename="'.$title.'"');
                    echo $this->readFile($media->file_path);
                }
                else if(in_array($media->type, array('image')))
                {
                    echo $this->readFile($media->file_path);
                }
                else if($media->type =='video')
                {
                    $this->doVideoStreaming();
                }
                else if($media->type =='audio')
                {
                    $this->doAudioStreaming();
                }
                return true;
            }
            return false;
        }
        function getChunkSize($size)
        {
            $mb= round(($size/1024)/1024);
            $len=1;
            if($mb<1)
            {
                $len= $size/2;
            }
            else if($mb<10)
            {
                $len= $size*(40/100);
            }
            else if($mb<50)
            {
                $len= $size*(5/100);
            }
            else if($mb<100)
            {
                $len= $size*(4/100);
            }
            else if($mb<200)
            {
                $len= $size*(2/100);
            }
            else if($mb<300)
            {
                $len= $size*(1/100);
            }
            else if($mb<500)
            {
                $len= $size*(0.4/100);
            }

            return round($len);
        }
        function doVideoStreaming()
        {
            $file= $this->media->file_path;
            $size= filesize($file);
            $start= 0;
            $end= $size-1;
            $max= $this->getChunkSize($size);

            ob_end_clean();
            $fp= fopen($file, 'rb');
            
            $read= 0;
            if(isset($_SERVER['HTTP_RANGE']))
            {
                $range= explode('-', str_replace('bytes=', '', $_SERVER['HTTP_RANGE']));
                $start= (isset($range[0]) && is_numeric($range[0]))? $range[0]: $start;
                $end= (isset($range[1]) && is_numeric($range[1]))? $range[1]: $end;

                $chunk_size= ($end-$start)+1;
                header("content-range: bytes ".$start."-".$end."/".$size);
                header("acept-ranges: bytes");
                header("content-length: ".$size);
                header("http/1.1 206 Partial content");
                fseek($fp, $start);
                
                $data= fread($fp, $max);
                if($data){
                    echo $data;
                    $read= 1;
                }
                //$fp= fopen("C:/Users/user/Desktop/range.txt", "a");
                //fwrite($fp, $start."-".$end."/".$size.PHP_EOL);
                //fclose($fp);
            }
            if(!$read)
            {
                header('content-length: '.$size);
                echo fread($fp, $max);
            }
            fclose($fp);
            flush();

        }
        function doAudioStreaming()
        {
            
            $file= $this->media->file_path;
            $size= filesize($file);
            $start= 0;
            $end= $size-1;
            $max= $this->getChunkSize($size);

            ob_end_clean();
            $fp= fopen($file, 'rb');
            
            $read= 0;
            if(isset($_SERVER['HTTP_RANGE']))
            {
                $range= explode('-', str_replace('bytes=', '', $_SERVER['HTTP_RANGE']));
                $start= (isset($range[0]) && is_numeric($range[0]))? $range[0]: $start;
                $end= (isset($range[1]) && is_numeric($range[1]))? $range[1]: $end;

                $chunk_size= ($end-$start)+1;
                header("content-range: bytes ".$start."-".$end."/".$size);
                header("acept-ranges: bytes");
                header("content-length: ".$size);
                header("http/1.1 206 Partial content");
                fseek($fp, $start);
                
                $data= fread($fp, $max);
                if($data){
                    echo $data;
                    $read= 1;
                }
                //$fp= fopen("C:/Users/user/Desktop/range.txt", "a");
                //fwrite($fp, $start."-".$end."/".$size.PHP_EOL);
                //fclose($fp);
            }
            if(!$read)
            {
                header('content-length: '.$size);
                echo fread($fp, $max);
            }
            fclose($fp);
            flush();
        }
    }
?>