"use strict"
$(function(){

   
  // This has the UnShifted and Shifted characters that each key maps to
  // Ones that are to be ignored for character input are empty.
  var cfCourseKeyboardCharMap = [
    ["",""], // [0]
    ["",""], // [1]
    ["",""], // [2]
    ["",""], // [3]
    ["",""], // [4]
    ["",""], // [5]
    ["",""], // [6]
    ["",""], // [7]
    ["",""], // [8]
    ["",""], // [9]
    ["", ""], // [10]   
    ["",""], // [11]
    ["",""], // [12]
    ["\r", "\r"], // [13] - MOST control characters are ignored.  This one (Carriage Return, or "Enter") is significant!
    ["",""], // [14]
    ["",""], // [15]
    ["",""], // [16]
    ["",""], // [17]
    ["",""], // [18]
    ["",""], // [19]
    ["",""], // [20]
    ["",""], // [21]
    ["",""], // [22]
    ["",""], // [23]
    ["",""], // [24]
    ["",""], // [25]
    ["",""], // [26]
    ["",""], // [27]
    ["",""], // [28]
    ["",""], // [29]
    ["",""], // [30]
    ["",""], // [31]
    [" "," "], // [32]  // SPACE!  Don't "clean it up" and remove the space!
    ["",""], // [33]
    ["",""], // [34]
    ["",""], // [35]
    ["",""], // [36]
    ["",""], // [37]
    ["",""], // [38]
    ["",""], // [39]
    ["",""], // [40]
    ["",""], // [41]
    ["",""], // [42]
    ["",""], // [43]
    ["",""], // [44]
    ["",""], // [45]
    ["",""], // [46]
    ["",""], // [47]
    ["0",")"], // [48]
    ["1","!"], // [49]
    ["2","@"], // [50]
    ["3","#"], // [51]
    ["4","$"], // [52]
    ["5","%"], // [53]
    ["6","^"], // [54]
    ["7","&"], // [55]
    ["8","*"], // [56]
    ["9","("], // [57]
    ["",""], // [58]
    [";",":"], // [59]
    ["<",""], // [60]
    ["=",""], // [61]
    [">",""], // [62]
    ["?",""], // [63] shifted;  else "/"
    ["",""], // [64]
    ["a","A"], // [65]
    ["b","B"], // [66]
    ["c","C"], // [67]
    ["d","D"], // [68]
    ["e","E"], // [69]
    ["f","F"], // [70]
    ["g","G"], // [71]
    ["h","H"], // [72]
    ["i","I"], // [73]
    ["j","J"], // [74]
    ["k","K"], // [75]
    ["l","L"], // [76]
    ["m","M"], // [77]
    ["n","N"], // [78]
    ["o","O"], // [79]
    ["p","P"], // [80]
    ["q","Q"], // [81]
    ["r","R"], // [82]
    ["s","S"], // [83]
    ["t","T"], // [84]
    ["u","U"], // [85]
    ["v","V"], // [86]
    ["w","W"], // [87]
    ["x","X"], // [88]
    ["y","Y"], // [89]
    ["z","Z"], // [90]
    ["",""], // [91] Windows Key (Windows) or Command Key (Mac)
    ["",""], // [92]
    ["",""], // [93]
    ["",""], // [94]
    ["",""], // [95]
    // Number Keypad Entries...
    ["0",""], // [96]
    ["1",""], // [97]
    ["2",""], // [98]
    ["3",""], // [99]
    ["4",""], // [100]
    ["5",""], // [101]
    ["6",""], // [102]
    ["7",""], // [103]
    ["8",""], // [104]
    ["9",""], // [105]
    ["*",""], // [106]
    ["+",""], // [107]
    ["",""], // [108]
    ["-",""], // [109]
    [".",""], // [110]
    ["/",""], // [111]
  
    ["",""], // [112]
    ["",""], // [113]
    ["",""], // [114]
    ["",""], // [115]
    ["",""], // [116]
    ["",""], // [117]
    ["",""], // [118]
    ["",""], // [119]
    ["",""], // [120]
    ["",""], // [121]
    ["",""], // [122]
    ["",""], // [123]
    ["",""], // [124]
    ["",""], // [125]
    ["",""], // [126]
    ["",""], // [127]
    ["",""], // [128]
    ["",""], // [129]
    ["",""], // [130]
    ["",""], // [131]
    ["",""], // [132]
    ["",""], // [133]
    ["",""], // [134]
    ["",""], // [135]
    ["",""], // [136]
    ["",""], // [137]
    ["",""], // [138]
    ["",""], // [139]
    ["",""], // [140]
    ["",""], // [141]
    ["",""], // [142]
    ["",""], // [143]
    ["",""], // [144]
    ["",""], // [145]
    ["",""], // [146]
    ["",""], // [147]
    ["",""], // [148]
    ["",""], // [149]
    ["",""], // [150]
    ["",""], // [151]
    ["",""], // [152]
    ["",""], // [153]
    ["",""], // [154]
    ["",""], // [155]
    ["",""], // [156]
    ["",""], // [157]
    ["",""], // [158]
    ["",""], // [159]
    ["",""], // [160]
    ["",""], // [161]
    ["",""], // [162]
    ["",""], // [163]
    ["",""], // [164]
    ["",""], // [165]
    ["",""], // [166]
    ["",""], // [167]
    ["",""], // [168]
    ["",""], // [169]
    ["",""], // [170]
    ["",""], // [171]
    ["",""], // [172]
    ["",""], // [173]
    ["",""], // [174]
    ["",""], // [175]
    ["",""], // [176]
    ["",""], // [177]
    ["",""], // [178]
    ["",""], // [179]
    ["",""], // [180]
    ["",""], // [181]
    ["",""], // [182]
    ["",""], // [183]
    ["",""], // [184]
    ["",""], // [185]
    ["",""], // [186]
    ["=","+"], // [187]
    [",","<"], // [188]
    ["-","_"], // [189]
    [".",">"], // [190]
    ["/","?"], // [191]
    ["`","~"], // [192]
    ["",""], // [193]
    ["",""], // [194]
    ["",""], // [195]
    ["",""], // [196]
    ["",""], // [197]
    ["",""], // [198]
    ["",""], // [199]
    ["",""], // [200]
    ["",""], // [201]
    ["",""], // [202]
    ["",""], // [203]
    ["",""], // [204]
    ["",""], // [205]
    ["",""], // [206]
    ["",""], // [207]
    ["",""], // [208]
    ["",""], // [209]
    ["",""], // [210]
    ["",""], // [211]
    ["",""], // [212]
    ["",""], // [213]
    ["",""], // [214]
    ["",""], // [215]
    ["",""], // [216]
    ["",""], // [217]
    ["",""], // [218]
    ["[","{"], // [219]
    ["\\","|"], // [220]
    ["]","}"], // [221]
    ["'","\""], // [222]
    ["",""], // [223]
    ["",""], // [224]
    ["",""], // [225]
    ["",""], // [226]
    ["",""], // [227]
    ["",""], // [228]
    ["",""], // [229]
    ["",""], // [230]
    ["",""], // [231]
    ["",""], // [232]
    ["",""], // [233]
    ["",""], // [234]
    ["",""], // [235]
    ["",""], // [236]
    ["",""], // [237]
    ["",""], // [238]
    ["",""], // [239]
    ["",""], // [240]
    ["",""], // [241]
    ["",""], // [242]
    ["",""], // [243]
    ["",""], // [244]
    ["",""], // [245]
    ["",""], // [246]
    ["",""], // [247]
    ["",""], // [248]
    ["",""], // [249]
    ["",""], // [250]
    ["",""], // [251]
    ["",""], // [252]
    ["",""], // [253]
    ["",""], // [254]
    ["",""] // [255]
  ];
    let cfCourseTimerCounterP = 0;
    let cfCourseTimerPreventT = 0;
    var cfCoursetimer = setInterval( function()
    { 
        cfCourseTimerPreventT++;
        if( cfCourseTimerPreventT > 60)
        {
            cfCourseTimerPreventT = 0;
            cfCourseTimerCounterP = 0;
        }
        
    }, 1000);
    let cfCourseTimerCounterPFNotes = 0;
    let cfCourseTimerPreventTFNotes = 0;
    var cfCoursetimerfnotes = setInterval( function()
    { 
        cfCourseTimerPreventTFNotes++;
        if( cfCourseTimerPreventTFNotes > 60)
        {
            cfCourseTimerPreventTFNotes = 0;
            cfCourseTimerCounterPFNotes = 0;
        }
        
    }, 1000);
    
    cfCourseGetPCHTML();
    cfCourseGetVideoStatus();
    cfCourseGetForTinyResponsive();
    //make cirtificates disabled by default
    //processComplitionCertificate(0, true);

    // change the angle
    $( ".cf-course-open-s" ).on("click",function(eve){
        let target = $(this);
        if( $( target ).hasClass( "cf-course-sec-o" ) )
        {
            let ele  = $(this);
            let aEle = $(ele).find(".cf-course-msr-s-arr");
            if( $( aEle ).hasClass("fa-angle-down") )
            {
                $(aEle).removeClass("fa-angle-down").addClass("fa-angle-up");

            }else{
                $(aEle).removeClass("fa-angle-up").addClass("fa-angle-down");
            }
        }

    });
    $("textarea").each(function () {
        let newHeight = (this.scrollHeight)+90;
        this.setAttribute("style", "height:" + newHeight + "px;overflow-y:hidden;");
      }).on("input", function () {
        this.style.height = "auto";
        this.style.height = (this.scrollHeight) + "px";
      });
      

    //this function is to fill either like or dislike at window load.. 
    $( window ).on( "load", function() {
        var c_id=$("#cfcourse-course--id").val();
        var op_id=$("#cfcourse-option--id").val();
        let count = $("#cf-course-main-ccount-"+op_id).data("count");
        try
        {
            let hash= window.location.hash.replace("#", "").trim();
            if(hash.length>0)
            {
                let curl = new URL(window.location);
                let type = curl.searchParams.get('type');
                $(".cf-course-tab-a").removeClass("cf-course-active-a");
                $(".cfcourse-tabs").removeClass("cf-course-tab-active");
                if(type=="comment"){
                    document.getElementById("cf-course-tabs-a-3").classList.add("cf-course-active-a");
                    document.getElementById("cfcourse-tabs-3").classList.add("cf-course-tab-active");
                }else{
                    document.getElementById("cf-course-tabs-a-4").classList.add("cf-course-active-a");
                    document.getElementById("cfcourse-tabs-4").classList.add("cf-course-tab-active");
                }
            }
        }catch(err)
        {console.log(err);}

        if(count < 10){
            count="0"+count;
        }
        $(".cf-cc-mcon-cont").text(count);
        var m_id=$("#cfcourse-member--id").val();
        let postData= "action=cfcourse_check_like_dislike&c_id="+c_id+"&op_id="+op_id+"&m_id="+m_id;//lecture_controller->checkLikeStatus()
      $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){
          if(response==1)
          {
                $("#cf-course--thumbs-up-like i").removeClass("far").addClass("fas cf-course-lecture-like")
          }
          else if(response==-1)
          {
                $("#cf-course--thumbs-up-dislike i").removeClass("far ").addClass("fas cf-course-lecture-like")
          }
      });//end of post function
    });//end of window function 
      $(document).on("click",function(eve)
      {
          let tar = eve.target;
          if($(tar).hasClass("cf-course-assign-ada-btn"))
          {
             
            let parEle = $(tar).parents(".cf-course-read-more-des");
            let childEl = $(parEle).find(".cf-course-assign-ada-ans-h");
            let txt = $(tar).text();
            if(txt.toLowerCase()=="read more"){
                $(tar).text("Read less");
                $(childEl).addClass("cf-course-assign-ada-ans mb-3 pb-5");
            }else{
                $(tar).text("Read more");
                $(childEl).removeClass("cf-course-assign-ada-ans mb-3 pb-5");
            }
          }
      });

    //to insert into the like value.. 
    $("#cf-course--thumbs-up-like").on("click", function(eve){
        var c_id=$("#cfcourse-course--id").val();
        var op_id=$("#cfcourse-option--id").val();
        var m_id=$("#cfcourse-member--id").val();        
      let postData= "action=cfcourse_add_like&c_id="+c_id+"&op_id="+op_id+"&m_id="+m_id;//lecture_controller->addLike()
      $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){
      let  res  = $.parseJSON( response );

            if( res.status ==1 )
            {
               $("#cf-course--thumbs-up-like i").removeClass("far").addClass("fas cf-course-lecture-like");
               $("#cf-course--likes").text(res.counts);
            }
            if( res.status ==-1 )
            { 

                $("#cf-course--thumbs-up-like i").removeClass("fas cf-course-lecture-like").addClass("far");
                $("#cf-course--likes").text(res.counts);
            }
            if( res.status ==5 )
            { 

                $("#cf-course--thumbs-up-like i").removeClass("far").addClass("fas cf-course-lecture-like");
                $("#cf-course--thumbs-up-dislike i").removeClass("fas cf-course-lecture-like").addClass("far");
                $("#cf-course--likes").text(res.counts);
                $("#cf-course--dislikes").text(res.count_dislikes);
            }
            else if( res.status == 0 )
            { 
                window.location=location.href;
               
            }
        });
    });
    $(".cf-course-dropdown-progress").click(function(){
        $(".cf-course-progress-dropdown").toggleClass("show");
    });

    $("#cf-course-choose-theme-btn").on("click",function(eve){
        let atLeastOneChecked=false;
        let theme="";
        $(".cfcourse_custom_theme").each(function() {
            if ( $( this ).is(":checked")) {
                theme = $(this).val();
                atLeastOneChecked = true;
            }
        });
        if(atLeastOneChecked)
        {
            document.cookie = "cfCourseUserChooseTheme="+theme+"; path=/; expires=Wed, 05 Aug 2022 23:00:00 UTC";
            location.reload();
        }        

    });
    $(".cf-course-select-theme").on("click",function(eve){
        eve.preventDefault();
        $("#mycf_course_theme_model").show();
    });
    $(".cf-course-middle-rating").on("click",function(){
        $("#mycf_course_rating-model").show();
    });

    //this function is to open modal at click to show remaining days left in unlock section at drip feeding(student side)
    $(".cf-course-open-model").on("click", function()
    {
        let target = $( this );
        let days   = $( target ).data("days");
        $("#cf-course--d-ys").text( days+" days" );
        $("#mycf_course_drip_model").show();
    });
    $(".cf-course-close-drip-btn").on("click", function(){
        $("#mycf_course_drip_model").hide();
        $("#mycf_course_drip_submit_model").hide();
        $("#mycf_course_theme_model").hide();
        $("#mycf_course_drip_note_model").hide();
        $("#mycf_course_rating-model").hide();
    });
    $(".cf-course-close-drip-btn-aq").on("click", function(){
        $("#cfquiz_stud_form").trigger("reset");
        $("#mycf_course_drip_submit_model").hide();
        window.location=location.href;
    });

    //to insert into the dislike value.. 
    $("#cf-course--thumbs-up-dislike").on("click", function(eve){
        var c_id=$("#cfcourse-course--id").val();
        var op_id=$("#cfcourse-option--id").val();
        var m_id=$("#cfcourse-member--id").val();        
      let postData= "action=cfcourse_add_dislike&c_id="+c_id+"&op_id="+op_id+"&m_id="+m_id;//lecture_controller->addDisLike()
      $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){
      let  res  = $.parseJSON( response );
            if( res.status ==2 )
            {
                $("#cf-course--thumbs-up-dislike i").removeClass("far").addClass("fas cf-course-lecture-like");
                $("#cf-course--dislikes").text(res.counts);
            }
            if( res.status ==-2 )
            {
                $("#cf-course--thumbs-up-dislike i").removeClass("fas cf-course-lecture-like").addClass("far");
                $("#cf-course--dislikes").text(res.counts);
            }
            if( res.status ==5 )
            { 
                $("#cf-course--thumbs-up-like i").removeClass("fas cf-course-lecture-like").addClass("far");
                $("#cf-course--thumbs-up-dislike i").removeClass("far").addClass("fas cf-course-lecture-like");
                $("#cf-course--likes").text(res.counts);
                $("#cf-course--dislikes").text(res.count_dislikes);
            }
            else if( res.status == 0 )
            { 
                window.location=location.href;
               
            }
        });
       $("#cf-course--thumbs-up-dislike i").removeClass("far").addClass("fas");
    });

    // open tabas
    $('.cf-course-tab-a').click(function(eve){
        let vertTabs, len, i=0;
        let count = $(this).data("id");
        $(".cf-course-tab-a").removeClass("cf-course-active-a");
        $(".cfcourse-tabs").removeClass("cf-course-tab-active");
        vertTabs = $(".cf-course-tab-a");
        len = vertTabs.length;
        for( i=0; i <= len;i++ )
        {
          if( $(this).hasClass("cf-course-tabs-a-"+i+"") )
          {
            $(".cf-course-tabs-a-"+count).addClass("cf-course-active-a");
            $(this).addClass("cf-course-active-a");
            $(".cfcourse-tabs-"+i+"").addClass("cf-course-tab-active");
            break;
          }
        }
    });
    // add progress in lecture checkbox and above progress bar
    $(".cf-course-msrs-lch").on("click",function()
    {

        let c_id  = $( this).data("c_id");
        let s_id  = $( this).data("s_id");
        let op_id  = $( this).data("op_id");
        let m_id  = $( this).data("m_id");
        let watc = 1;
        let total_prgrs = parseInt($("#cf-course-a-mem-p").text());
        if ( $(this).prop("checked")==true )
        {
            watc = 1;

        }else{
            watc = 0;
        }
        cfCourseAddProgress( c_id, s_id, op_id, m_id, watc  );
        
    });

    // start a course click on start course button
    $(".cf-course--st-course").on("click",function()
    {
        let oid  = $( this).data("oid");
        let sid  = $( this).data("sid");
        let type = $( this).data("type");
        let cid  = $( this).data("cid");
        let mid  = $( this).data("mid");
        cfCourseStartVideoFrom( 0,mid, cid, sid, oid, "save" , type);
    });

    // start a lecture from specific time
    $(".cf-course-getlen-id").on("click",function()
    {
        let oid    = $( this).data("opt");
        let sid    = $( this).data("sec");
        let type   = $( this).data("type");
        let cid    = $( this).data("course");
        let mid    = $( this).data("m_id");
        cfCourseStartVideoFrom( 0,mid, cid, sid, oid, "save" ,type);
    });


    // add a notes 
    $(".cf-course-all-notes").on("submit", function( eve ){
        let tar = eve.target;
        if( $( tar ).hasClass("cf-course-notes-form") )
        {
            let sbBtn = ("#cf-course-notes-add-b");
            $( sbBtn ).html('Adding.. <span class=" spinner-border spinner-border-sm"></span>'); 
            eve.preventDefault();
            let postData= "action=cfcourse_add_notes&m_action=save&"+$(tar).serialize();

            $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){
                let res  = $.parseJSON( response );
               
                if( res.status ==1 )
                {
                    $( sbBtn ).html('Add'); 
                    if( res.type=="add" )
                    {
                        cfCourseTimerCounterPFNotes++;
                        if( cfCourseTimerCounterPFNotes > 15 )
                        {
                            window.location=location.href;
                        }
                        $("#cf-course-notes-add").val("");
                        $(".cf-course-lnotes").hide();
                        $("#cf-course-notes-times").show();
                        $("#cf-course-notes").prepend(res.data);
                        $(".cf--no-notea").html("");

                    }else if( res.type == "update" )
                    {
                        $( sbBtn ).html('update');
                        let peElm =$(tar).parents(".cf-cousre-not-con");
                        let helm = $(peElm).find(".cf-course-ncont");
                        let noteEl = $(helm).find(".cf-course-nt-c");
                        let celm = $(peElm).find(".cf-course-note-edit");
                        let textEl = $(celm).find(".cf-course-ed-notes");
                        $(noteEl).html( res.note );
                        $(textEl).html(res.notes_edit );
                        $(celm).hide();
                        $(helm).show();
                    }
                    $("#cf-course-notes-add").val(" ");
                }
                else if( res.status == 0 )
                { 
                    window.location=location.href;
                   
                }

            });
        }
    });

    $(".cf-course-all-notes").on("click", function( eve ){
        let tarElem = eve.target;

        // delete a notes
        if( $( tarElem ).hasClass("cf-course-del-notes") )
        {
            eve.preventDefault();
            let nid = $(tarElem).data("id");
            $("#cf-course-delete-note").val(nid);
            $("#mycf_course_drip_note_model").show();
        }

        // edit a notes
        else if( $( tarElem ).hasClass("cf-course-edit-notes") )
        {
            
            cfCourseGetForTinyResponsive();
            let parElem = $( tarElem ).parents(".cf-cousre-not-con");
            let hElem  = $(parElem).find(".cf-course-ncont");
            let oElem  = $(parElem).find(".cf-course-note-edit");
            $(hElem).hide();
            $(oElem).show();

        }
        // cancel edit or add
        else if( $(tarElem).hasClass("cf-course-ed-notes-cancel") )
        {
            let parElem = $(tarElem).parents(".cf-cousre-not-con");
            let hElem  = $(parElem).find(".cf-course-ncont");
            let oElem  = $(parElem).find(".cf-course-note-edit");
            $(oElem).hide();
            $(hElem).show();

        }
    });
    $("#cf-course-remove-notes").on( "click", function(eve){
        
        eve.preventDefault();
        let btn = $("#cf-course-remove-notes");
        let nid = $( "#cf-course-delete-note" ).val();
        $("#cf-course-snackbar").text("Note Deleted.");
        try{
            if( nid !="")
            {
                let postData= "action=cfcourse_add_notes&m_action=delete&nid="+nid;
                $( btn ).html('Deleting.. <span class=" spinner-border spinner-border-sm"></span>'); 
                $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){ 
                    $( btn ).html('Delete'); 
                    let  res  = $.parseJSON( response );
                    if( res.status ==1 )
                    { 
                        $( "#cf-course-notes-c-"+res.nid ).remove();
                        $("#cf-course-delete-note").val( "" );
                    }
                    else if( res.status == 0 )
                    { 
                        window.location=location.href;
                       
                    }
                    $("#mycf_course_drip_note_model").hide();
                    $("#cf-course-snackbar").addClass("cf-course-snackbar-show");
                    setTimeout(function(){ 
                        $("#cf-course-snackbar").text("Comment Deleted.");
                        $("#cf-course-snackbar").removeClass("cf-course-snackbar-show")
                     }, 3000);
                });
            }
        }
        catch(err)
        {   
            console.log(err.message);
            $("#mycf_course_drip_delete_model").hide();

        }

    });
    
    let cfCourseCurrentOpSy = $("#cf-course-current-os").val();
    let cfCourseOpSysArray  = ['iPhone','iPod','iPad','Android','BlackBerry','Mobile']; 


    if(cfCourseOpSysArray.includes(cfCourseCurrentOpSy))
    {
        $(document).on("input touchend",function(eve){
            
            let targ = eve.target;
            if($(targ).hasClass("cf--com-in-text"))
            {
                let childEl , parElem , removeEl;
                if($(targ).hasClass("cf-course-text-input"))
                {
                    childEl = $(targ).find(".cf--com-in-span2");
                    removeEl = $(targ).find(".c-f--com-reply-name");
                }else{
                    parElem =  $(targ).parents("cf-course-text-input");
                    childEl = $(parElem).find(".cf--com-in-span2");
                    removeEl = $(parElem).find(".c-f--com-reply-name");
                }
                let suerpel = $(targ).parents(".cf--c--c");
                let next = $(suerpel).next();
                let text = $(childEl).text();
                let btn = $(next).find(".cf--c--post-comment");
                text = text.trim();
                let parText = $(targ).text();
                parText = parText.trim();
                if( text.length === 0)
                {
                    $(removeEl).remove();
                }else{
                    // $(targ).html(" ");
                    btn.disabled=false;
                }
                if(parText.length>0)
                {  $(btn).addClass("cf--c--post-comment-active");
                    btn.disabled=false;
                    $(btn).prop('disabled', false);
    
                }else
                {  
                    btn.disabled=true;
                    $(btn).removeClass("cf--c--post-comment-active");
                    $(btn).prop('disabled', true);
                }    
            }
        });
    }else{
        $(document).on("keyup",function(eve){
            let targ = eve.target;;
            if($(targ).hasClass("cf--com-in-text"))
            {
                var cfCourseiCol = 0;
                if (eve.shiftKey) {
                    cfCourseiCol = 1;
                }
                var cfCourseCh = cfCourseKeyboardCharMap[eve.keyCode][cfCourseiCol];
                var key = eve.keyCode || eve.charCode;
                if (cfCourseCh!= "" ||  key == 8 || key == 46 ) {
                    let childEl , parElem , removeEl;
                    if($(targ).hasClass("cf-course-text-input"))
                    {
                        childEl = $(targ).find(".cf--com-in-span2");
                        removeEl = $(targ).find(".c-f--com-reply-name");
                    }else{
                        parElem =  $(targ).parents("cf-course-text-input");
                        childEl = $(parElem).find(".cf--com-in-span2");
                        removeEl = $(parElem).find(".c-f--com-reply-name");
                    }
                    let suerpel = $(targ).parents(".cf--c--c");
                    let next = $(suerpel).next();
                    let text = $(childEl).text();
                    let btn = $(next).find(".cf--c--post-comment");
                    text = text.trim();
                    let parText = $(targ).text();
                    parText = parText.trim();
                    if( text.length == 0)
                    {
                        $(removeEl).remove();
                    }else{
                        // $(targ).html(" ");
                        btn.disabled=false;
                    }
                    if(parText.length>0)
                    {  $(btn).addClass("cf--c--post-comment-active");
                        btn.disabled=false;
                        $(btn).prop('disabled', false);
        
                    }else
                    {  
                        btn.disabled=true;
                        $(btn).removeClass("cf--c--post-comment-active");
                        $(btn).prop('disabled', true);
                    }    
                }
            }
        });
    }
   
    // add a comment and also reply and edit
    $(".cf-course-dis-pn").on("submit", function( eve ){
        let tar = eve.target;
        if( $( tar ).hasClass("cf-course-add-comment") )
        {
            let pElm = $(tar).parents(".cf-course-dis-form");
            let prev = $(pElm).prev();
            let subBtn = $(tar).find(".cf--c--post-comment");
            eve.preventDefault();
            let comment_html = $(tar).find(".cf-course-text-input");
            let comment_text = $(tar).find(".cf-course-text-input").html();
            comment_text = comment_text.replace(/<div>/ig,"\r");
            comment_text = comment_text.replace(/<p>/ig,"\r");
            comment_text = comment_text.replace(/<\/p>/ig,"");
            comment_text = comment_text.replace(/<\/div>/ig,"");
            let comment_txt = encodeURIComponent(comment_text);
            let postData= "action=cfcourse_add_comment&"+$(tar).serialize()+"&comment="+comment_txt;
            $( subBtn ).html('Posting.. <span class=" spinner-border spinner-border-sm"></span>'); 
            $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){   
                let res  = $.parseJSON( response );
                if( res.status ==1 )
                {
                    $(prev).find(".c-f--com-reply-c").attr("data-afterpress","false");
                    if( res.type=="add" )
                    {
                       if(res.reply=="yes")
                       {
                        let comSec =  $("#cf-course-expand-reply-"+res.commId); 
                        $("#cf-coruse-com-expn-b-"+res.commId).show();
                        $(comSec).append(res.data);
                        $(pElm).remove();
                       }else if(res.reply=="no")
                       {
                        $(comment_html).html(" ");
                        let comSec =  $("#cf-course-to--comm-");
                        $(comSec).prepend(res.data);
                       }
                        cfCourseTimerCounterP++;
                        if( cfCourseTimerCounterP > 15 )
                        {
                            window.location=location.href;
                        }
                        $(".cf--no-comment").html("");
                    }else if( res.type == "update" )
                    {
                        $( "#cf-course-comment-text" ).html("");
                        var c = document.getElementById("cfCourse-context-menu");
                        if( $( c ).hasClass("cf--cc--ddshow") ){
                            $( c ).removeClass("cf--cc--ddshow").addClass("cf--cc--ddhide");
                        }
                        $( "#cf-course-cedit-text"+res.comid ).val( res.comment_edit );
                        $( "#cf-course-cdom-text"+res.comid ).html( res.comment );
                        $(pElm).remove();
                    }
                    $(subBtn).html("Post");
                    $(subBtn).removeClass("cf--c--post-comment-active");
                    subBtn.disabled=true;
                    $(subBtn).prop('disabled', true);
                }else{
                    window.location=location.href;
                }
            });
        }
    });

    // delete comment
    $("#cf-course-remove-comm").on( "click", function(eve){
        
        eve.preventDefault();
        let btn = $("#cf-course-remove-comm");
        let cid = $( "#cf-course-delete-comment" ).val();
        let vvalue = $( "#cf-course--nonce" ).val();
        try{
            if( cid !="")
            {
                var c = document.getElementById("cfCourse-context-menu");
                if( $( c ).hasClass("cf--cc--ddshow") ){
                    $( c ).removeClass("cf--cc--ddshow").addClass("cf--cc--ddhide");
                }
                let postData= "action=cfcourse_add_comment&param=delete&cid="+cid+"&cfc_comment_nonce="+vvalue;
                $( btn ).html('Deleting.. <span class=" spinner-border spinner-border-sm"></span>'); 
                $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){ 
                    $( btn ).html('Delete'); 
                    let  res  = $.parseJSON( response );
                    if( res.status ==1 )
                    { 
                        $( ".cf-course-cdel-"+res.cid ).remove();
                        $("#cf-course--opt--id").val( "" );
                    }
                    else{
                        window.location=location.href;
                    }
                    $( "#cf-course-delete-comment" ).val(" ");
                    $("#mycf_course_drip_delete_model").hide();
                    $("#cf-course-snackbar").addClass("cf-course-snackbar-show");
                    setTimeout(function(){ $("#cf-course-snackbar").removeClass("cf-course-snackbar-show") }, 3000);
                });
            }
        }
        catch(err)
        {   
            console.log(err.message);
            $("#mycf_course_drip_delete_model").hide();
        }
    });
    $(".cf-course-close-drip-btn").click(function(){
        $("#mycf_course_drip_delete_model").hide();
    });
     $(".cf-course-text-input").focus(function(){
        $(".cf-course-discus").css({
            "z-index":"999999",
            "min-height":"75%",
            "position":"relative",
            "bottom":"0"
        });       
    });
    $(".cf-course-text-input").focusout(function(){
        $(this).css("margin-top","0px");
        $(".cf-course-discus").css({
            "z-index":"0",
            "min-height":"auto",
            "position":"relative",
        });       
    });

    // edit comment
    $("#cf-course-edit-comment").on( "click", function(eve){
        eve.preventDefault();
        let commentId = $( "#cf-course--opt--id" ).val();
            let txt = $( "#cf-course--opt--value" ).val();
            $("#cf-course-cparam").val("update");
            $("#cf-course-com-id").val( commentId );
            let text = document.getElementById('cf-course-comment-text');
            $( text ).html(  txt+"&nbsp; " );
            text.focus();  // alternatively use setTimeout(() => { p.focus(); }, 0);
            // this is enough to focus an empty element (at least in Chrome)
            
            if (text.hasChildNodes()) {  // if the element is not empty
                let s = window.getSelection();
                let r = document.createRange();
                let e =text.childElementCount > 0 ? text.lastChild : text;  
                r.setStart(e, 1); 
                r.setEnd(e, 1);    
                s.removeAllRanges();
                s.addRange(r);
            } 
            $("#cf-course--opt--id").val( "" );
            $("#cf-course--opt--value").val( "" );
            var c = document.getElementById("cfCourse-context-menu");
            if( $( c ).hasClass("cf--cc--ddshow") ){
                $( c ).removeClass("cf--cc--ddshow").addClass("cf--cc--ddhide");
            }

    });
    $(".cf-course-dis-pn").click(function( eve ){
        let targ = eve.target;
        if( $( targ ).hasClass("c-f--com-reply-c") )
        {
           if($(targ).attr("data-afterpress")=="false")
           {
                $(targ).attr("data-afterpress","true");
                let parElem = $(targ).parents(".c-f--com-time");
                let sid = $("#cfcourse-section-enc--id").val();
                let mid = $("#cfcourse-member-enc--id").val();
                let oid = $("#cfcourse-option-enc--id").val();
                let cid = $("#cfcourse-course-enc--id").val();
                let curl = $("#cfcourse-course-url").val();
                let type = $("#cfcourse-course-type").val();
                let theme = $("#cfcourse-course-theme").val();
                let nonce = $("#cfcours-nonce--id").val();
                let pelm = $(targ).parents(".c-f--com-time");
                $(targ).toggleClass("waves-ripple waves-block waves-notransition");
                eve.preventDefault();
                let commentId = $(pelm).data("commentid");
                let name = $(targ).data("name");
                $("#cf-course-comment-text").html("");
                let reply_name =  "<span class='c-f--com-reply-name cf--com-in-text'><b class='c-f--d-did cf--com-in-text'>@"+name+"</b></span><span class='c-f--d-did cf--com-in-text cf--com-in-span2'>&nbsp; </span>"; 
                let htmlText=`<div class="cf-course-dis-form cf-course-dis-reply-form">
                                <form class="cf-course-add-comment">
                                    <input type="hidden" name="mid"   value="${mid}" />
                                    <input type="hidden" name="oid"   value="${oid}" />
                                    <input type="hidden" name="param" id="cf-course-cparam3" value="save" />
                                    <input type="hidden" name="comment_id" id="cf-course-com-id" value="${commentId}" />
                                    <input type="hidden" name="cf-course-sid"  value="${sid}" />
                                    <input type="hidden" name="cf-course-cid"  value="${cid}" />
                                    <input type="hidden" name="type"  value="${type}" />
                                    <input type="hidden" name="url"  value="${curl}" />
                                    <input type="hidden" name="theme"  value="${theme}" />
                                    <input type="hidden" name="reply" id="cf-course-reply"  value="yes" />
                                    <input type="hidden"  name="from"  value="u!^rr" />
                                    <input type="hidden" name="cfc_comment_nonce" id="cf-course--nonced"  value="${nonce}"  >
                                    <div class="cf--c--c">
                                        <div id="cf-course-comment-text-${commentId}" tabindex="0" data-placeholder="Add Comment" contenteditable class="cf-course-com-text cf--com-in-text cf-course-text-input" >${reply_name}</div>
                                            <span class="cf-course-focus-border"></span>
                                    </div>
                                    <div class="cf--c--s py-2 float-right" id="cf--cm--sbtn">
                                            <button type="button" class="cf--c--sb cf--c--cancel-reply btn-sm  d-inline-block" >Cancel</button>
                                            <button type="submit" class="cf--c--sb btn-sm cf--c--post-comment d-inline-block" >Post</button>
                                    </div>
                                </form>
                            </div>`;
                            
                         
               
                $(parElem).after(htmlText);
                let nextEle = $(parElem).next();
                let text = document.getElementById("cf-course-comment-text-"+commentId);

                $(text).focus();
                let nextChildEle = $(nextEle).find(".cf-course-focus-border");
                let nextsEhildEle = $(nextEle).find(".cf--c--s");
                $(nextChildEle).addClass("cf-course-increase-width");
                $(nextChildEle).css("width","100%");
                $(nextsEhildEle).css("visibility","visible");
                text.focus();
                if (typeof window.getSelection != "undefined"
                        && typeof document.createRange != "undefined") {
                    var range = document.createRange();
                    range.selectNodeContents(text);
                    range.collapse(false);
                    var sel = window.getSelection();
                    sel.removeAllRanges();
                    sel.addRange(range);
                } else if (typeof document.body.createTextRange != "undefined") {
                    var textRange = document.body.createTextRange();
                    textRange.moveToElementText(text);
                    textRange.collapse(false);
                    textRange.select();
                } 

           }else if($(targ).attr("data-afterpress")=="true")
           {   
                let parElem = $(targ).parents(".c-f--com-time");
                let nextEle = $(parElem).next();
              
                $(nextEle).find(".cf-course-focus-border").addClass("cf-course-increase-width").css("width","100%");
           }
        }else if( $( targ ).hasClass("cf-course-edit-comment") )
        {
            eve.preventDefault();
                let parElem = $(targ).parents(".cf--cc--ddc");
                let commentId = $(targ).data("id");
                let encid = $(targ).data("encid");
                let suPaEl = $(parElem).parents(".cf-course-cdel-"+encid);
                let childPaEl = $(suPaEl).find(".c-f--com-time-"+commentId);
                let sid = $("#cfcourse-section-enc--id").val();
                let mid = $("#cfcourse-member-enc--id").val();
                let oid = $("#cfcourse-option-enc--id").val();
                let cid = $("#cfcourse-course-enc--id").val();
                let nonce = $("#cfcours-nonce--id").val();
                let comment_edit = $(parElem).find(".cf-course-cd-text").val();
                $(targ).toggleClass("waves-ripple waves-block waves-notransition");
                let htmlText=`<div class="cf-course-dis-form cf-course-dis-reply-form">
                                <form class="cf-course-add-comment">
                                    <input type="hidden" name="mid"   value="${mid}" />
                                    <input type="hidden" name="oid"   value="${oid}" />
                                    <input type="hidden" name="param" id="cf-course-cparam2" value="update" />
                                    <input type="hidden" name="comment_id" id="cf-course-com-id" value="${commentId}" />
                                    <input type="hidden" name="cf-course-sid"  value="${sid}" />
                                    <input type="hidden" name="cf-course-cid"  value="${cid}" />
                                    <input type="hidden" name="reply" id="cf-course-reply"  value="no" />
                                    <input type="hidden"  name="from"  value="u!^rr" />
                                    <input type="hidden" name="cfc_comment_nonce" id="cf-course--nonce3"  value="${nonce}"  >
                                    <div class="cf--c--c">
                                        <div id="cf-course-comment-text-${commentId}" tabindex="0" data-placeholder="Add Comment" contenteditable class="cf-course-com-text cf--com-in-text cf-course-text-input" >${comment_edit} &nbsp;</div>
                                            <span class="cf-course-focus-border"></span>
                                    </div>
                                    <div class="cf--c--s py-2 float-right" id="cf--cm--sbtn">
                                            <button type="button" class="cf--c--sb btn-sm cf--c--cancel-reply  d-inline-block" >Cancel</button>
                                            <button type="submit" class="cf--c--sb btn-sm cf--c--post-comment d-inline-block" >Post</button>
                                    </div>
                                </form>
                            </div>`;
                $(childPaEl).after(htmlText);

                let nextEle = $(childPaEl).next();
                let text = document.getElementById("cf-course-comment-text-"+commentId);

                $(text).focus();
                let nextChildEle = $(nextEle).find(".cf-course-focus-border");
                let nextsEhildEle = $(nextEle).find(".cf--c--s");
                $(nextChildEle).addClass("cf-course-increase-width");
                $(nextChildEle).css("width","100%");
                $(nextsEhildEle).css("visibility","visible");
                text.focus();
                if (typeof window.getSelection != "undefined"
                        && typeof document.createRange != "undefined") {
                    var range = document.createRange();
                    range.selectNodeContents(text);
                    range.collapse(false);
                    var sel = window.getSelection();
                    sel.removeAllRanges();
                    sel.addRange(range);
                } else if (typeof document.body.createTextRange != "undefined") {
                    var textRange = document.body.createTextRange();
                    textRange.moveToElementText(text);
                    textRange.collapse(false);
                    textRange.select();
                }
        }else if( $( targ ).hasClass("cf-course-del-comment") )
        {
            let checks = $(targ).attr("data-check");
            let id = $(targ).attr("data-id");
            if(checks=="reply")
            {

                $("#cf-course-delete-he").text("Delete Reply");
                $("#cf-course-snackbar").text("Reply Deleted");
                $(".cf_course_drip_model-del-body").text("Are you sure to delete this reply permanently?");
            }else if(checks=="comment"){
                $("#cf-course-delete-he").text("Delete Comment");
                $("#cf-course-snackbar").text("Comment Deleted");
                $(".cf_course_drip_model-del-body").text("Are you sure to delete this comment permanently?");
            }
            $("#cf-course-delete-comment").val(id);
            checks="";
            $("#mycf_course_drip_delete_model").show();

        }
    });
    

    $(".cf-course-dis-pn").on("click",function( eve ){
        
        let tarElem = eve.target;
        
        if( $( tarElem ).hasClass("c-f--com-ac-el") )
        {
            let pElem, checks=""; 
            if( $(tarElem).prop("tagName")=="SPAN" )
            {
                pElem == $( tarElem).next(); 
            }else if( $(tarElem).prop("tagName")=="I" )
            {
                pElem = $(tarElem).parent().next();
            }
            if( $(pElem).data("check")=="comment")
            {
                checks="comment";
            }else if( $(pElem).data("check")=="reply")
            {
                checks="reply";
            
            }
            let commentId = $( pElem ).data("id");
            var c = document.getElementById("cfCourse-context-menu-"+commentId);
            if( ( typeof commentId == undefined && typeof txt == undefined ) || ( typeof commentId == "undefined" && typeof txt == "undefined" ) || ( commentId == "" &&  txt == "" )  )
            {
                $( c ).toggleClass("cf--cc--ddshow");
            }
            else
            {
                $( c ).toggleClass("cf--cc--ddshow");
                $( c ).find(".cf-course-del-comment").attr("data-check",checks).show();
            }

        }else if( $( tarElem ).hasClass("cf--c--cancel-comment") )
        {
            let _thisParent = $(tarElem).parents(".cf--c--s")
            $(_thisParent).css("visibility","hidden");

        }else if( $(tarElem).hasClass("cf-course-text-input") )
        {

            $(tarElem).parents(".cf--c--c").next().css("visibility","visible");
        }else if( $(tarElem).hasClass("cf--c--cancel-reply") )
        {

            let _thisParent = $(tarElem).parents(".cf-course-dis-form")
            let prevEle   = ( _thisParent ).prev();
            let preChidlEle = $(prevEle).find(".c-f--com-reply-c");

            $(preChidlEle).attr("data-afterpress","false");
            $(_thisParent).remove();
        }else{
            $(".cf--cc--ddc").removeClass("cf--cc--ddshow");
        }

    });

    $( document ).bind("click", function(event) {
        var c = document.getElementById("cfCourse-context-menu");
        if( $( c ).hasClass("cf--cc--ddshow") ){
            $( c ).removeClass("cf--cc--ddshow").addClass("cf--cc--ddhide");
        }
    });

    let cfCourseVideoDuration = $("#cf-course--msl--video");
    let cfCourseVideoAfter5    = $( cfCourseVideoDuration ).data("duration");
    let cfCoursepreventMultiple=0;
    $("#cf-course-mlec-video").on("timeupdate", function(){
        let allCon = $("#cf-course--msl--video");
        let oid    = $( allCon ).data("oid");
        let sid    = $( allCon ).data("sid");
        let type   = "lecture";
        let cid    = $( allCon ).data("cid");
        let mid    = $( allCon ).data("mid");
        let timer = Math.floor( this.currentTime );
        let cfviduration = Math.floor( this.duration ); 
        let cfvidurationles = cfviduration-10;
        
        if( timer >= cfvidurationles && timer <= cfviduration && cfCoursepreventMultiple==0 )
        {
            cfCoursepreventMultiple++;
            cfCourseAddProgress( cid, sid, oid, mid, 1  );
        }
        if( timer == cfCourseVideoAfter5 )
        {

            cfCourseStartVideoFrom( cfCourseVideoAfter5,mid, cid, sid, oid, "update" , type );
            cfCourseVideoAfter5 = cfCourseVideoAfter5 + 10;
        }

        let times = cfCourseGetVideoTime( timer ) ;
        $(".cf-course-notes-times").text(times);
    });


    let cfCourseStopSettimeout;
    $("#cf-course-mlec-video").on("ended",function()
    {
        let parEl = $(this).parents(".cf-course-show-lect");
        $(parEl).hide();
        $("#cf-course-next-open-rating").show();
        let rating_status  = $("#cfcours-urating-status").val();

        if(rating_status.trim()=="no")
        {
            $("#cf-course-next-open-rating").show();

        }else if(rating_status.trim()=="yes"){
            $("#cf-course-next-open").show();
            let par=100;
            $('.cf-course-second-cancel.cf-course-circle-cancel').circleProgress({
                startAngle: -Math.PI / 4 *10,
                value: par/100,
                thickness:5,
                delay:9000,
                emptyFill: '#918e8e',
                fill: { color: "#ffffff" },
                animation: {
                    duration: 4000
                    }
                }).on('circle-animation-progress', function(event, progress) {
                    progress=progress-3;
                    let strg = $( this ).find('strong');      
                    let oid  = $( strg ).data("oid");
                    let sid  = $( strg ).data("sid");
                    let type = $( strg ).data("type");
                    let cid  = $( strg ).data("cid");
                    let mid  = $( strg ).data("mid");
                    let count= $( strg ).data("count");
                    $(strg).html('<a href="javascript:void(0)" class="text-white  data-type="'+type+'"  data-mid="'+mid+'" data-sid="'+sid+'"  data-oid="'+oid+'" data-cid="'+cid+'"  ><i class="fa fa-step-forward "></i></a>');
                
            });
            let video= $(".cf-course--st-cnext");
            let oid  = $( video ).data("oid");
            let sid  = $( video ).data("sid");
            let type = $( video ).data("type");
            let cid  = $( video ).data("cid");
            let mid  = $( video ).data("mid");
            cfCourseStopSettimeout=setTimeout(function(){
                cfCourseAddProgress( cid, sid, oid, mid, 1  );
                cfCourseStartVideoFrom( 0, mid, cid, sid, oid, "save" , type);
            },4000);
        }
});
    

$("#cf-course-cancel-next").click(function(){
    window.location=location.href;
});
    $("#cf-course-mlec-video").on("seeked", function(){
        let  timer  = Math.floor( this.currentTime );
        cfCourseVideoAfter5  = timer;
    });

    $("#cf-course-notes-times").on("click" ,function(){

        let timer = $(this).find(".cf-course-notes-times").text();
        $(".cf-course-l-ntime").val(timer);
        $(".cf-course-notes-ti").text(timer);
        $(this).hide();
        $(".cf-course-lnotes").show();
    });

    $("#cf-course-notes-cancel").on("click", function(){
        $(".cf-course-lnotes").hide();
        $("#cf-course-notes-times").show();
    });

    let cfCourseTotalLec = $("#cf-course-total_lecture").val();
    let cfCourseTotalLecCounts = $("#cf-course-progers_count").val();
    let cfCoursePrgrs = Math.floor( ( cfCourseTotalLecCounts/cfCourseTotalLec )*100 );

    
    processComplitionCertificate(cfCoursePrgrs);

    $('.cf-course-second.cf-course-circle').circleProgress({
        startAngle: -Math.PI / 4 *10,
        value: cfCoursePrgrs/100,
        thickness:12,
      }).on('circle-animation-progress', function(event, progress) {
        $( this ).find('strong').html( cfCoursePrgrs + '<i>%</i>');        

    });

    $("#cfCourseAddRating-non").submit(function( eve){
        eve.preventDefault();
        let postData= "action=cfcourse_add_rating&"+$(this).serialize();
        $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){ 
            $(".cf-course-middle-rating").hide();
            $("#mycf_course_rating-model").hide();
            $("#cfCourseAddRating-non").trigger("reset");
        });
    });

    $("#cfCourseAddRating").submit(function(eve ){
        eve.preventDefault();
        if($(eve.target).hasClass("cf-course-submit-rating"))
        {
            let postData= "action=cfcourse_add_rating&"+$(this).serialize();
            $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){    
                $("#cf-course-next-open-rating").hide();
                $("#cf-course-rating-us").show();
                $("#cf-course-next-open").show();
    
                let par=100;
                $('.cf-course-second-cancel.cf-course-circle-cancel').circleProgress({
                    startAngle: -Math.PI / 4 *10,
                    value: par/100,
                    thickness:5,
                    delay:9000,
                    emptyFill: '#918e8e',
                    fill: { color: "#ffffff" },
                    animation: {
                        duration: 4000
                      }
                  }).on('circle-animation-progress', function(event, progress) {
                      progress=progress-3;
                
                   let strg = $( this ).find('strong');      
                   let oid  = $( strg ).data("oid");
                   let sid  = $( strg ).data("sid");
                   let type = $( strg ).data("type");
                   let cid  = $( strg ).data("cid");
                   let mid  = $( strg ).data("mid");
                   let count= $( strg ).data("count");
                  
                   $(strg).html('<a href="javascript:void(0)" class="text-white  data-type="'+type+'"  data-mid="'+mid+'" data-sid="'+sid+'"  data-oid="'+oid+'" data-cid="'+cid+'" ><i class="fa fa-step-forward "></i></a>');
                
                   
                   
                });
                let video= $(".cf-course--st-cnext");
                let oid  = $( video ).data("oid");
                let sid  = $( video ).data("sid");
                let type = $( video ).data("type");
                let cid  = $( video ).data("cid");
                let mid  = $( video ).data("mid");
                cfCourseStopSettimeout=setTimeout(function(){
                    cfCourseAddProgress( cid, sid, oid, mid, 1  );
                    cfCourseStartVideoFrom( 0, mid, cid, sid, oid, "save" , type );
                },4000);
    
              });

        }

      });
$("#cf-course-cancel-rating").click(function(){
    $("#cf-course-rating-us").hide();
    $("#cf-course-next-open-rating").hide();
    $("#cf-course-next-open").show();
    let par=100;
    $('.cf-course-second-cancel.cf-course-circle-cancel').circleProgress({
        startAngle: -Math.PI / 4 *10,
        value: par/100,
        thickness:5,
        delay:9000,
        emptyFill: '#918e8e',
        fill: { color: "#ffffff" },
        animation: {
            duration: 4000
            }
        }).on('circle-animation-progress', function(event, progress) {
            progress=progress-3;
            let strg = $( this ).find('strong');      
            let oid  = $( strg ).data("oid");
            let sid  = $( strg ).data("sid");
            let type = $( strg ).data("type");
            let cid  = $( strg ).data("cid");
            let mid  = $( strg ).data("mid");
            let count= $( strg ).data("count");
            $(strg).html('<a href="javascript:void(0)" class="text-white  data-type="'+type+'"  data-mid="'+mid+'" data-sid="'+sid+'"  data-oid="'+oid+'" data-cid="'+cid+'" ><i class="fa fa-step-forward "></i></a>');
        
    });
    let video= $(".cf-course--st-cnext");
    let oid  = $( video ).data("oid");
    let sid  = $( video ).data("sid");
    let type = $( video ).data("type");
    let cid  = $( video ).data("cid");
    let mid  = $( video ).data("mid");
    cfCourseStopSettimeout=setTimeout(function(){
        cfCourseAddProgress( cid, sid, oid, mid, 1  );
        cfCourseStartVideoFrom( 0, mid, cid, sid, oid, "save" , type );
    },4000);
});
   



    $(".cf-course--ci-vid").on("click", function(eve){
        eve.preventDefault();

        if( $(this).hasClass("cf-course--ci-vidblock") )
        {
            $("#cf-course-msr-c").css("width","0");
            $("#cf-course-msr-c").hide();
            $("#cf-course-msl-c").css("width","100%");
            var appendDiv = $("#cf-course-msr-s-mm");
            var mbDiv = $("#cf-course-mr-mobs-c");
            $(mbDiv).append($(appendDiv));
            $(".cf-course-tab-a").removeClass("cf-course-active-a");
            $(".cfcourse-tabs").removeClass("cf-course-tab-active");
            $("#cf-course-msl-f-tabs").addClass("cf-course-tab-active");
            $("#cf-course-msl-ft-btn").addClass("cf-course-active-a");
            $("#cf-course-msl-ft-btn").css("display","inline-block");
            $(".cf-course--ci-vidblock").hide();
            $(".cf-course--ci-vidnone").css("display","inline-block");
        }
        else if( $(this).hasClass("cf-course--ci-vidnone") )
        {
            $("#cf-course-msr-c").css("width","32%");
            $("#cf-course-msr-c").show();
            $("#cf-course-msl-c").css("width","68%");
            // $(".cf-course-ml-cs").css("height","500px");
            var appendDiv = $("#cf-course-msr-s-mm");
            var mbDiv = $("#cf-course-mr-pcl-c");
            $(mbDiv).append($(appendDiv));
            $(".cf-course-tab-a").removeClass("cf-course-active-a");
            $(".cfcourse-tabs").removeClass("cf-course-tab-active");
            $("#cf-course-msl-st-btn a").addClass("cf-course-active-a");
            $("#cf-course-msl-st-btn").css("display","inline-block");
            $("#cf-course-msl-s-tabs").addClass("cf-course-tab-active");
            $("#cf-course-msl-ft-btn").css("display","none");
            $(".cf-course--ci-vidblock").css("display","inline-block");
            $(".cf-course--ci-vidnone").hide();
        }
    });
    $(window).scroll(function () {
        //if you hard code, then use console
        //.log to determine when you want the 
        //nav bar to stick.  
        let h = parseInt($(".cf-course-ms-head").css("height"))+2;
        let nextEle = $("#cf-course-this-end").next();
        if( nextEle == undefined )
        {
            if ($(window).scrollTop() > h) {
                $('#cf-course-msr-c').addClass('cf-course-sticky-sec');
              }
              if ($(window).scrollTop() < h) {
                $('#cf-course-msr-c').removeClass('cf-course-sticky-sec');
              }
              $("#cf-course-mr-sec-con").css({"height":"100vh","overflow-y":"auto"});

        }else{
            $("#cf-course-mr-sec-con").css({"height":"auto","overflow":"visible"});
        }
    });
    $( "#cf-course-comments-con" ).on("click",function(eve){
        let target = eve.target;
        if( $( target ).hasClass( "cf-coruse-com-expn-b" ) )
        {
            let ele, aEle;
            if( $(target).prop("tagName")=="A" )
            {
                ele  = $(target);
                aEle = $(ele).find(".fas");
            }else if( $(target).prop("tagName")=="I" )
            {
                aEle = $(target);
            }
          
            if( $( aEle ).hasClass("fa-caret-down") )
            {
                $(aEle).removeClass("fa-caret-down").addClass("fa-caret-up");

            }else{
                $(aEle).removeClass("fa-caret-up").addClass("fa-caret-down");
            }
        }else if(  $( target ).hasClass( "c-f--com-like" ) )
        {
            let ele, pelm,param;
            if( $(target).prop("tagName")=="A" )
            {
                ele  = $(target);
                pelm= $(ele).parents(".c-f--com-time");
            }else if( $(target).prop("tagName")=="I" || $(target).prop("tagName")=="SPAN" )
            {
                ele  = $(target).parents("a.c-f--com-like");
                pelm= $(ele).parents(".c-f--com-time");
            }
            if( $(ele).attr("like-status")==true || $(ele).hasClass("text-primary")==true )
            {
                param="update";

            }
            else if( $(ele).attr("like-status")==false || $(ele).hasClass("text-primary")==false )
            {
                param="add";
                
            }
            // $(ele).toggleClass("text-primary");
            let cid = $(pelm).attr("id");
            let mid = $(pelm).data("memid");
            let oid = $(pelm).data("oid");
            let postData= "action=cfcourse_add_comment_like&param="+param+"&cid="+cid+"&mid="+mid+"&oid="+oid;
            $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){    
                let  res  = $.parseJSON( response );
                let likesCount=  $(pelm).find(".c-f--com-like-cout-span");
                let dislike = $(pelm).find(".c-f--com-dislike");
                let dislikeCount = $(pelm).find(".c-f--com-dislike-cout-span");
                if( res.status == 1 )
                { 
                    $(ele).removeClass("text-primary");
                    $(ele).attr("like-status","false");
                    $(likesCount).text(res.total_like);
                   
                }else if( res.status == 2 )
                { 
                    $(ele).addClass("text-primary");
                    $(ele).attr("like-status","true");
                    $(likesCount).text(res.total_like);
                    $(dislike).removeClass("text-primary").attr("dislike-status","false");
                    $(dislikeCount).text(res.total_dislike);
                   
                }
                else if( res.status == 3 )
                { 
                    $(ele).addClass("text-primary");
                    $(ele).attr("like-status","true");
                    $(likesCount).text(res.total_like);
                   
                }
                else if( res.status == 0 )
                { 
                    window.location=location.href;
                   
                }
            });

        }
        else if(  $( target ).hasClass( "c-f--com-dislike" ) )
        {
            let ele, pelm,param;
            if( $(target).prop("tagName")=="A" )
            {
                ele  = $(target);
                pelm= $(ele).parents(".c-f--com-time");
            }else if( $(target).prop("tagName")=="I" || $(target).prop("tagName")=="SPAN" )
            {
                ele  = $(target).parents("a.c-f--com-dislike");
                pelm= $(ele).parents(".c-f--com-time");
            }

            if( $(ele).attr("dislike-status")==true || $(ele).hasClass("text-primary")==true )
            {
                param="update";

            }
            else if( $(ele).attr("dislike-status")==false || $(ele).hasClass("text-primary")==false )
            {
                param="add";
                
            }
            // $(ele).toggleClass("text-primary");
            let cid = $(pelm).attr("id");
            let mid = $(pelm).data("memid");
            let oid = $(pelm).data("oid");
            let postData= "action=cfcourse_add_comment_dislike&param="+param+"&cid="+cid+"&mid="+mid+"&oid="+oid;
            $.post( $("#cfcourse-user-ajax").val() , postData, function( response ){    
                let  res  = $.parseJSON( response );
                let dislikesCount=  $(pelm).find(".c-f--com-dislike-cout-span");
                let likes = $(pelm).find(".c-f--com-like");
                let likeCount = $(pelm).find(".c-f--com-like-cout-span");
                if( res.status == 1 )
                { 
                    $(ele).removeClass("text-primary");
                    $(ele).attr("dislike-status","false");
                    $(dislikesCount).text(res.total_dislike);
                   
                }else if( res.status == 2 )
                { 
                    $(ele).addClass("text-primary");
                    $(ele).attr("dislike-status","true");
                    $(dislikesCount).text(res.total_dislike);
                    $(likes).removeClass("text-primary").attr("like-status","false");
                    $(likeCount).text(res.total_like);
                   
                }
                else if( res.status == 3 )
                { 
                    $(ele).addClass("text-primary");
                    $(ele).attr("dislike-status","true");
                    $(dislikesCount).text(res.total_dislike);
                   
                }
                else if( res.status == 0 )
                { 
                    window.location=location.href;
                   
                }
            });
        }

    });
    $(".cf-course--fu-vidblock").on("click", function(eve){
        eve.preventDefault();
        var documentelem = $("#cf-course-content-play-s").get(0);

        if (documentelem.requestFullscreen) {
            documentelem.requestFullscreen();
        } else if (documentelem.webkitRequestFullscreen) { /* Safari */
            documentelem.webkitRequestFullscreen();
        } else if (documentelem.msRequestFullscreen) { /* IE11 */
            documentelem.msRequestFullscreen();
        }
        $("#cf-course-ml-all--video").addClass("cf-course-increase-height");
        $(".cf-course-ml-cs").addClass("cf-course-increase-height");
        $(".cf-course--fu-vidblock").hide();
        $(".cf-course--fu-vidnone").css("display","inline-block");

    });
    $(".cf-course--fu-vidnone").on("click", function(eve){
        eve.preventDefault();
        if (document.exitFullscreen) {
            document.exitFullscreen();
        } else if (document.webkitExitFullscreen) { /* Safari */
            document.webkitExitFullscreen();
        } else if (document.msExitFullscreen) { /* IE11 */
            document.msExitFullscreen();
        }
        $("#cf-course-ml-all--video").removeClass("cf-course-increase-height");
        $(".cf-course-ml-cs").removeClass("cf-course-increase-height");
        $(".cf-course--fu-vidblock").css("display","inline-block");
        $(".cf-course--fu-vidnone").hide();
    });
});

function cfCourseAddProgress( c_id, s_id, op_id, m_id, watc  )
{

        let xhttp=new XMLHttpRequest();
        xhttp.onreadystatechange=function(){
            if( this.readyState==4 && this.status==200 ){
               // console.log(this.responseText);
                try{
                    if( this.responseText1 !=="" )
                    {
                        let  res  = $.parseJSON( this.responseText );
                        if( res.status ==1 )
                        {
                            $("#cf-course-slec-count-"+s_id).text(res.counts);
                            let TotalLec = parseInt($("#cf-course-total_lecture").val());
                            let TotalLecCounts = parseInt($("#cf-course-progers_count").val());
                            
                            if( res.type=="add" )
                            {
                                let TotalLecCount= TotalLecCounts+ 1;
                                $("#cf-course-progers_count").val(TotalLecCount);
                                let Prgrs = Math.floor( ( TotalLecCount/TotalLec )*100 );

                                processComplitionCertificate(Prgrs);

                                $('.cf-course-second.cf-course-circle').circleProgress({
                                    startAngle: -Math.PI / 4 *10,
                                    value: Prgrs/100,
                                    thickness:12,
                                }).on('circle-animation-progress', function(event, progress) {
                                    //:cirt
                                    $( this ).find('strong').html( Prgrs + '<i>%</i>');        
                                });
                                let prElem = $("#cf-coursse-user-progress");
                                if(prElem != undefined)
                                {
                                    $(prElem).css("width",Prgrs+"%");
                                    $("#cf-course-a-mem-p").text(TotalLecCount);
                                    $(".cf-course-memebr-progress").text(TotalLecCount);

                                }
                                $("#cf-course-sl-checkbox-"+op_id).prop("checked",true);
                            }else if( res.type=="up" ){
                                let TotalLecCount= TotalLecCounts- 1;
                                $("#cf-course-progers_count").val(TotalLecCount);
                                let Prgrs = Math.floor( ( TotalLecCount/TotalLec )*100 );
                                processComplitionCertificate(Prgrs);
                                $('.cf-course-second.cf-course-circle').circleProgress({
                                    startAngle: -Math.PI / 4 *10,
                                    value: Prgrs/100,
                                    thickness:12,
                                }).on('circle-animation-progress', function(event, progress) {
                            
                                    $( this ).find('strong').html( Prgrs + '<i>%</i>');        
                            
                                });
                                let prElem = $("#cf-coursse-user-progress");
                                if(prElem != undefined)
                                {
                                    $(prElem).css("width",Prgrs+"%");
                                    $("#cf-course-a-mem-p").text(TotalLecCount);
                                    $(".cf-course-memebr-progress").text(TotalLecCount);

                                }
                            }         
                        }
                        else if( res.status == 0 )
                        { 
                            window.location=location.href;
                        }
                    }
               }catch(err){

               }
            }else{
                // console.info("You are a admin. please first logout");
            }
        }
        
        let postData= "action=cfcourse_add_progress&c_id="+c_id+"&s_id="+s_id+"&op_id="+op_id+"&watc="+watc+"&m_id="+m_id;
        xhttp.open( "POST", $("#cfcourse-user-ajax").val(), true );
        xhttp.setRequestHeader("Access-Control-Allow-Origin", "*");
        xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xhttp.setRequestHeader('cache-control', 'no-cache, must-revalidate, post-check=0, pre-check=0');
        xhttp.setRequestHeader('cache-control', 'max-age=0');
        xhttp.setRequestHeader('pragma', 'no-cache');
        xhttp.send( postData );
}



function cfCourseMouseX(evt) {
    if (evt.pageX) {
      return evt.pageX;
    } else if (evt.clientX) {
      return evt.clientX + (document.documentElement.scrollLeft ?
        document.documentElement.scrollLeft :
        document.body.scrollLeft);
    } else {
      return null;
    }
  }
  
  function cfCourseMouseY(evt) {
    if (evt.pageY) {
      return evt.pageY;
    } else if (evt.clientY) {
      return evt.clientY + (document.documentElement.scrollTop ?
        document.documentElement.scrollTop :
        document.body.scrollTop);
    } else {
      return null;
    }
  }

function cfCourseStartVideoFrom( duration, mid, course_id, section_id, option_id, param, type="")
{

    let xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if ( this.readyState == 4 && this.status == 200 ) {
            // first add the video duration in database after adding refresh the page
            if( this.responseText !="" )
            {
                   try{
                    let res = JSON.parse( this.responseText );
                    if( res.status == 1 && res.type == "add" )
                    {
                            
                        if( res.action =="yes" ){
                            history.pushState( {}, "", "?cf_vid="+res.data );
                            window.location = location.href;

                        }else if( res.action == "no" ){
                            $("#cf-course--d-ys").text( res.drip_days+" days" );
                            $("#mycf_course_drip_model").show();
                        }
                    }else if( res.status == 1 && res.type =="update" )
                    {
                        if( res.action=="no" )
                        {
                            $("#cf-course--d-ys").text( res.drip_days+" days" );
                            $("#mycf_course_drip_model").show();
                        }
                        // window.location = location.href;
                        // just udpate the  video duration data or kuchh ye condiiton karti nhi he
                    }
                    else if( res.status == 0 )
                    { 
                        window.location=location.href;          
                    }
                }catch(err){

                }
            }else{
                console.info("You are a admin. please first logout");
            }
        }
    };
    let postData = "action=cfcourse_add_video_time&oid="+option_id+"&param="+param+"&type="+type+"&sid="+section_id+"&cid="+course_id+"&duration="+duration+"&mid="+mid+"&person=s";
    xhttp.open( "POST", $("#cfcourse-user-ajax").val(), true );
    xhttp.setRequestHeader( "Content-type", "application/x-www-form-urlencoded" );

    xhttp.send( postData );
}
function cfCourseTotalWatched( course_id = 0 )
{

    let xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if ( this.readyState == 4 && this.status == 200 ) {
        }
    };
    let postData = "action=cfcourse_total_video_time&cid="+course_id
    xhttp.open( "POST", $("#cfcourse-user-ajax").val(), true );
    xhttp.setRequestHeader( "Content-type", "application/x-www-form-urlencoded" );
    xhttp.send( postData );
}

function cfCourseGetVideoTime( timer =1 )
{
    let  hour=0, minute=0, seconds=0;
            if( timer >= 3600 )
            {
                hour       = Math.floor( timer/3600 );
                timer      = Math.floor( timer%3600 );
                if( timer < 10 )
                {
                    hour = "0"+hour;

                }else{
                    hour = hour;
                }
            }
            else if( timer >= 60 )
            {
                minute = Math.floor( timer/60 );
                timer      = Math.floor( timer%60 );
                if( timer < 10 )
                {
                    minute = "0"+minute;

                }else{
                    minute = minute;
                }   
            }
            if( timer < 10 )
            {
                seconds = "0"+Math.floor(timer);

            }else{
                seconds = Math.floor(timer);
            }
        return  hour +":"+minute+":"+seconds;
}
function cfCourseGetPCHTML() {
    
    var appendDiv = document.getElementById("cf-course-msr-s-mm");
    var pcDiv = document.getElementById("cf-course-mr-pcl-c");
    var mbDiv = document.getElementById("cf-course-mr-mobs-c");
    if ( window.matchMedia("screen and (max-width: 500px)").matches ){
        cfCourseShowContentTab();
        var repDiv = document.getElementById("cf-course-msr-s-mm");
        if( repDiv == "undefined" || repDiv == undefined || repDiv == "" )
        {
            // console.log(repDiv);
            mbDiv.appendChild( appendDiv ); 

        }else{
            mbDiv.replaceChild( appendDiv, appendDiv ); 
        }
    }
    else if ( window.matchMedia("screen and ( min-width: 500px) and (max-width: 1024px)").matches ){
        cfCourseShowContentTab();
        var repDiv = document.getElementById("cf-course-msr-s-mm");
        if( repDiv == "undefined" || repDiv == undefined || repDiv == "" )
        {
            mbDiv.appendChild( appendDiv ); 

        }else{
            mbDiv.replaceChild( appendDiv, appendDiv ); 
        }
    }
    else if ( window.matchMedia("screen and ( min-width: 1024px) ").matches ){;
        
        if(pcDiv!=undefined)
        {
            pcDiv.appendChild( appendDiv ); 
            $(".cf-course-msrs-lc[tabindex='-1']").focus();
            $(".cf-course-msrs-lc[tabindex='-1']").animate({
                scrollTop: $(".cf-course-msrs-lc[tabindex='-1']").scrollHeight - $(".cf-course-msrs-lc[tabindex='-1']").clientHeight
              }, 1000);
        }
        cfCourseShowOverviewTab();
    }

}

function cfCourseGetForTinyResponsive() {

    // if ( window.matchMedia("screen and ( min-width: 768px) ").matches ){
    //     cfCourseTinyEditorAssignment(".cfcourse_assign_answer",250);
    //     cfCourseTinyEditorAssignment(".cfcourse_assign_answer_ro",250,1);
    // }

}

function cfCourseShowContentTab()
{
    let openTaba = document.querySelectorAll(".cfcourse-tabs");
    for( let i=0; i < openTaba.length; i++ )
    {
        openTaba[i].classList.remove("cf-course-tab-active");
    }
    let openTab = document.querySelectorAll(".cf-course-tab-a");
    for( let i=0; i < openTab.length; i++ )
    {
        openTab[i].classList.remove("cf-course-active-a");
    }

    let firstTab = document.getElementById("cf-course-msl-ft-btn");
    let firstTabC = document.getElementById("cf-course-msl-f-tabs");
    firstTab.classList.add("cf-course-active-a");
    firstTabC.classList.add("cf-course-tab-active");

}
function cfCourseShowOverviewTab()
{
        let openTaba = document.querySelectorAll(".cfcourse-tabs");
        for( let i=0; i < openTaba.length; i++ )
        {
            openTaba[i].classList.remove("cf-course-tab-active");
        }
        let openTab = document.querySelectorAll(".cf-course-tab-a");
        for( let i=0; i < openTab.length; i++ )
        {
            openTab[i].classList.remove("cf-course-active-a");
        }
        let firstTab = document.getElementById("cf-course-second-t");
        let firstTabC = document.getElementById("cf-course-msl-s-tabs");
        firstTab.classList.add("cf-course-active-a");
        firstTabC.classList.add("cf-course-tab-active");

}

function cfCourseGetVideoStatus()
{
    let video = document.getElementById("cf-course-mlec-video");
    if(  video!=null  )
    {
        let cid = video.getAttribute("data-cid");
        let setIn;
        // if video status is changed to "playing", then change control button to "Stop"
        video.onplaying = function() {
        setIn = setInterval(function(){
            cfCourseTotalWatched(cid);
            },10000);
        };
        video.onended = function() {
            clearInterval(setIn);
        };
        
        // if video status is changed to "paused", then change control button to "Continue Play"
        video.onpause = function() {
            clearInterval(setIn);
        };
    }
    
}
function processComplitionCertificate(p, init= false)
{
    try
    {
        let showFinalCirt= parseInt($("#cfcourse-show-completion-cert").val());
        let btn= $(".cf-cirt-download button");
        if(showFinalCirt)
        {
            p= parseInt(p);
            let disabled= true;
            if(p===100)
            {
                let da = cfCourseGetBroswerDate();
                disabled= false;
                btn.attr({disabled: true});
                btn.on('click', function(){
                let form= $('form');
                form.attr({method: 'POST', action: "",class:"cf-course-certificate-form",id:"cf-course-certificate-form"});
                let inp= $('input').attr({type: 'hidden', name: 'export_cert_for_completion', value: da});
                form.append(inp);
                form.submit();
                });
            }
            btn.attr({disabled});
        }
        else
        {
            btn.hide();
        }
    }catch(err)
    {console.log(err);}
}
