<?php
//This controller will deal with the front end working of the client / or students 
if(!class_exists('CFCourse_course_control'))
{
    class CFCourse_course_control
    {
        function __construct($arr)
        {
            $this->loader=$arr['loader'];
        }
        public function getCourseCategory($c="")
        {
            $ca="";
            if(empty($c))
            {
                $c="Not Selected";
            }
            switch($c)
            {
                case "bus":
                    $ca="Business";
                    break;
                case "des":
                    $ca="Design";
                    break;
                case "dev":
                    $ca="Development";
                    break;
                case "ent":
                    $ca="Entertainment and Music";
                    break;
                case "edu":
                    $ca="Education";
                    break;
                case "fin":
                    $ca="Finance and Accounting";
                    break;
                case "hea":
                    $ca="Health and Fitness";
                    break;
                case "its":
                    $ca="IT and Software";
                    break;
                case "lan":
                    $ca="Language Learning";
                    break;
                case "lif":
                    $ca="Lifestyle";
                    break;
                case "mar":
                    $ca="Marketing";
                    break;
                case "off":
                    $ca="Office Productivity";
                    break;
                case "per":
                    $ca="Personal Development";
                    break;
                case "pav":
                    $ca="Photography and Video";
                    break;
                case "sam":
                    $ca="Science and Mathematics";
                    break;
                default:
                    $ca=$c;
                    
            }
            return $ca;

        }
        //shortcode function to view single courses by id
        function get_course_by_id( $course_id,$get_only=false )
        {
            global $mysqli;
            global $dbpref;
            $table=$dbpref.'all_products';

            $course_id = trim( $mysqli->real_escape_string( $course_id ) );

             if($get_only)
             {
                $r = $mysqli->query("SELECT `".$get_only."` FROM `".$table."` WHERE `id`=".$course_id );
             }else{
                $r = $mysqli->query("SELECT * FROM `".$table."` WHERE `id`=".$course_id );
             }

             if( $r->num_rows > 0)
             {
                $data = $r->fetch_assoc();

                return $data;
              
             }
             return false;
        }

        //shortcode function to view all courses together. 
        function get_all_courses( $get=false,$course_id=false)
        {
            global $mysqli;
            global $dbpref;
            $table=$dbpref.'all_products';
            if($get)
            {
                $qry = $mysqli->query("SELECT * FROM `".$table."` WHERE `id`=".$course_id );
            }else{
                $qry = $mysqli->query("SELECT * FROM `".$table."`" );
            }
            if(isset($qry->num_rows))
            {
            if($qry->num_rows)
            {
            return $qry;
            }
            return 0;
            }
        }
        

        //function to view single quiz by id
        function get_quiz_by_id( $quiz_id )
        {
            global $mysqli;
            global $dbpref;
            $table=$dbpref.'content_options';
            $quiz_id = trim( $mysqli->real_escape_string( $quiz_id ) );
             $r = $mysqli->query("SELECT * FROM `".$table."` WHERE `id`=".$quiz_id );
             if( $r->num_rows > 0)
             {
                $data = $r->fetch_assoc();
                return $data;
             }
        }
        
        //function to view quiz questions.. 
        function get_quiz_questions_by_id( $quiz_id )
        {
            global $mysqli;
            global $dbpref;
            
            $table=$dbpref.'quiz_questions';

            $quiz_id = trim( $mysqli->real_escape_string( $quiz_id ) );

            $qry = $mysqli->query("SELECT * FROM `".$table."` WHERE `quiz_id`=".$quiz_id );

            if(isset($qry->num_rows))
            {
                return $qry;
            }
        }
        //function to view quiz questions.. 
        function checkAlreadyplayedQuizAssign( $qu_or_ass_id,$mem_id ,$action=false)
        {
            global $mysqli;
            global $dbpref;
           
            $mem_id = trim( $mysqli->real_escape_string( $mem_id ) );
            $quiz_ob= $this->loader->load("quiz_stud_control");

            $mem_data = $quiz_ob->checkIfIsAdmin($mem_id);
            $mid = $mem_data['mid'];
            if( $action == "a" )
            {
                $table=$dbpref.'stud_assignment';
                $qu_or_ass_id = trim( $mysqli->real_escape_string( $qu_or_ass_id ) );
                $qry = $mysqli->query("SELECT * FROM `".$table."` WHERE `assign_id`=$qu_or_ass_id AND `member_id`=$mid ORDER BY `submitted_on` DESC LIMIT 1");

            }else if( $action == "q" )
            {
                $table=$dbpref.'stud_quiz';
                $qu_or_ass_id = trim( $mysqli->real_escape_string( $qu_or_ass_id ) );
                $qry = $mysqli->query("SELECT * FROM `".$table."` WHERE `quiz_id`=$qu_or_ass_id AND `member_id`=$mid ORDER BY `submitted_on` DESC LIMIT 1");

            }
            if(  $qry->num_rows > 0 )
            {
                return $qry;
            }
            return 0;
        }
        function getquizUI($id= null )
        {
            $quiz_data=self::get_quiz_by_id($id);
            $quiz_questions=self::get_quiz_questions_by_id($id);
            require plugin_dir_path( dirname(__FILE__,1) )."/views/view_stud_quiz_shortcode.php";
        }
        function getTime($duration=60)
        {
            $hour = floor(($duration / 60)/60);
            $minutes = floor(($duration / 60) % 60);
            $seconds =$duration % 60;
            if($hour<10)
            {
            $hour="0".$hour;
            }
            if($minutes<10)
            {
            $minutes="0".$minutes;
            }
            if($seconds<10)
            {
            $seconds="0".$seconds;
            }
            if ($hour > 0 )
            {
            $times = $hour.":".$minutes.":".$seconds;
            }
            else if( $minutes>0 )
            {
            $times = "00:".$minutes.":".$seconds;
            }
            else{
            $times = "00:00:".$seconds;
            }
            return $times;
        }

        function getcourseUI($id= null )
        {
            $course_data=self::get_all_courses(true,$id);
            require plugin_dir_path( dirname(__FILE__,1) )."/views/view_course_shortcode.php";
        }

        function getallcourseUI($id= null )
        {
            $allcourse_data=self::get_all_courses( false,false);
            require plugin_dir_path( dirname(__FILE__,1) )."/views/view_allcourse_shortcode.php";
        }

        // this function show main screen and all course related content
        function getMainScreeUI( $course_id, $mdata,  $questions_ob, $quiz_stud_ob,  $lecture_ob, $assign_stud_ob, $assignment_ob, $person )
        {
           
            global $mysqli;
            global $dbpref;
            if( !empty( $course_id ) && isset($course_id) )
            {
                $table      =  $dbpref."all_products" ;
                $table1     =  $dbpref."section";
                $table2     =  $dbpref."content_options";
                $course_id  =  $mysqli->real_escape_string( $course_id );
                $qr1 =  "SELECT * FROM `".$table."` WHERE `id`=".$course_id;
                $cresult = $mysqli->query( $qr1 );
               if($person=="a")
               {
                    if( $cresult->num_rows >0 )
                    {
                        $cr = $cresult->fetch_assoc();
                        if(isset($mdata['email']))
                        {
     
                            $email = $mdata['email'];
                            $name  = $mdata['name'];
                        }else{
                            header("Location:".$cr['membership_url']."");
                        }

                        $c_id = $cr['id'];

                        $qr2 =  "SELECT * FROM `".$table1."` WHERE `course_id`=$c_id ORDER BY `display_order` ASC";
                        $sresult = $mysqli->query( $qr2 );
                        

                        // this is for mobile but i need to delete this and all releded data with this after complete the project 
                        $qr3 =  "SELECT * FROM `".$table1."` WHERE `course_id`=$c_id ORDER BY `display_order` ASC";
                        $sresultm = $mysqli->query( $qr3 );
                        $qr4 =  "SELECT * FROM `".$table1."` WHERE `course_id`=$c_id ORDER BY `display_order` ASC";
                        $sresultD = $mysqli->query( $qr4 );
                        $qr5 =  $mysqli->query("SELECT COUNT(*) as 't_l' FROM `".$table2."` WHERE  `option_type`='lecture' AND `course_id`=$c_id");
                        $t_l =  $qr5->fetch_assoc();
                        
                        $qr6 =  $mysqli->query("SELECT COUNT(*) as 't_q' FROM `".$table2."` WHERE  `option_type`='quiz' AND `course_id`=$c_id");
                        $t_q =  $qr6->fetch_assoc();

                        $qr7 =  $mysqli->query("SELECT COUNT(*) as 't_a' FROM `".$table2."` WHERE  `option_type`='assign' AND `course_id`=$c_id");
                        $t_a =  $qr7->fetch_assoc();
                        $qr8 =  $mysqli->query("SELECT COUNT(*) as 't_t' FROM `".$table2."` WHERE  `option_type`='test' AND `course_id`=$c_id");
                        $t_t =  $qr8->fetch_assoc();
                        
                        if( $sresult->num_rows > 0 || $sresultm->num_rows > 0 || $sresultD->num_rows > 0 )
                        {

                            $course_name = $cr['title'];
                            $brand_image = $cr['brand_img_url'];
                            if(!$brand_image && !empty($brand_image))
                            {
                                list( $bimg_width, $bimg_height, $type,  $attr) = getimagesize($brand_image);
                            }else{
                                $bimg_height=0;
                                $bimg_width=0;
                            }

                            $theme       = $cr['theme'];
                            $theme = ( !empty($theme) && in_array($theme, array("a","b","c","d") ) )? $theme : "a"; 
                            $default_header       = $cr['default_header'];
                            if(isset($_COOKIE['cfCourseUserChooseTheme'])){
                                $theme=$_COOKIE['cfCourseUserChooseTheme'];

                            }else{
                                setcookie("cfCourseTheme",$theme, (time() + (86400 * 365)), "/");
                                if(isset($_COOKIE['cfCourseTheme']))
                                {
                                    $theme=$_COOKIE['cfCourseTheme'];
                                }
                            }
                            $p_dir_url = plugin_dir_url( dirname( __FILE__ ,1 ) );
                            $drip_texts  = !empty( $cr['drip_text'] ) ? $cr['drip_text'] :"Sorry! The next section will be available after {days}";
                            $drip_texts  = $mysqli->real_escape_string( $drip_texts );
                            $drip_texts  = $notifications=str_ireplace("{days}", ' <span id="cf-course--d-ys" class="font-weight-bold">2 days</span>', $drip_texts );
                            $drip_texts  = explode("\\r\\n", rtrim( $drip_texts, "\\r\\n"));
                            $text        = '<p>';
                            foreach( $drip_texts as $drip_text )
                            {
                                $text.=$drip_text;   
                            }
                            $text.='</p>';
                            $membership_url = $cr['membership_url'];
                            $c_des       = stripcslashes( trim(stripcslashes($cr['description']),"\r\n") ) ;
                            $course_video= $cr['demo_video'];
                            $course_image= $cr['image'];
                            $course_url  = $cr['url'];

                            $show_end_cirtificate= $cr['end_cirtificate'];
                            require plugin_dir_path( dirname(__FILE__,1) )."/views/course_screen_a_".$theme.".php";

                        }

                    }else{
                        echo "please add course in course page setting or go back in membership page";
                    }
               }elseif($person=="s")
               {
                    if( $cresult->num_rows >0 )
                    {

                        $cr = $cresult->fetch_assoc();
                        if(isset($mdata['email']))
                        {
     
                            $email = $mdata['email'];
                            $name  = $mdata['name'];
                        }else{
                            header("Location:".$cr['membership_url']."");
                        }

                        $c_id = $cr['id'];

                        $qr2 =  "SELECT * FROM `".$table1."` WHERE `course_id`=$c_id ORDER BY `display_order` ASC";
                        $sresult = $mysqli->query( $qr2 );

                        // this is for mobile but i need to delete this and all releded data with this after complete the project 
                        $qr3 =  "SELECT * FROM `".$table1."` WHERE `course_id`=$c_id ORDER BY `display_order` ASC";
                        $sresultm = $mysqli->query( $qr3 );
                        $qr4 =  "SELECT * FROM `".$table1."` WHERE `course_id`=$c_id ORDER BY `display_order` ASC";
                        $sresultD = $mysqli->query( $qr4 );
                        $qr5 =  $mysqli->query("SELECT COUNT(*) as 't_l' FROM `".$table2."` WHERE  `option_type`='lecture' AND `course_id`=$c_id");
                        $t_l =  $qr5->fetch_assoc();
                        
                        $qr6 =  $mysqli->query("SELECT COUNT(*) as 't_q' FROM `".$table2."` WHERE  `option_type`='quiz' AND `course_id`=$c_id");
                        $t_q =  $qr6->fetch_assoc();

                        $qr7 =  $mysqli->query("SELECT COUNT(*) as 't_a' FROM `".$table2."` WHERE  `option_type`='assign' AND `course_id`=$c_id");
                        $t_a =  $qr7->fetch_assoc();
                        $qr8 =  $mysqli->query("SELECT COUNT(*) as 't_t' FROM `".$table2."` WHERE  `option_type`='test' AND `course_id`=$c_id");
                        $t_t =  $qr8->fetch_assoc();
                        if( $sresult->num_rows > 0 || $sresultm->num_rows > 0 || $sresultD->num_rows > 0 )
                        {

                            $course_name = $cr['title'];
                            $brand_image = $cr['brand_img_url'];
                            $theme       = $cr['theme'];
                            $brand_image = $cr['brand_img_url'];
                            if(!$brand_image && !empty($brand_image))
                            {
                                list( $bimg_width, $bimg_height, $type,  $attr) = getimagesize($brand_image);
                            }else{
                                $bimg_height=0;
                                $bimg_width=0;
                            }
                            $theme = ( !empty($theme) && in_array($theme, array("a","b","c","d") ) )? $theme : "a"; 
                            $p_dir_url = plugin_dir_url( dirname( __FILE__ ,1 ) );
                            $default_header       = $cr['default_header'];

                            if(isset($_COOKIE['cfCourseUserChooseTheme'])){
                                $theme=$_COOKIE['cfCourseUserChooseTheme'];

                            }else{
                                setcookie("cfCourseTheme",$theme, (time() + (86400 * 365)), "/");
                                if(isset($_COOKIE['cfCourseTheme']))
                                {
                                    $theme=$_COOKIE['cfCourseTheme'];
                                }
                            }

                            
                            $drip_texts  = !empty( $cr['drip_text'] ) ? $cr['drip_text'] :"Sorry! The next section will be available after {days}";
                            $drip_texts  = $mysqli->real_escape_string( $drip_texts );
                            $drip_texts  = $notifications=str_ireplace("{days}", ' <span id="cf-course--d-ys" class="font-weight-bold">2 days</span>', $drip_texts );
                            $drip_texts  = explode("\\r\\n", rtrim( $drip_texts, "\\r\\n"));
                            $text        = '<p>';
                            foreach( $drip_texts as $drip_text )
                            {
                                $text.=$drip_text;   
                            }
                            $text.='</p>';
                            $membership_url = $cr['membership_url'];
                            $c_des       = stripcslashes( trim(stripcslashes($cr['description']),"\r\n") ) ;
                            $course_video= $cr['demo_video'];
                            $course_image= $cr['image'];
                            $course_url  = $cr['url'];

                            $show_end_cirtificate= $cr['end_cirtificate'];
                            require plugin_dir_path( dirname(__FILE__,1) )."/views/course_screen_".$theme.".php";

                        }
                    }else{
                        echo "please add course in course page setting or go back in membership page";
                    }
               }
            }
        }
        
        function getallSectionDataMo( $sresult, $c_id, $mem_id, $oo_id, $ss_id,$theme, $person="s",$drip_on_off )
        {
            $htmCon = '';
            global $mysqli;
            global $dbpref;
            if( $person=="s" )
            {
                self::addDripFeedData($mem_id,$c_id);
            }
            $drip_count=0;
            $add_times_ser=date("Y-m-d",time());//to pick date from Server.. 
            $result_drip=self::showDripLocks($mem_id,$c_id);
            if($result_drip->num_rows > 0)
            {
                if($row = $result_drip->fetch_assoc() )
                {
                    $drip_days=$row['drip_days'];
                    $created_at=$row['created_at'];
                }
            }else{
                $drip_days=0;
            }

           $add_days=0;
          
            while( $sr = $sresult->fetch_assoc() )
            {   
               $drip_count++;
                $s_title    = htmlentities(stripcslashes( trim( stripcslashes(base64_decode($sr['title'])),"\r\n")  ));
                $s_id       = $sr['id'];
                $table      = $dbpref."content_options";
                $qr         = "SELECT * FROM `".$table."` WHERE `course_id`=$c_id AND `section_id`=$s_id ORDER BY `display_order` ASC ";
                $oresult     = $mysqli->query( $qr );
                $total_row  = self::getTotalContent($c_id, $s_id );
                $counts     = self::getWatched($mem_id, $c_id, $s_id );
                $as=1;
                $le=1;
                $te=1;
                $qu=1;
                if( $theme == "b" )
                {
                    $style      =  ( $ss_id== $s_id ) ? 'style="background-color: #d9e5fa61 !important"': '' ;

                }
                else if( $theme == "c" )
                {
                    $style      =  ( $ss_id== $s_id ) ? 'style="background-color: #4845458f !important"': '' ;
                    
                }
                else if( $theme =="d" )
                {
                    $style      =  ( $ss_id== $s_id ) ? 'style="background-color: #64c5f757 !important"': '' ;
                    
                }else{
                    $style      =  ( $ss_id== $s_id ) ? 'style="background-color: #d9e5fa61 !important"': '' ;
                }
                $fas_down      =  ( $ss_id== $s_id ) ? 'fa-angle-up': 'fa-angle-down' ;
                $showc         =  ( $ss_id== $s_id ) ? 'show': '' ;
                $drip_collapse="collapse";
                $open_modal  = "";
                if(isset($drip_on_off))
                {
                    if($drip_on_off==1 || $drip_on_off=="1")//showing locks system only if drip is on via admin. 
                    {
                        if($drip_count==1)
                        {
                        $htmCon_lock= '<i class="fa fa-unlock d--cf--lock "></i>';
                        $drip_collapse="collapse";
                        }
                        else
                        { 
                        $created_at=date('Y-m-d', strtotime($created_at. ' + '.$drip_days.' days'));
                            if($created_at<=$add_times_ser)
                            {
                             $htmCon_lock= '<i class="fa fa-unlock d--cf--lock"></i>';
                             $drip_collapse="collapse";   
                            }else
                            {
                                 $htmCon_lock= '<i class="fa fa-lock d--cf--lock"></i>'; 
                                 $drip_collapse="";
                                 $open_modal  = "cf-course-open-model";
                                 $add_days=$add_days+$drip_days;
                            }
                        }
                    }//drip on off ends if condition
                }
              
                $htmCon  .= '<div class="cf-course-msr-s">
                                <div class="cf-course-msr-sec">
                                    <div class="cf-course-sec-o b--cf--sec-o c--cf--sec-o d--cf--sec-o e--cf--sec-o cf-course-open-s '.$open_modal.' p-3" data-days="'.$add_days.'" '.$style.' data-toggle="'.$drip_collapse.'" data-target="#cf-course-sec-'.$s_id.'" >';
                if(isset($htmCon_lock)){
                $htmCon .=$htmCon_lock;   
                }
                $htmCon  .= '<div class="d-flex justify-content-between cf-course-sec-o-'.$s_id.'">
                                            <div class="cf-course-sec-o-'.$s_id.'">
                                                <span class="cf-course-sec-o-'.$s_id.'" >Section <span class="cf-course-main-scount" ></span>: </span> <span class="cfcourse-s-t-t cf-course-sec-o-'.$s_id.'" > '.$s_title.' <span>
                                            </div>
                                            <div class="ml-1 cf-course-sec-o-'.$s_id.'">
                                                <i class="cf-course-msr-s-arr fas '. $fas_down.' cf-course-sec-o-'.$s_id.'"></i>
                                            </div>
                                        </div>
                                        <div class="cf-course-msrs-cl">
                                            <div >
                                                <span class="cf-course-slec-count" id="cf-course-slec-count-'.$s_id.'" > '.$counts.' </span> | <span> '.$total_row.' </span>
                                            </div>
                                        </div>
                                    </div>
                                    <div id="cf-course-sec-'.$s_id.'" class=" d--cf--crse-in collapse '.$showc.'">';
                                        
                                            if( $oresult->num_rows > 0 )
                                            {
                                                while( $o_data = $oresult->fetch_assoc() )
                                                {
                                                    $type = $o_data['option_type'];
                                                    if( $type == "lecture" )
                                                    {
                                                        $htmCon.= self::getLectureUI( $o_data,$mem_id,$oo_id, $theme,$le );
                                                        $le++;

                                                    }else if( $type == "quiz" ){

                                                        $htmCon.= self::getMainQuizUI( $o_data,$mem_id,$oo_id, $theme,$person,$qu );
                                                        $qu++;


                                                    }else if( $type == "assign" )
                                                    {
                                                        $htmCon.= self::getAssignUI( $o_data,$mem_id,$oo_id, $theme,$person,$as );
                                                        $as++;

                                                    }
                                                    else if( $type == "test" )
                                                    {
                                                        $htmCon.= self::getTestUI( $o_data,$mem_id,$oo_id, $theme,$person,$te );
                                                        $te++;

                                                    }
                                                }
                                            }
                                
                            $htmCon.='</div>
                                </div>
                            </div>';
                           
            }
            return $htmCon;
        }
        /*
        Theme a start
        */ 
        function getLectureUI( $o_data,$mem_id,$oo_id, $theme,$le_count )
        {
            $op_id = $o_data['id'];
            $s_id  = $o_data['section_id'];
            $c_id  = $o_data['course_id'];
            $o_title= htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type = $o_data['content_type'];
            $o_cont  = json_decode( base64_decode( $o_data['content'] ) ,true);
            $progress  = self::getUserProgress( $mem_id,$c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #f0f5f9 !important"': '' ;
            $tabindex =( $oo_id== $op_id ) ? 'tabindex="-1"':''  ;
            $htmCon ='';
            $htmCon .='
            <div class="cf-course-msrslc px-1 px-md-4 pt-2">
                <div class="cf-course-msrs-lc p-2" '.$style.' '.$tabindex.'>
                    <div class="cf-course-msrs-lct">
                        <input class="cf-course-msrs-lch d--cf--sl-check cf-course-sl-check" name="cf-course-opcom-'.$op_id.'" '.$watched.' data-c_id="'.$c_id.'" data-m_id="'.$mem_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'"  id="cf-course-sl-checkbox-'.$op_id.'" type="checkbox" >
                        <label class="mb-0" for="cf-course-sl-checkbox-'.$op_id.'"></label>
                        <span class="cf-course-getlen-id" id="cf-course-main-ccount-'.$op_id.'" data-type="lecture" data-course="'.$c_id.'"  data-m_id="'.$mem_id.'" data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$le_count.'"><span>Lecture  <span class="cf-course-main-lcount cf-course-main-ocount" >'.$le_count.'</span>  </span>: <span class="cf-course-msr-slt" >  '.$o_title.' </span></span>
                    </div>
                    <div class="cf-course-msrs-lcty mt-2">';
                        if( $o_type ==  'vu' ):
                            $htmCon .='<i class="fas fa-play-circle cf-courseI"></i>
                            <span  class="cf-course-msrs-lcount"> 
                                Video <span>'.( isset( $o_cont['v_h'] ) && !empty( $o_cont['v_h'] ) ? $o_cont["v_h"]."H" :  "").' </span> <span>'.( isset( $o_cont['v_m'] ) && !empty( $o_cont['v_m'] ) ? $o_cont["v_m"]."Mn" :  "").' </span><span>'.( isset( $o_cont['v_s'] ) && !empty( $o_cont['v_s'] ) ? $o_cont["v_s"]."S" :  "").' </span> 
                            </span>';
                        elseif( $o_type ==  'au' ):
                            $htmCon .='<i class="fas fa-headphones cf-courseI"></i><span  class="cf-course-msrs-lcount"> Audio </span>';
                        elseif( $o_type ==  'y' ):
                            $htmCon .='<i class="fas fa-play-circle cf-courseI"></i>
                            <span  class="cf-course-msrs-lcount"> 
                               Video <span>'.( isset( $o_cont['y_h'] ) && !empty( $o_cont['y_h'] ) ? $o_cont["y_h"]."H" :  "").' </span> <span>'.( isset( $o_cont['y_m'] ) && !empty( $o_cont['y_m'] ) ? $o_cont["y_m"]."Mn" :  "").' </span> <span>'.( isset( $o_cont['y_s'] ) && !empty( $o_cont['y_s'] ) ? $o_cont["y_s"]."S" :  "").' </span>    
                            </span>';
                        elseif( $o_type ==  'vm' ):
                            $htmCon .=' <i class="fas fa-play-circle cf-courseI"></i>
                            <span  class="cf-course-msrs-lcount"> 
                            Video <span>'.( isset( $o_cont['vm_h'] ) && !empty( $o_cont['vm_h'] ) ? $o_cont["vm_h"]."H" :  "").' </span> <span>'.( isset( $o_cont['vm_m'] ) && !empty( $o_cont['vm_m'] ) ? $o_cont["vm_m"]."Mn" :  "").' </span><span>'.( isset( $o_cont['vm_s'] ) && !empty( $o_cont['vm_s'] ) ? $o_cont["vm_s"]."S" :  "").' </span>
                            </span>';
                        elseif( $o_type ==  'i' ):
                            $htmCon .='<i class="fas fa-image cf-courseI" ></i><span  class="cf-course-msrs-lcount"> Image </span>'; 
                        elseif( $o_type ==  'd' ):
                            $htmCon .='<i class="fas fa-file cf-courseI"></i><span  class="cf-course-msrs-lcount"> Document </span>'; 
                        elseif( $o_type ==  'cfcourselat' ):
                            $htmCon .='<i class="fas fa-newspaper cf-courseI"></i> <span  class="cf-course-msrs-lcount"> Article </span>'; 
                        elseif( $o_type ==  'if' ):
                            $htmCon .='<i class="fas fa-chalkboard cf-courseI"></i> <span  class="cf-course-msrs-lcount"> Iframe </span>'; 
                        endif;
                        $htmCon.=$this->getHelpContent($op_id);
                  $htmCon.='</div>
                </div>
            </div>';
            return $htmCon;
        }

        function getMainQuizUI( $o_data , $mem_id, $oo_id, $theme, $person,$qu_count)
        {
            $op_id      = $o_data['id'];
            $s_id       = $o_data['section_id'];
            $c_id       = $o_data['course_id'];
            $o_title      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type     = $o_data['option_type'];
            $o_cont     = json_decode( base64_decode( $o_data['content'] ) ,true);
            $help_resources     = $o_data['help_resource'];
            $progress  = self::getUserProgress($mem_id, $c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #f0f5f9 !important"': '' ;
            $tabindex =( $oo_id== $op_id ) ? 'tabindex="-1"':''  ;
            $htmCon ='';
            if( $person=="a" )
            {
                $htmCon .='
                <div class="cf-course-msrslc  px-1 px-md-4 pt-2" style="cursor:not-allowed;">
                    <div class="cf-course-msrs-lc p-2" '.$style.' '.$tabindex.'>
                        <div class="cf-course-msrs-lct" style="cursor:not-allowed;">
                            <input class="cf-course-msrs-lch d--cf--sl-check cf-course-sl-check" '.$watched.' name="cf-course-opcom-'.$op_id.'"  data-m_id="'.$mem_id.'"  data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'"  id="cf-course-sl-checkbox-'.$op_id.'"  type="checkbox" >
                            <label for="cf-course-sl-checkbox-'.$op_id.'"></label>
                            <span style="cursor:not-allowed;" class="cf-course-getlen-id"  data-type="quiz" data-course="'.$c_id.'"  data-m_id="'.$mem_id.'" data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$qu_count.'"><span>Quiz  <span class="cf-course-main-qcount cf-course-main-ocount" >'.$qu_count.'</span>  </span>: <span class="cf-course-msr-slt" >'.$o_title.' </span></span>
                        </div>
                        <div class="cf-course-msrs-lcty mt-2"><i class="fas fa-puzzle-piece cf-courseI"></i> <span > Quiz </span></div>
                    </div>
                </div>';
            }else if( $person=="s" )
            {
                $htmCon .='
                <div class="cf-course-msrslc  px-1 px-md-4 pt-2">
                    <div class="cf-course-msrs-lc p-2" '.$style.' '.$tabindex.'>
                        <div class="cf-course-msrs-lct">
                            <input class="cf-course-msrs-lch d--cf--sl-check cf-course-sl-check" '.$watched.' name="cf-course-opcom-'.$op_id.'"  data-m_id="'.$mem_id.'"  data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'"  id="cf-course-sl-checkbox-'.$op_id.'"  type="checkbox" >
                            <label class="mb-0" for="cf-course-sl-checkbox-'.$op_id.'"></label>
                            <span class="cf-course-getlen-id" id="cf-course-main-ccount-'.$op_id.'" data-type="quiz" data-course="'.$c_id.'"  data-m_id="'.$mem_id.'" data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$qu_count.'"><span>Quiz  <span class="cf-course-main-qcount cf-course-main-ocount" >'.$qu_count.'</span>  </span>: <span class="cf-course-msr-slt" >'.$o_title.' </span></span>
                        </div>
                        <div class="cf-course-msrs-lcty mt-2"><i class="fas fa-puzzle-piece cf-courseI"></i> <span > Quiz </span></div>
                    </div>
                </div>';
            }
            return $htmCon;

        }

        function getAssignUI( $o_data ,$mem_id, $oo_id, $theme,$person, $as_count)
        {
            $op_id      = $o_data['id'];
            $s_id       = $o_data['section_id'];
            $c_id       = $o_data['course_id'];
            $o_title      = htmlentities( stripcslashes( trim( stripcslashes( base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type     = $o_data['content_type'];
            $o_cont     = json_decode( base64_decode( $o_data['content'] ) ,true);
            $help_resources     = $o_data['help_resource'];
            $progress  = self::getUserProgress( $mem_id,$c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #f0f5f9 !important"': '' ;
            $htmCon ='';
            $tabindex = ( $oo_id== $op_id ) ? 'tabindex="-1"':'';
            if( $person=="a" )
            {
                $htmCon .='
                <div class="cf-course-msrslc  px-1 px-md-4 pt-2" style="cursor:not-allowed;">
                    <div class="cf-course-msrs-lc p-2" '.$style.' '.$tabindex.'>
                        <div class="cf-course-msrs-lct" style="cursor:not-allowed;">
                            <input class="cf-course-msrs-lch d--cf--sl-check cf-course-sl-check" '.$watched.' name="cf-course-opcom-'.$op_id.'" data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'"  id="cf-course-sl-checkbox-'.$op_id.'"  type="checkbox" >
                            <label class="mb-0" for="cf-course-sl-checkbox-'.$op_id.'"></label>
                            <span style="cursor:not-allowed !important;"  id="cf-course-main-ccount-'.$op_id.'" class="cf-course-getlen-id" data-course="'.$c_id.'" data-type="assignment" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'"  data-count="'.$as_count.'"> <span>Assignment  <span class="cf-course-main-acount cf-course-main-ocount" >'.$as_count.'</span>  </span>: <span class="cf-course-msr-slt" >'.$o_title.'</span></span>
                        </div>
                        <div class="cf-course-msrs-lcty mt-2"><i class="fas fa-tasks cf-courseI"></i> <span > Assignment </span></div>
                    </div>
                </div>';
            }else if( $person=="s" )
            {
                $htmCon .='
                <div class="cf-course-msrslc  px-1 px-md-4 pt-2">
                    <div class="cf-course-msrs-lc p-2" '.$style.' '.$tabindex.'>
                        <div class="cf-course-msrs-lct">
                            <input class="cf-course-msrs-lch d--cf--sl-check cf-course-sl-check" '.$watched.' name="cf-course-opcom-'.$op_id.'" data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'"  id="cf-course-sl-checkbox-'.$op_id.'"  type="checkbox" >
                            <label class="mb-0" for="cf-course-sl-checkbox-'.$op_id.'"></label>
                            <span class="cf-course-getlen-id"  id="cf-course-main-ccount-'.$op_id.'" data-course="'.$c_id.'" data-type="assignment" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$as_count.'"> <span>Assignment  <span class="cf-course-main-acount cf-course-main-ocount" >'.$as_count.'</span>  </span>: <span class="cf-course-msr-slt" >'.$o_title.'</span></span>
                        </div>
                        <div class="cf-course-msrs-lcty mt-2"><i class="fas fa-tasks cf-courseI"></i> <span > Assignment </span></div>
                    </div>
                </div>';
            }
            return $htmCon;
        }
        function getTestUI( $o_data ,$mem_id, $oo_id, $theme,$person, $te_count)
        {
            $op_id      = $o_data['id'];
            $s_id       = $o_data['section_id'];
            $c_id       = $o_data['course_id'];
            $o_title      = htmlentities( stripcslashes( trim( stripcslashes( base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type     = $o_data['content_type'];
            $o_cont     = json_decode( base64_decode( $o_data['content'] ) ,true);
            $help_resources     = $o_data['help_resource'];
            $progress  = self::getUserProgress( $mem_id,$c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #f0f5f9 !important"': '' ;
            $htmCon ='';
            $tabindex = ( $oo_id== $op_id ) ? 'tabindex="-1"':'';
            if( $person=="a" )
            {
                $htmCon .='
                <div class="cf-course-msrslc  px-1 px-md-4 pt-2" style="cursor:not-allowed;">
                    <div class="cf-course-msrs-lc p-2" '.$style.' '.$tabindex.'>
                        <div class="cf-course-msrs-lct" style="cursor:not-allowed;">
                            <input class="cf-course-msrs-lch d--cf--sl-check cf-course-sl-check" '.$watched.' name="cf-course-opcom-'.$op_id.'" data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'"  id="cf-course-sl-checkbox-'.$op_id.'"  type="checkbox" >
                            <label class="mb-0" for="cf-course-sl-checkbox-'.$op_id.'"></label>
                            <span style="cursor:not-allowed !important;"  id="cf-course-main-ccount-'.$op_id.'" class="cf-course-getlen-id" data-course="'.$c_id.'" data-type="test" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$te_count.'"><span>Test  <span class="cf-course-main-tcount cf-course-main-ocount" >'.$te_count.'</span>  </span>: <span class="cf-course-msr-slt" >'.$o_title.'</span></span>
                        </div>
                        <div class="cf-course-msrs-lcty mt-2"><i class="fas fa-pen-fancy cf-courseI"></i> <span > Test </span>
                    </div>
                    </div>
                </div>';
            }else if( $person=="s" )
            {
                $htmCon .='
                <div class="cf-course-msrslc  px-1 px-md-4 pt-2">
                    <div class="cf-course-msrs-lc p-2" '.$style.' '.$tabindex.'>
                        <div class="cf-course-msrs-lct">
                            <input class="cf-course-msrs-lch d--cf--sl-check cf-course-sl-check" '.$watched.' name="cf-course-opcom-'.$op_id.'" data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'"  id="cf-course-sl-checkbox-'.$op_id.'"  type="checkbox" >
                            <label class="mb-0" for="cf-course-sl-checkbox-'.$op_id.'"></label>
                            <span class="cf-course-getlen-id"  id="cf-course-main-ccount-'.$op_id.'" data-course="'.$c_id.'" data-type="test" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$te_count.'"><span>Test  <span class="cf-course-main-tcount cf-course-main-ocount" >'.$te_count.'</span>  </span>: <span class="cf-course-msr-slt" >'.$o_title.'</span></span>
                        </div>
                        <div class="cf-course-msrs-lcty mt-2"><i class="fas fa-pen-fancy cf-courseI"></i> <span > Test </span></div>
                    </div>
                </div>';
            }
            return $htmCon;
        }
        /*
        Theme a end
        */ 
         /*
        Theme b start
        */ 
        function getallSectionDataA( $sresult, $c_id, $mem_id, $oo_id, $ss_id, $person="s",$drip_on_off )
        {
            $htmCon = '';
            global $mysqli;
            global $dbpref;
            if( $person=="s" )
            {
                self::addDripFeedData($mem_id,$c_id);
            }
            $drip_count=0;
            $add_times_ser=date("Y-m-d",time());//to pick date from Server.. 
            $result_drip=self::showDripLocks($mem_id,$c_id);
            if($result_drip->num_rows > 0)
            {
                if($row = $result_drip->fetch_assoc() )
                {
                    $drip_days=$row['drip_days'];
                    $created_at=$row['created_at'];
                }
            }else{
                $drip_days=0;
                $created_at=time();
            }
           $add_days=0;
           $sc=0;
           $as=1;
           $le=1;
           $te=1;
           $qu=1;
            while( $sr = $sresult->fetch_assoc() )
            {   
                $drip_count++;
                $s_title    = htmlentities(stripcslashes( trim( stripcslashes(base64_decode($sr['title'])),"\r\n")  ));
                $s_id       = $sr['id'];
                $table      = $dbpref."content_options";
                $qr         = "SELECT * FROM `".$table."` WHERE `course_id`=$c_id AND `section_id`=$s_id ORDER BY `display_order` ASC ";
                $oresult     = $mysqli->query( $qr );
                $total_row  = self::getTotalContent($c_id, $s_id );
                $counts     = self::getWatched($mem_id, $c_id, $s_id );
                $sc++;
                $sc0 = self::getNumberWithZero($sc);

                $fas_down      =  ( $ss_id== $s_id ) ? 'fa-angle-up': 'fa-angle-down' ;
                $showc         =  ( $ss_id== $s_id ) ? 'show': '' ;
                $drip_collapse="collapse";
                $open_modal  = "";
                if(isset($drip_on_off))
                {
                    if($drip_on_off==1 || $drip_on_off=="1")//showing locks system only if drip is on via admin. 
                    {
                        if($drip_count==1)
                        {
                        $htmCon_lock= '<i class="fa fa-unlock "></i>';
                        $drip_collapse="collapse";
                        }
                        else
                        { 
                        $created_at=date('Y-m-d', strtotime($created_at. ' + '.$drip_days.' days'));
                            if($created_at<=$add_times_ser)
                            {
                             $htmCon_lock= '<i class="fa fa-unlock"></i>';
                             $drip_collapse="collapse";   
                            }else
                            {
                                 $htmCon_lock= '<i class="fa fa-lock"></i>'; 
                                 $drip_collapse="";
                                 $open_modal  = "cf-course-open-model";
                                 $add_days=$add_days+$drip_days;
                            }
                        }
                    }//drip on off ends if condition
                }
                                
 
                $htmCon.='<li class="cf-course-course-title-a cf-course-open-s cf-course-sec-o '.$open_modal.'" data-days="'.$add_days.'" data-toggle="'.$drip_collapse.'" data-target="#cf-course-sec-'.$s_id.'" >
                            <div class="d-flex justify-content-between">
                                <div> <h4>'.(isset($htmCon_lock)?$htmCon_lock:'').'<span>Section '.$sc0.' :</span> '.$s_title.' </h4></div>
                            <span><i class="cf-course-msr-s-arr fas '. $fas_down.' "></i></span>
                            </div>
                        </li>';
                
                        $htmCon  .= '<li id="cf-course-sec-'.$s_id.'" class="cf-course-course-details-a collapse '.$showc.'"><ul>';
                                    if( $oresult->num_rows > 0 )
                                    {
                                        while( $o_data = $oresult->fetch_assoc() )
                                        {
                                            $type = $o_data['option_type'];
                                            if( $type == "lecture" )
                                            {
                                                $htmCon.= self::getLectureUIA( $o_data,$mem_id,$oo_id,$le );
                                                $le++;

                                            }else if( $type == "quiz" ){

                                                $htmCon.= self::getMainQuizUIA( $o_data,$mem_id,$oo_id, $person,$qu );
                                                $qu++;


                                            }else if( $type == "assign" )
                                            {
                                                $htmCon.= self::getAssignUIA( $o_data,$mem_id,$oo_id,$person,$as );
                                                $as++;

                                            }
                                            else if( $type == "test" )
                                            {
                                                $htmCon.= self::getTestUIA( $o_data,$mem_id,$oo_id,$person,$te );
                                                $te++;

                                            }
                                        }
                                    }
                    $htmCon.='</ul></li>';
                           
            }
            return $htmCon;
        }
        function getLectureUIA( $o_data,$mem_id,$oo_id,$le_count )
        {
            $op_id = $o_data['id'];
            $le_count0 = self::getNumberWithZero($le_count);
            
            $s_id  = $o_data['section_id'];
            $c_id  = $o_data['course_id'];
            $o_title= htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type = $o_data['content_type'];
            $o_cont  = json_decode( base64_decode( $o_data['content'] ) ,true);
            $progress  = self::getUserProgress( $mem_id,$c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #2ACF97 !important"': '' ;
            $tabindex =( $oo_id== $op_id ) ? 'tabindex="-1"':''  ;
            
            $htmCon ='<li '.$tabindex.' '.$style.' >
            <p class="d-flex align-items-center">
            <span class="cf-course-a-checkboxes">
                <input data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'" class="cf-course-msrs-lch" type="checkbox" id="cf-course-sl-checkbox-'.$op_id.'" name="cf-course-opcom-'.$op_id.'" '.$watched.' >
                <label  for="cf-course-sl-checkbox-'.$op_id.'"></label>
            </span>
            <span class="cf-course-getlen-id" id="cf-course-main-ccount-'.$op_id.'" data-type="lecture" data-course="'.$c_id.'"  data-m_id="'.$mem_id.'" data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$le_count.'">Lesson '.$le_count0.' : '.$o_title.'</span> </p>
            </li>';
            return $htmCon; 
        }

        function getMainQuizUIA( $o_data , $mem_id, $oo_id, $person,$qu_count)
        {
            $op_id      = $o_data['id'];
            $s_id       = $o_data['section_id'];
            $c_id       = $o_data['course_id'];
            $qu_count0 = self::getNumberWithZero($qu_count);
            $o_title      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type     = $o_data['option_type'];
            $o_cont     = json_decode( base64_decode( $o_data['content'] ) ,true);
            $help_resources     = $o_data['help_resource'];
            $progress  = self::getUserProgress($mem_id, $c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #2ACF97 !important"': '' ;

            $tabindex =( $oo_id== $op_id ) ? 'tabindex="-1"':''  ;
            $htmCon ='';
            if( $person=="a" )
            {
                $htmCon ='<li '.$tabindex.' '.$style.' >
                <p class="d-flex align-items-center">
                <span class="cf-course-a-checkboxes">
                    <input data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'" class="cf-course-msrs-lch" type="checkbox" id="cf-course-sl-checkbox-'.$op_id.'" name="cf-course-opcom-'.$op_id.'" '.$watched.' >
                    <label  for="cf-course-sl-checkbox-'.$op_id.'"></label>
                </span>
                <span style="cursor:not-allowed;" class="cf-course-getlen-id"  data-type="quiz" data-course="'.$c_id.'"  data-m_id="'.$mem_id.'" data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$qu_count.'">Quiz '.$qu_count0.' : '.$o_title.' </span>
                </p></li>';
            }else if( $person=="s" )
            {
                $htmCon ='<li '.$tabindex.' '.$style.'>
                <p  class="d-flex align-items-center">
                <span class="cf-course-a-checkboxes">
                <input data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'" class="cf-course-msrs-lch" type="checkbox" id="cf-course-sl-checkbox-'.$op_id.'" name="cf-course-opcom-'.$op_id.'" '.$watched.' >
                <label  for="cf-course-sl-checkbox-'.$op_id.'"></label>
            </span>
                <span class="cf-course-getlen-id" id="cf-course-main-ccount-'.$op_id.'" data-type="quiz" data-course="'.$c_id.'"  data-m_id="'.$mem_id.'" data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$qu_count.'">Quiz '.$qu_count0.' : '.$o_title.'</span> </p></li>';
            }
            return $htmCon;

        }

        function getAssignUIA( $o_data ,$mem_id, $oo_id, $person, $as_count)
        {
            $op_id      = $o_data['id'];
            $s_id       = $o_data['section_id'];
            $c_id       = $o_data['course_id'];
            $as_count0 = self::getNumberWithZero($as_count);
            $o_title      = htmlentities( stripcslashes( trim( stripcslashes( base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type     = $o_data['content_type'];
            $o_cont     = json_decode( base64_decode( $o_data['content'] ) ,true);
            $help_resources     = $o_data['help_resource'];
            $progress  = self::getUserProgress( $mem_id,$c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #2ACF97 !important"': '' ;
            $htmCon ='';
            $tabindex = ( $oo_id== $op_id ) ? 'tabindex="-1"':'';
            if( $person=="a" )
            {
                $htmCon ='<li '.$tabindex.' '.$style.'>
                <p class="d-flex align-items-center">
                <span class="cf-course-a-checkboxes">
                <input data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'" class="cf-course-msrs-lch" type="checkbox" id="cf-course-sl-checkbox-'.$op_id.'" name="cf-course-opcom-'.$op_id.'" '.$watched.' >
                <label  for="cf-course-sl-checkbox-'.$op_id.'"></label>
            </span>
                <span style="cursor:not-allowed !important;"  id="cf-course-main-ccount-'.$op_id.'" class="cf-course-getlen-id" data-course="'.$c_id.'" data-type="assignment" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'"  data-count="'.$as_count.'">Assignment '.$as_count0.' : '.$o_title.'</span> 
                </p></li>';

            }else if( $person=="s" )
            {
                $htmCon ='<li '.$tabindex.' '.$style.'>
                <p class="d-flex align-items-center">
                <span class="cf-course-a-checkboxes">
                <input data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'" class="cf-course-msrs-lch" type="checkbox" id="cf-course-sl-checkbox-'.$op_id.'" name="cf-course-opcom-'.$op_id.'" '.$watched.' >
                <label  for="cf-course-sl-checkbox-'.$op_id.'"></label>
            </span>
                <span  id="cf-course-main-ccount-'.$op_id.'" class="cf-course-getlen-id" data-course="'.$c_id.'" data-type="assignment" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'"  data-count="'.$as_count.'">Assignment '.$as_count0.' : '.$o_title.'</span> 
                </p></li>';
            }
            return $htmCon;
        }
        function getTestUIA( $o_data ,$mem_id, $oo_id, $person, $te_count)
        {
            $op_id      = $o_data['id'];
            $s_id       = $o_data['section_id'];
            $c_id       = $o_data['course_id'];
            $te_count0 = self::getNumberWithZero($te_count);

            $o_title      = htmlentities( stripcslashes( trim( stripcslashes( base64_decode($o_data['title'])),"\r\n")  ) );
            $o_desc      = htmlentities( stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) );
            $o_type     = $o_data['content_type'];
            $o_cont     = json_decode( base64_decode( $o_data['content'] ) ,true);
            $help_resources     = $o_data['help_resource'];
            $progress  = self::getUserProgress( $mem_id,$c_id, $s_id, $op_id );
            $watched   = ( ( $progress == true ) ? "checked":"");
            $style      =  ( $oo_id== $op_id ) ? 'style="background-color: #2ACF97 !important"': '' ;
            $htmCon ='';
            $tabindex = ( $oo_id== $op_id ) ? 'tabindex="-1"':'';
            if( $person=="a" )
            {
                $htmCon ='<li '.$tabindex.' '.$style.'>
                <p class="d-flex align-items-center">
                <span class="cf-course-a-checkboxes">
                <input data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'" class="cf-course-msrs-lch" type="checkbox" id="cf-course-sl-checkbox-'.$op_id.'" name="cf-course-opcom-'.$op_id.'" '.$watched.' >
                <label  for="cf-course-sl-checkbox-'.$op_id.'"></label>
            </span>
                <span style="cursor:not-allowed !important;"  id="cf-course-main-ccount-'.$op_id.'" class="cf-course-getlen-id" data-course="'.$c_id.'" data-type="test" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$te_count.'">Test '.$te_count0.' : '.$o_title.'</span> </p>
                </li>';


            }else if( $person=="s" )
            {
                $htmCon ='<li '.$tabindex.' '.$style.'>
                <p class="d-flex align-items-center">
                <span class="cf-course-a-checkboxes">
                <input data-m_id="'.$mem_id.'" data-c_id="'.$c_id.'"  data-s_id="'.$s_id.'" data-op_id="'.$op_id.'" class="cf-course-msrs-lch" type="checkbox" id="cf-course-sl-checkbox-'.$op_id.'" name="cf-course-opcom-'.$op_id.'" '.$watched.' >
                <label  for="cf-course-sl-checkbox-'.$op_id.'"></label>
            </span>
                <span   id="cf-course-main-ccount-'.$op_id.'" class="cf-course-getlen-id" data-course="'.$c_id.'" data-type="test" data-m_id="'.$mem_id.'"  data-opt="'.$op_id.'" data-sec="'.$s_id.'" data-count="'.$te_count.'">Test '.$te_count0.' : '.$o_title.'</span> </p>
                </li>';

            }
            return $htmCon;
        }

        function getNumberWithZero( $num=1 ){

            if($num < 10 ){
                return "0".$num;
            }else{
                return $num;
            }
        }
        /*
        Theme a end
        */ 

        function getTotalContent( $c_id, $s_id)
        {
            global $mysqli;
            global $dbpref;
            $table      = $dbpref."content_options";
            $qr1        = "SELECT COUNT(*) AS 'total_row' FROM `".$table."` WHERE `course_id`=$c_id AND `section_id`=$s_id AND `option_type`!='NULL' OR `option_type`!=NULL";
            $oresult2   = $mysqli->query( $qr1 );
            $ofetch     = $oresult2->fetch_assoc();
            return $ofetch['total_row'];
            
        }
        function getWatched($m_id, $c_id, $s_id = 0 )
        {

            global $mysqli;
            global $dbpref;
            $table     = $dbpref."member_progress";
            $progress  = 1;
            $quiz_ob= $this->loader->load("quiz_stud_control");
            $mem_data = $quiz_ob->checkIfIsAdmin( $m_id );

            $mid = $mem_data['mid'];
            if( $s_id == 0 )
            {
                $qr1       = "SELECT COUNT(*) as total_watched FROM `".$table."` WHERE `course_id`=$c_id  AND `member_id`=$mid AND `progress`=".$progress;
                $cou_result     = $mysqli->query( $qr1 );
            }else{
                $qr1       = "SELECT COUNT(*) as total_watched FROM `".$table."` WHERE `course_id`=$c_id AND `section_id`=$s_id AND `member_id`=$mid AND `progress`=".$progress;
                $cou_result     = $mysqli->query( $qr1 );
            }

            if( $cou_result->num_rows > 0 )
            {
                $counts  = $cou_result->fetch_assoc();
                return $counts['total_watched'];

            }else{
                return "0";
            }
            
        }

        function getUserProgress($m_id, $c_id, $s_id, $oid )
        {

            global $mysqli;
            global $dbpref;
            $quiz_ob= $this->loader->load("quiz_stud_control");
            $mem_data = $quiz_ob->checkIfIsAdmin( $m_id );

            $mid = $mem_data['mid'];
            $table    = $dbpref."member_progress";
            $watched   = 1;
            $qr1       = "SELECT *  FROM  `".$table."` WHERE  `member_id`=$mid AND `option_id`=$oid AND `progress`=".$watched;
            $cou_result     = $mysqli->query( $qr1 );
            if( $cou_result->num_rows > 0 )
            {
                $counts  = $cou_result->fetch_assoc();
                return $counts['progress'];

            }else{
                return "0";
            }
        }
        
        // this function fetch all related help content for a lecture.
        function getHelpContent($op_id)
        {
            global $mysqli;
            global $dbpref;
            $table = $dbpref."content_resource";
            $sql   = "SELECT * FROM `".$table."` WHERE `content_id`=".$op_id;
            $h_r = $mysqli->query($sql);
            $help_cont="";
            if( $h_r->num_rows > 0  )
            {
                $count=1;
                $help_cont.='<span class="btn p-0 ml-2  btn-unstyled px-2 cf-course-msrs-lctexob" data-toggle="collapse" data-target="#cf-course-msrs-lctexb-'.$op_id.'"> <i class="fas fa-caret-down"></i> Extras</span>
                <div id="cf-course-msrs-lctexb-'.$op_id.'" class="collapse" >
                <div class="cf-course-msrs-lctexd ">
                ';
                
                while( $h_ds = $h_r->fetch_assoc() ){ 
                    $link=htmlentities($h_ds["link"]);
                    $text=htmlentities($h_ds["text"]);
                    $help_cont.='<div class="cf-course-lex p-1">';    
                    if( $h_ds['resource_type']=="d" ):
                        $help_cont.='<a href="'.$link.'" download  class="text-primary"> <i class="fas fa-download"></i>  '.$text.'  </a>';
                    elseif( $h_ds['resource_type']=="v" ):
                        $help_cont.='<a href="'.$link.'" target="_blank" class="text-success"> <i class="fas fa-eye"></i> '.$text.'  </a>';
                    elseif( $h_ds['resource_type']=="l" ):
                        $help_cont.='<a href="'.$link.'" target="_blank"  class="text-info"> <i class="fas fa-link"> </i>  '.$text.'  </a>'; 
                    endif;
                    $help_cont.='</div>'; 
                }
                $help_cont.='</div></div>';
            }
            return $help_cont;

        }
        function getHelpContentData($op_id)
        {
            global $mysqli;
            global $dbpref;
            $table = $dbpref."content_resource";
            $sql   = "SELECT * FROM `".$table."` WHERE `content_id`=".$op_id;
            $h_r = $mysqli->query($sql);
            return $h_r;


        }
        function getOptionsContent( $oid, $sid, $c_id, $count ,$assign_stud_ob, $lecture_ob, $type="", $mem_id=0)
        {
            global $mysqli;
            global $dbpref;
            $opid      = $mysqli->real_escape_string( $oid );
            $seid      = $mysqli->real_escape_string( $sid);
            $c         = $mysqli->real_escape_string( $count );
            $table     = $dbpref."content_options";
            $qr        = "SELECT * FROM `".$table."` WHERE `course_id`=$c_id AND `section_id`=$sid AND  `id`=".$oid;
            $oresult   = $mysqli->query( $qr );
            $status    =   $lecture_ob->getStatusOfContent($oid, "like" );
            $review_status     = self::getRatingStatus( $c_id,$mem_id );
            $htmCon ='';
            if( $oresult->num_rows > 0 )
            {
                $o_data     = $oresult->fetch_assoc();
                $op_id      = $o_data['id'];
                $s_id       = $o_data['section_id'];
                $c_id       = $o_data['course_id'];
                $o_title    = stripcslashes( trim( stripcslashes( base64_decode($o_data['title'])),"\r\n")  );
                $o_des      = stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") );
                $o_type     = $o_data['option_type'];
                $c_type     = $o_data['content_type'];

                if( $o_type == "quiz" )
                {
                    $title = '<span class="cf-course-sltcou"> Quiz <span class="cf-cc-mcon-cont">'.$c.'</span>:  </span>';
                    $about = '<h5 class="font-weight-bold">About This Quiz </h5>';
                    $action ='<div class="cf-course-opact"> 2 participated </div>';
                }
                else if( $o_type == "assign" || $o_type == "test" )
                {
                    $astst = $o_type=="assign"?"Assignment":"Test";
                    $title = '<span class="cf-course-sltcou"> '.$astst.' <span class="cf-cc-mcon-cont">'.$c.'</span>:  </span>';
                    $about = '<h5 class="font-weight-bold">About This '.$astst.' </h5>';
                    $action ='<div class="cf-course-opact"> 2 participated </div>';
                    $assingment_details=$assign_stud_ob->get_assign_details_by_id( $op_id );
                    $inst_video_url= $assingment_details['inst_video_url']; 
                    $inst_instructions= $assingment_details['inst_instructions'];
                    $inst_resourses_url= $assingment_details['inst_resourses_url'];
                    $solu_video_url= $assingment_details['solu_video_url'];
                    $solu_down_resource= $assingment_details['solu_down_resource'];
                    $training_ob = $this->loader->load("training_control");
                    if( stristr( $inst_video_url,"youtu" ) ){
                        $vid=$training_ob->getYoutubeVimeoId($inst_video_url,"y" );
                        $ivu='<iframe style="width:80%;height:200px"  src="https://www.youtube.com/embed/'.$vid.'" title="YouTube video player" frameborder="0"  allowfullscreen></iframe>';
                    }
                    else if( stristr( $inst_video_url,"vimeo" ) ){
                        $vid=$training_ob->getYoutubeVimeoId($inst_video_url,"vm" );
                        $ivu='<iframe  style="width:80%;height:200px"   src="https://player.vimeo.com/video/'.$vid.'" width="100%" frameborder="0" allow="fullscreen; picture-in-picture" allowfullscreen></iframe>';
                    }
                    else{
                        $ivu='<video style="width:80%;height:200px"  controls>
                          <source src="'.$inst_video_url.'" type="video/mp4">
                          <source src="'.$inst_video_url.'" type="video/ogg">
                        Your browser does not support the video tag.
                        </video>';
                    }
                    $ivu = (!empty($inst_video_url))? '<h4 class="py-2">Instruction Video</h4>'.$ivu:"";
                    if( stristr( $solu_video_url,"youtu" ) ){
                        $vid=$training_ob->getYoutubeVimeoId($solu_video_url,"y" );
                        $svu='<iframe style="width:80%;height:200px"   src="https://www.youtube.com/embed/'.$vid.'" title="YouTube video player" frameborder="0"  allowfullscreen></iframe>';
                    }
                    else if( stristr( $solu_video_url,"vimeo" ) ){
                        $vid=$training_ob->getYoutubeVimeoId($solu_video_url,"vm" );
                        $svu='<iframe style="width:80%;height:200px"  src="https://player.vimeo.com/video/'.$vid.'" width="100%" frameborder="0" allow="fullscreen; picture-in-picture" allowfullscreen></iframe>';
                    }
                    else{
                        $svu='
                        <video  style="width:80%;height:200px"  controls>
                        <source src="'.$solu_video_url.'" type="video/mp4">
                        <source src="'.$solu_video_url.'" type="video/ogg">
                        Your browser does not support the video tag.
                        </video>';
                    }
                    $svu = (!empty($solu_video_url))? '<h4 class="py-2">Solution Video</h4>'.$svu:"";
                    $i_res_u=' <h5 class="py-1 mt-1">Instruction Resource Download</h5><a class="btn btn-primary" href="'.$inst_resourses_url.'" download>Download</a>';
                    $i_res_u = (!empty($inst_resourses_url))?$i_res_u:"";
                    $s_res_u='   <h3>Solution Resource Download</h3><a class="btn btn-primary" href="'.$solu_down_resource.'" download>Download</a>';
                    $s_res_u = (!empty($solu_down_resource))?$s_res_u:"";
                    $assign_dataa ='<div class=" mx-auto mb-3">
                                        <div class="row">
                                            <div class="col-md-12">
                                            <h5>Instructions to Solve '.$astst.'</h5></div>
                                        </div>
                                        <div class="row cf-couse-slcon">';
                                            if(!empty($inst_instructions)){  $assign_dataa .= '<div class="col-md-12">'.$inst_instructions.'</div>';}
                                            if(!empty($ivu)){ $assign_dataa .= '<div class="col-md-6">'.$ivu.'</div>';}
                                            if(!empty($svu)){  $assign_dataa .= '<div class="col-md-6">'.$svu.'</div>';}
                                        $assign_dataa .='</div>';
                                        $assign_dataa .='<div class="row cf-couse-slcon">';
                                            if(!empty($i_res_u)){ $assign_dataa .= '<div class="col-md-6">'.$i_res_u.'</div>';}
                                            if(!empty($s_res_u)){ $assign_dataa .= '<div class="col-md-6">'.$s_res_u.'</div>';}
                                            $assign_dataa .='</div>';
                                $assign_dataa .='</div>';
                    if( !empty($i_res_u) || !empty($ivu) || !empty($svu) || !empty($s_res_u) || !empty($inst_instructions) )
                    {
                        $o_des.=$assign_dataa;

                    }

                }
                else if( $o_type == "lecture" )
                {
                    $title = '<span class="cf-course-sltcou"> Lecture <span class="cf-cc-mcon-cont">'.$c.'</span>:  </span>';
                    $action ='<div class="cf-course-opact"> 2000 views </div>';
                    $about = '<h5 class="font-weight-bold">About This Lecture </h5>';
                }

                if($type=="title")
                {
                    $htmCon .='
                    <div class="cf-course-slti px-1 py-2 pb-2 px-sm-0">
                         '.$title.'<span class="cf-course-clttext"> '.$o_title.' <span>
                    </div><div class="d-flex justify-content-between"><div>';
                    $g_like_enable = get_option('disable_like');
                    if($g_like_enable == false || $g_like_enable == -1 ):
                        if( $status['status']==0 ):
                            $htmCon .='<div class="mx-2 mb-3">
                                            <a class="cf-course-li-dlike " id="cf-course--thumbs-up-like"> <i class="far fa-thumbs-up"></i> </a>
                                            <a class="cf-course-li-dlike " id="cf-course--likes">'.$lecture_ob->show_total_likes($c_id,$op_id).'</a>
                                            <a class=" cf-course-li-dlike" id="cf-course--dislikes">'.$lecture_ob->show_total_dislikes($c_id,$op_id).'</a>
                                            <a class="cf-course-li-dlike " id="cf-course--thumbs-up-dislike"> <i class="far fa-thumbs-up"></i> </a>
                                        </div>';
                        endif;
                    endif;
                    $htmCon .='</div><div>';
                    if($review_status==="no"):
                        $htmCon .='<div class="cf-course-all-ratin">
                            <button class="cf-course-middle-rating btn btn-primary"><i class="fas fa-star"></i><span class="pl-2">Leave a rating</span></button>
                        </div>';
                    endif;
                    $htmCon .='</div></div>';

                }else if($type=="desc")
                {
                    $des_len = strip_tags($o_des);
                    if( strlen( $des_len ) >500 )
                    {
                        $class="cf-course-assign-ada-ans-h";
                        $button='<a href="javascript:void(0)" class="d-inline-block  cf-course-assign-ada-btn">Read More</a>';
                    }else{
                        
                        $class  = '';
                        $button = '';
                    }
                    $htmCon.='<div class="cf-course-content px-3 pt-5">'.$about.'</div><hr />';
                    $htmCon.='<div class="cf-course-sltdec cf-course-read-more-des position-relative c--cf-l-des py-2  px-3">
                        <div class="cf-couse-slcon py-2 '.$class.'  c--cf-l-des ">
                            '.$o_des.'
                        </div>
                        '.$button.'
                    </div><hr />';
                }

            }
            return $htmCon;
        }//end of function

        // this function will return all details of content
        function getContentDetails( $oid, $cid,$get_only=false )
        {
            global $mysqli;
            global $dbpref;
            $op_id      = $mysqli->real_escape_string( $oid );
            $c_id      = $mysqli->real_escape_string( $cid);
            $table     = $dbpref."content_options";
            if($get_only)
            {
                $qr   = "SELECT `".$get_only."` FROM `".$table."` WHERE `course_id`=$c_id  AND  `id`=".$op_id;
            }else{
                $qr   = "SELECT * FROM `".$table."` WHERE `course_id`=$c_id  AND  `id`=".$op_id;
            }
            $cresult   = $mysqli->query( $qr );
            if( $cresult->num_rows > 0 )
            {
                $o_data     = $cresult->fetch_assoc();
                return $o_data;
            }
        }

        // this function will return description of content
        function getContentTitle( $oid, $cid )
        {
            global $mysqli;
            global $dbpref;
            $opid      = $mysqli->real_escape_string( $oid );
            $c_id      = $mysqli->real_escape_string( $cid );
            $table     = $dbpref."content_options";
            $qr        = "SELECT `title` FROM `".$table."` WHERE `course_id`=$c_id  AND  `id`=".$opid;
            $cresult   = $mysqli->query( $qr );
            if( $cresult->num_rows > 0 )
            {
                $c_data     = $cresult->fetch_assoc();
                $c_title    = stripcslashes( trim( stripcslashes( base64_decode($c_data['title'])),"\r\n")  );
                return $c_title;
            }
        }
        // this function will return title  of content
        function getContentDescription( $oid, $cid )
        {
            global $mysqli;
            global $dbpref;
            $opid      = $mysqli->real_escape_string( $oid );
            $c_id      = $mysqli->real_escape_string( $cid );
            $table     = $dbpref."content_options";
            $qr        = "SELECT `description` FROM `".$table."` WHERE `course_id`=$c_id  AND  `id`=".$opid;
            $cresult   = $mysqli->query( $qr );
            if( $cresult->num_rows > 0 )
            {
                $c_data     = $cresult->fetch_assoc();
                $c_desc    = stripcslashes( trim( stripcslashes( base64_decode($c_data['description'])),"\r\n")  ) ;
                return $c_desc;
            }
        }
        function getLectureHeader( $oid, $count ,$take,$type="" )
        {

            global $mysqli;
            global $dbpref;
            $opid      = $mysqli->real_escape_string( $oid );
            $table     = $dbpref."content_options";
            $qr        = "SELECT * FROM `".$table."` WHERE  `id`=".$oid;
            $oresult   = $mysqli->query( $qr );
            $htmCon ='';
            if( $oresult->num_rows > 0 )
            {
                $o_data     = $oresult->fetch_assoc();
                $op_id      = $o_data['id'];
                $s_id       = $o_data['section_id'];
                $c_id       = $o_data['course_id'];
                $o_tit    = stripcslashes( trim( stripcslashes( base64_decode($o_data['title'])),"\r\n")  ) ;
                $o_des      = stripcslashes( trim(stripcslashes(base64_decode($o_data['description'])),"\r\n") ) ;
                $o_title    = ( ( strlen( $o_tit ) > 80) ? substr( $o_tit,0, 80 ).'...' : $o_tit );
                $o_type     = $o_data['option_type'];
                $c_type     = $o_data['content_type'];

                if($take=="all")
                {
                    if( $o_type == "quiz" )
                    {
                        $title = '<span class="cf-course-sltcou b--cf-sltcou c--cf-sltcou d--cf-sltcou e--cf-sltcou"> Quiz <span class="cf-cc-mcon-cont"></span>:  </span>';
                        $action ='<div class="cf-course-opact"> 2 participated </div>';
                    }
                    else if( $o_type == "assign" )
                    {
                        $title = '<span class="cf-course-sltcou b--cf-sltcou c--cf-sltcou d--cf-sltcou e--cf-sltcou"> Assignment <span class="cf-cc-mcon-cont"></span>:  </span>';
                        $action ='<div class="cf-course-opact"> 2 participated </div>';
                    }
                    else if( $o_type == "lecture" )
                    {
                        $title = '<span class="cf-course-sltcou b--cf--sltcou c--cf-sltcou d--cf-sltcou e--cf-sltcou"> Lecture <span class="cf-cc-mcon-cont"</span>:  </span>';
                        $action ='<div class="cf-course-opact"> 2000 views </div>';
                    }
                    else if( $o_type == "test" )
                    {
                        $title = '<span class="cf-course-sltcou b--cf-sltcou c--cf-sltcou d--cf-sltcou e--cf-sltcou"> Test <span class="cf-cc-mcon-cont"></span>:  </span>';
                        $action ='<div class="cf-course-opact"> 2 participated </div>';
                    }
                    $htmCon .='
                    <div class="cf-course-slti px-1 px-sm-0">
                        '.$title.'<span class="cf-course-clttext b--cf--clttext c--cf--clttext d--cf--clttext e--cf--clttext"> '.$o_title.' <span>
                    </div>';
                }elseif( $take =="one" ){
                    if( $o_type == "quiz" ){ $title = '<span class="font-weight-bold text-primary" >Quiz: </span>'; }
                    else if( $o_type == "assign" ){$title = '<span  class="font-weight-bold text-primary" > Assignment: </span>';}
                    else if( $o_type == "test" ){ $title = '<span  class="font-weight-bold text-primary" > Test: </span>'; }
                    else if( $o_type == "lecture" ){$title = '<span  class="font-weight-bold text-primary" > Lecture: </span>';}
                    $htmCon .='
                    <div class="">
                        '.$title.'<span > '.$o_title.' <span>
                    </div>';
                }
            }
            return $htmCon;
        }//end of function

       

        //this function is just to collect important data from 1st row
        function showDripLocks( $member_id, $c_id)
        {
                global $mysqli;
                global $dbpref;
                $table_drip=$dbpref."member_drip";
                $table_section=$dbpref."section";
                $sql_drip="SELECT * FROM `".$table_drip."` WHERE course_id= ".$c_id." and member_id= ".$member_id." ORDER BY `id` ASC limit 1";
                $result_drip=$mysqli->query($sql_drip);
                return $result_drip;
        }

        public function getCourseData( $sresult, $c_id )
        {
            global $mysqli;
            global $dbpref;
            $course_content = [];
            
            while( $sr = $sresult->fetch_assoc() )
            {
                $s_title    = htmlentities(stripcslashes( trim( stripcslashes(base64_decode($sr['title'])),"\r\n")  ));
                $s_id       = $sr['id'];
                $table      = $dbpref."content_options";
                $qr         = "SELECT * FROM `".$table."` WHERE `course_id`=$c_id AND `section_id`=$s_id ORDER BY `display_order` ASC ";
                $oresult    = $mysqli->query( $qr );
                if( $oresult->num_rows > 0 )
                {
                    while( $o_data = $oresult->fetch_assoc() )
                    {
                        $op_id  = $o_data['id'];
                        $s_id   = $o_data['section_id'];
                        $c_id   = $o_data['course_id'];
                        $type   = $o_data['option_type'];
                        if( $type == "lecture" )
                        {
                            $course_content[] = ['course_id'=>$c_id,"section_id"=>$s_id, "option_id"=>$op_id ,"option_type"=> "lecture" ];

                        }else if( $type == "quiz" ){

                            $course_content[] = ['course_id'=>$c_id,"section_id"=>$s_id, "option_id"=>$op_id ,"option_type"=> "quiz" ];

                        }else if( $type == "assign" )
                        {
                            $course_content[] = ['course_id'=>$c_id,"section_id"=>$s_id, "option_id"=>$op_id ,"option_type"=> "assignment"];
                        }
                        else if( $type == "test" )
                        {
                            $course_content[] = ['course_id'=>$c_id,"section_id"=>$s_id, "option_id"=>$op_id ,"option_type"=> "test"];
                        }
                    }
                   
                }

            }
           return $course_content;
        }
        /* theme a button */ 
        public function NextPrevA( $sresult, $c_id, $mem_id, $action,$option_id=0 )
        {
            $htmCon = '';
            global $mysqli;
            global $dbpref;
            $o_datas = self::getCourseData( $sresult, $c_id );
            $o_conunt= count( $o_datas )-1;
            
            $progress = self::getProgress($mem_id, $c_id );
            if($progress==100)
            {
                $style="style='display:block'";
            }else{
                $style="style='display:none'";
            }

            foreach( $o_datas as $o_key => $o_data )
            {
                $op_id  = $o_data['option_id'];
                $s_id   = $o_data['section_id'];
                $type   = $o_data['option_type'];

               if( $action == "start" )
                {
                    if(isset($_GET['page']) && $_GET['page']=="cfcourse_preview" )
                    {
                        $url1  =   base64_encode(json_encode([ "admin"=>"is_admin","course_id"=>$c_id ] ));
                        $url  =  base64_encode(json_encode([ "course_id"=>$c_id,"section_id"=>$s_id,"type"=>$type,"option_id"=>$op_id,"count"=>$count,"d_id"=>0 ]));
                        $preview_url = "?page=cfcourse_preview&cfapreview=".$url1."&cf_vid=".$url;
                        
                        if(!isset($_GET['gmailloadtemplate'])){
                        header("Location:".$preview_url.""); 
                        break; 
                        }
 
                    }
                    else{
                        $url  =  base64_encode(json_encode([ "course_id"=>$c_id,"section_id"=>$s_id,"type"=>$type,"option_id"=>$op_id,"count"=>$count,"d_id"=>0 ]));
                        $course_url=$course_url."?cf_vid=".$url;
                        if(!isset($_GET['gmailloadtemplate'])){
                            header("Location:".$course_url.""); 
                            break; 
                        }
                    } 
                }
                else if( $action == "no" )
                {
                    if( $op_id  ==  $option_id )
                    {
                        if( $o_key == $o_conunt )
                        { 
                            if( $o_conunt == 0 )
                            {
                                $url    = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
                                if(isset($_GET['apreview']))
                                {
                                    $query_url       =  base64_encode(json_encode([ "admin"=>"is_admin","course_id"=>$c_id ] ));
                                    $url_arr = parse_url($url);
                                    $query = $url_arr['query'];
                                    $url = str_replace(array($query,'?'), '', $url);
                                    $new_url = $url."?apreview=".$query_url;
                                   
                                    $htmCon.='
                                        <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn btn-primary btn-sm text-white cf-course--st-course "><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        ';
                                }else{
                                    $htmCon.='
                                    <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn btn-primary btn-sm text-white cf-course--st-course "><i class="fas fa-certificate"></i> Download Certificate  </button>
                                    </div>
                                    ';
                                }
                                    break;
                            }else{
                                $prev_arr = self::getAdjascentKey( $o_key, $o_datas, -1 );
                                $htmCon.='
                                <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn btn-primary text-white cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        <div class="mx-2">
                                            <a class="btn  btn-primary text-white cf-course--st-course  " data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'" ><i class="fas fa-backward"></i> <span class="cf-course-hide-inline">Prev </span>  </a>
                                        </div>';
                                    break;
                            }

                        }else{
                            if( $o_key == 0 )
                            {
                                $url    = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
                                $url_arr = parse_url($url);
                                $query = $url_arr['query'];
                                $new_url = str_replace(array($query,'?'), '', $url);
                                $prev_arr = self::getAdjascentKey( $o_key, $o_datas, +1 );

                                if(isset($_GET['apreview']))
                                {
                                    $query_url       =  base64_encode(json_encode([ "admin"=>"is_admin","course_id"=>$c_id ] ));
                                    $admin_url = $new_url."?apreview=".$query_url;
                                   
                                    $htmCon.='
                                    <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn btn-primary text-white cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        <div class="mx-2">
                                            <a class="btn btn-primary text-white cf-course--st-course btn-sm cf-course--st-cnext" data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'" > <span class="cf-course-hide-inline"> Next </span> <i class="fas fa-forward"></i></a>
                                        </div>';
                                }else{
                                    $htmCon.='
                                        <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn btn-primary text-white cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        <div class="mx-2">
                                            <a class="btn btn-primary text-white btn-sm cf-course--st-course btn-sm cf-course--st-cnext" data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'" > <span class="cf-course-hide-inline"> Next </span> <i class="fas fa-forward"></i></a>
                                        </div>';
                                }
                                break;
                            }else if( $o_key > 0 ){
                                $prev_arr = self::getAdjascentKey( $o_key, $o_datas, -1 );
                                $next_arr = self::getAdjascentKey( $o_key, $o_datas, +1 );
                                $htmCon.='
                                    <div class="mx-2 cf-cirt-download">
                                        <button '.$style.' type="button" class="btn btn-primary text-white cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                    </div>
                                    <div class="mx-2">
                                        <a class="btn btn-primary text-white btn-sm cf-course--st-course " data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'"  ><i class="fas fa-backward"></i>  <span class="cf-course-hide-inline"> Prev </span></a>
                                    </div>
                                    <div class="mx-2">
                                        <a class="btn btn-primary text-white  cf-course--st-course btn-sm cf-course--st-cnext" data-type="'.$next_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$next_arr['section_id'].'" data-oid="'.$next_arr['option_id'].'" data-cid="'.$c_id.'"   > <span class="cf-course-hide-inline"> Next </span> <i class="fas fa-forward"></i></a>
                                    </div>';
                                break;
                            }else{

                            }
                        }
                    }
                }
            }
            return $htmCon;
        }
        /* theme a button end */ 

        /* theme b button start */ 
        public function NextPrevB( $sresult, $c_id, $mem_id, $action,$option_id=0 )
        {
            $htmCon = '';
            global $mysqli;
            global $dbpref;
            $o_datas = self::getCourseData( $sresult, $c_id );
            $o_conunt= count( $o_datas )-1;
            
            $progress = self::getProgress($mem_id, $c_id );
            if($progress==100)
            {
                $style="style='display:block'";
            }else{
                $style="style='display:none'";
            }

            foreach( $o_datas as $o_key => $o_data )
            {
                $op_id  = $o_data['option_id'];
                $s_id   = $o_data['section_id'];
                $type   = $o_data['option_type'];

               if( $action == "start" )
                {
                    if(isset($_GET['page']) && $_GET['page']=="cfcourse_preview" )
                    {
                        $url1  =   base64_encode(json_encode([ "admin"=>"is_admin","course_id"=>$c_id ] ));
                        $url  =  base64_encode(json_encode([ "course_id"=>$c_id,"section_id"=>$s_id,"type"=>$type,"option_id"=>$op_id,"count"=>$count,"d_id"=>0 ]));
                        $preview_url = "?page=cfcourse_preview&cfapreview=".$url1."&cf_vid=".$url;
                        
                        if(!isset($_GET['gmailloadtemplate'])){
                        header("Location:".$preview_url.""); 
                        break; 
                        }
 
                    }
                    else{
                        $url  =  base64_encode(json_encode([ "course_id"=>$c_id,"section_id"=>$s_id,"type"=>$type,"option_id"=>$op_id,"count"=>$count,"d_id"=>0 ]));
                        $course_url=$course_url."?cf_vid=".$url;
                        if(!isset($_GET['gmailloadtemplate'])){
                            header("Location:".$course_url.""); 
                            break; 
                        }
                    } 
                }
                else if( $action == "no" )
                {
                    if( $op_id  ==  $option_id )
                    {
                        if( $o_key == $o_conunt )
                        { 
                            if( $o_conunt == 0 )
                            {
                                $url    = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
                                if(isset($_GET['apreview']))
                                {
                                    $query_url       =  base64_encode(json_encode([ "admin"=>"is_admin","course_id"=>$c_id ] ));
                                    $url_arr = parse_url($url);
                                    $query = $url_arr['query'];
                                    $url = str_replace(array($query,'?'), '', $url);
                                    $new_url = $url."?apreview=".$query_url;
                                   
                                    $htmCon.='

                                        <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn  cf--c--sb  btn-sm text-white cf-course--st-course "><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        ';
                                }else{
                                    $htmCon.='

                                    <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn cf--c--sb btn-sm text-white cf-course--st-course "><i class="fas fa-certificate"></i> Download Certificate  </button>
                                    </div>
                                    ';
                                }
                                    break;
                            }else{
                                $prev_arr = self::getAdjascentKey( $o_key, $o_datas, -1 );
                                $htmCon.='
                                <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn text-white cf--c--sb cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        <div class="mx-2">
                                            <a class="btn   cf--c--sb text-white cf-course--st-course btn-sm " data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'" ><i class="fas fa-backward"></i> <span class="cf-course-hide-inline"> Prev </span>  </a>
                                        </div>';
                                    break;
                            }

                        }else{
                            if( $o_key == 0 )
                            {
                                $url    = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
                                $url_arr = parse_url($url);
                                $query = $url_arr['query'];
                                $new_url = str_replace(array($query,'?'), '', $url);
                                $prev_arr = self::getAdjascentKey( $o_key, $o_datas, +1 );

                                if(isset($_GET['apreview']))
                                {
                                    $query_url       =  base64_encode(json_encode([ "admin"=>"is_admin","course_id"=>$c_id ] ));
                                    $admin_url = $new_url."?apreview=".$query_url;
                                   
                                    $htmCon.='
                                    <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn  cf--c--sb text-white cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        <div class="mx-2">
                                            <a class="btn  cf--c--sb text-white cf-course--st-course btn-sm cf-course--st-cnext" data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'" > <span class="cf-course-hide-inline"> Next </span> <i class="fas fa-forward"></i></a>
                                        </div>';
                                }else{
                                    $htmCon.='
                                        <div class="mx-2 cf-cirt-download">
                                            <button '.$style.' type="button" class="btn  cf--c--sb text-white cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                        </div>
                                        <div class="mx-2">
                                            <a class="btn  cf--c--sb text-white cf-course--st-course btn-sm cf-course--st-cnext" data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'" > <span class="cf-course-hide-inline"> Next </span> <i class="fas fa-forward"></i></a>
                                        </div>';
                                }
                                break;
                            }else if( $o_key > 0 ){
                                $prev_arr = self::getAdjascentKey( $o_key, $o_datas, -1 );
                                $next_arr = self::getAdjascentKey( $o_key, $o_datas, +1 );
                                $htmCon.='
                                    <div class="mx-2 cf-cirt-download">
                                        <button '.$style.' type="button" class="btn  cf--c--sb text-white cf-course--st-course btn-sm"><i class="fas fa-certificate"></i> Download Certificate  </button>
                                    </div>
                                    <div class="mx-2">
                                        <a class="btn  cf--c--sb text-white cf-course--st-course btn-sm" data-type="'.$prev_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$prev_arr['section_id'].'" data-oid="'.$prev_arr['option_id'].'" data-cid="'.$c_id.'"  ><i class="fas fa-backward"></i> <span class="cf-course-hide-inline"> Prev </span> </a>
                                    </div>
                                    <div class="mx-2">
                                        <a class="btn  cf--c--sb text-white cf-course--st-course btn-sm cf-course--st-cnext" data-type="'.$next_arr['option_type'].'" data-mid="'.$mem_id.'" data-sid="'.$next_arr['section_id'].'" data-oid="'.$next_arr['option_id'].'" data-cid="'.$c_id.'"   > <span class="cf-course-hide-inline"> Next </span> <i class="fas fa-forward"></i></a>
                                    </div>';
                                break;
                            }else{

                            }
                        }
                    }
                }
            }
            return $htmCon;
        }
        /* theme b button end */ 

        public function getAdjascentKey( $key, $hash = array(), $increment ) {
            $keys = array_keys( $hash );    
            // print_r( $hash );
            $found_index = array_search( $key, $keys );
            if ( $found_index === false ) {
                // echo $found_index;
                return false;
            }
            $newindex = $found_index + $increment;
            // echo $newindex;
            $re = ( $newindex >= 0 && $newindex < count( $hash ) ) ? $hash[ $newindex ] : false;
            return $re;
        
        }

        //this function will add drip feed data into the table
        function addDripFeedData($member_id,$c_id){
                global $mysqli;
                global $dbpref;
                $table_all_products= $dbpref."all_products";
                $table_drip=$dbpref."member_drip";
                $table_section=$dbpref."section";
                $sql_drip="SELECT * FROM `".$table_drip."` WHERE course_id= ".$c_id." and member_id= ".$member_id;
                $result_drip=$mysqli->query($sql_drip);
                if($result_drip->num_rows === 0)
                {
                $sql_product="SELECT * FROM `".$table_all_products."` WHERE id= ".$c_id."";
                $result_product=$mysqli->query($sql_product);
                if($result_product->num_rows>0)
                 { 
                    if($row = $result_product->fetch_assoc() )
                    {
                        $drip_on_off=$row['drip_on_off'];
                        $drip_days=$row['drip_days'];
                    }
                }
                if($drip_on_off!=NULL && $drip_on_off!=0)
                {
                $sql_sec="SELECT * FROM `".$table_section."` WHERE course_id= ".$c_id." ORDER BY `display_order` ASC";
                $result=$mysqli->query($sql_sec);
                $arr=[];
                if($result->num_rows>0)
                 { $add_times=date("Y-m-d",time());
                    while($row = $result->fetch_assoc() )
                    {
                    $section_id=$row['id'];  $locked=1;
                    
                    
                    $sql="INSERT INTO `".$table_drip."`(`course_id`, `section_id`, `member_id`,`locked`,`drip_on_off`,`drip_days`, `created_at`) VALUES (".$c_id.",".$section_id.",".$member_id.",".$locked.",".$drip_on_off.",".$drip_days.",'".$add_times."')";
                    $mysqli->query($sql);
                    $add_times=date('Y-m-d', strtotime($add_times. ' + '.$drip_days.' days'));
                    }
                 }
                }
                }
                else {
                    //It is already entered
                }
        }//end of function.

        public function addRating($data)
        {
            global $mysqli;
            global $dbpref;
            $rating_table= $dbpref."course_review";
            $cid   = (int) cf_enc( $mysqli->real_escape_string( trim( $data['cid'] ) ),"decrypt" );
            $mid   = (int)cf_enc( $mysqli->real_escape_string( trim( $data['mid'] ) ),"decrypt" );
            $rating   =  isset( $data['rating'] )?$data['rating']:"4.5";
            $rating  = $mysqli->real_escape_string($rating);
            $summery   =  $mysqli->real_escape_string( trim( $data['summery'] ) );
            
            $quiz_ob= $this->loader->load("quiz_stud_control");
            $mem_data = $quiz_ob->checkIfIsAdmin( $mid );

            $mid = $mem_data['mid'];
            $email = $mem_data['email'];
            $name = $mem_data['name'];
            $is_ad = $mem_data['is_ad'];

            $r_appr=1;
            $time    =  date("Y-m-d H:i:s");
            $sql="SELECT * FROM `".$rating_table."` WHERE `member_id`=$mid AND `course_id`=$cid";
            $fetch_row = $mysqli->query( $sql );
            if( $fetch_row->num_rows > 0 )
            {
                $sql2="UPDATE `".$rating_table."` SET `rating`=$rating   WHERE `member_id`= $mid AND `course_id`= $cid";

            }else{
                $sql2="INSERT INTO `".$rating_table."`(`course_id`, `member_id`, `name`, `email`, `rating`, `summary`, `is_admin`, `approved`, `added_on`) VALUES ($cid,$mid,'".$name."','".$email."',$rating,'".$summery."',$is_ad,$r_appr,'".$time."')";
              
            }
            $true = $mysqli->query( $sql2 )?1:-1;
            if( $true )
            {
                echo json_encode( array( "status"=>1, "data" => "added successfull") );
                if( get_option('reply_review_email') && get_option('reply_review_email')==1 )
                {
                 self::sendReviewEmail( $name,$cid );
                }
              
            }else{
                echo json_encode( array( "status"=>1, "data" => "not added successfull") );
            }
            die();

        }
        function sendReviewEmail($name, $course_id )
        {
            $t = self::get_course_by_id( $course_id,'title');
            $email_body="<p>Hello,</p>";
            $bottom_line = "<p>Thanks </p><p>CourseFunnels</p>";
            $com_email = get_option("communication_email");
            $subject = "(CourseFunnels) Rating Notification";
            $email_body="";
            $newurl = get_option("install_url")."?page=cfcourse_manage_review&cfcourse_id=".$course_id;
            $email_body.="<p>I hope you’re having a great week. <strong>".$name."</strong> 
            has given a rating on the <strong>".$t['title']."</strong> course.</p>";
            $email_body.="<p><a target='_blank' href='".$newurl."'>See rating</a> </p>";
            $email_body.= "<p>Thanks </p><p>CourseFunnels</p>";
            $email_data=[
                "",
                "name"=>"",
                "email"=>$com_email,
                "subject"=>$subject,
                "body"=>$email_body
            ];
            $sends_email =cf_mail($email_data);
        }
        public function getRatingStatus($cid,$mid)
        {

            global $mysqli;
            global $dbpref;
            $rating_table= $dbpref."course_review";
            $quiz_ob= $this->loader->load("quiz_stud_control");
            $mem_data = $quiz_ob->checkIfIsAdmin( $mid );
            $mid = $mem_data['mid'];
            $sql="SELECT * FROM `".$rating_table."` WHERE `member_id`=$mid AND `course_id`=$cid";
            $row = $mysqli->query( $sql );
            if( $row->num_rows > 0 )
            {
                return "yes";
            }else{
                return "no";
            }
        }
        function getProgress($mid, $cid )
        {
            global $mysqli;
            global $dbpref;
            $m_id = $mysqli->real_escape_string( $mid );
            $c_id = $mysqli->real_escape_string( $cid );
            $table = $dbpref."content_options";
            $qr1 = "SELECT COUNT(*) AS 'total_content' FROM `".$table."` WHERE `course_id`=".$c_id;
            $row = $mysqli->query( $qr1 );
            if( $row->num_rows > 0 )
            {
                $data = $row->fetch_assoc();
                $alllecture_count = $data['total_content'];
                $totol_progress = self::getWatched( $m_id, $c_id );
                $cfCoursePrgrs = floor( ( $totol_progress/$alllecture_count )*100 );
                return $cfCoursePrgrs;
            }
            return 0;
        }
        public function getExamStatus( $type,$mem_id,$content_id )
        {
            global $mysqli;
            global $dbpref;
            $mem_id=$mysqli->real_escape_string( $mem_id );
            $type=$mysqli->real_escape_string( $type );
            $content_id=$mysqli->real_escape_string( $content_id );
            if($type=="assign"  ||$type=="test" )
            {
                $table=$dbpref."stud_assignment";
                $sql = "SELECT * FROM `".$table."` WHERE `assign_id`=$content_id AND `member_id`=".$mem_id;
            }else if($type=="quiz")
            {
                $table=$dbpref."stud_quiz";
                $sql = "SELECT * FROM `".$table."` WHERE `quiz_id`=$content_id AND `member_id`=".$mem_id;
            }
            $qry = $mysqli->query($sql);
            $r=[];
            if($qry->num_rows>0)
            {
                while($data=$qry->fetch_assoc())
                {
                    $r=$data;
                }
            }

            return $r;
        }
        function isResultPublished( $id , $mid, $type )
        {
            global $mysqli;
            global $dbpref;
            $id = $mysqli->real_escape_string( $id );
            $mid = $mysqli->real_escape_string( $mid );
            $type = $mysqli->real_escape_string( $type );
            $content_table = $dbpref."content_options";
            $member_id= 0;

            $quiz_ob= $this->loader->load("quiz_stud_control");
            
            $mem_data = $quiz_ob->checkIfIsAdmin( $mid );
            $member_id = $mem_data['mid'];
            
            if( $type=="assign" )
            {
                $table = $dbpref."stud_assignment";
                $sql="SELECT `result_out_date`,`checked` FROM `".$table."` WHERE `assign_id`=$id AND `type`='assign' AND `member_id`=".$member_id." order by `id` desc limit 1";
  
            }
            elseif( $type=="test" )
            {
                $table = $dbpref."stud_assignment";
                $sql="SELECT `result_out_date`,`checked` FROM `".$table."` WHERE `assign_id`=$id AND `type`='test' AND `member_id`=".$member_id." order by `id` desc limit 1";
  
            }
            elseif( $type=="quiz" )
            {
                $table = $dbpref."stud_quiz";
                $sql="SELECT `result_out_date`,`checked` FROM `".$table."` WHERE `quiz_id`=$id AND `member_id`=".$member_id." order by `id` desc limit 1";
            }
            $delay_days=0;
            $admin_check=0;
            $no_of_days = 0;
            $checked = 0;
            $sql1=$mysqli->query("SELECT `delay_result`,`admin_check` FROM `".$content_table."` WHERE `id`=$id");
            if( $sql1->num_rows > 0 )
            {
                $data = $sql1->fetch_assoc();
                $delay_days = $data['delay_result'];
                $admin_check = $data['admin_check'];
            }
            $qry = $mysqli->query($sql);
            if($qry->num_rows>0)
            {
  
                $add_times_ser = date("d-M-Y",time());//GET TODAY DATE
                $r= $qry->fetch_object();
                $result_out_date=$r->result_out_date;
                $diff = strtotime($add_times_ser) - strtotime($result_out_date);
                $diff=round($diff / 86400);
                $no_of_days= $diff*(-1);//to change the sign
                $checked= $r->checked;
            }

            if( $admin_check )
            {
                if($qry->num_rows>0)
                {
                    if($checked)
                    {
                        if($delay_days==0)
                        {
                            return true;

                        }else{
                            if( $no_of_days <= 0 ) // this one is correct .. if($no_of_days>0)
                            {
                                return true;
                            }
                        } 
                    }
                }
                return false;

            }else{
                if($qry->num_rows>0)
                {
                    if( $type=="assign" || $type=="test" )
                    {
                        if($checked)
                        {
                            if($delay_days==0)
                            {
                                return true;

                            }else{
                                if( $no_of_days <= 0 ) // this one is correct .. if($no_of_days>0)
                                {
                                    return true;
                                }
                            } 
                        }

                    }else{
                        if($delay_days==0)
                        {
                            return true;

                        }else{
                            if( $no_of_days <= 0 ) // this one is correct .. if($no_of_days>0)
                            {
                                return true;
                            }
                        }
                    }
                }
            }
            return false;
        }
    }
}
?>