<?php

$cf_course_timezone = get_option("cf_course_timezone");

if( $cf_course_timezone !=="" && !empty($cf_course_timezone) )
{
	date_default_timezone_set( $cf_course_timezone );
}
if( !defined("COURSE_PLUGIN_DIR_PATH")  )
{
	define( "COURSE_PLUGIN_DIR_PATH", plugin_dir_path( __FILE__ ) );
}
if( !defined("COURSE_PLUGIN_URL") )
{
	define("COURSE_PLUGIN_URL", plugins_url( )."cf_course");
}

if(!class_exists('CFcourse_base'))
{
	require_once('controller/controller.php');
	class CFcourse_base extends CFcourse_controller
	{
		var $pref='cfcourse_';
		var $config=false;
		function __construct()
		{	
			parent:: __construct();
			self::getConfig();
			self::createMenu();
			self::takleAjaxRequest();
			self::createShortCode();
			self::desolveCertPosts();
			self::addLanguage();
			self::generateLanguage();
			//admin_headers
			add_action('admin_head',function(){
				self::loadScripts();
				self::addScriptsinSiglePage();

			});  

			add_action('cf_head',function(){
				self::loadCSSinFront();
				
			});
			add_filter('the_content', function( $content, $args){
				
				if( $args['is_membership'] == "membership" )
				{
					global $mysqli;
					$course_data='';
					$category = $args['category'];
				
					if( $category == "course" )
					{
						$main_screen_ob  =  $this->load('course_control');
						$question_ob     =  $this->load('quiz_questions_control');
						$quiz_stud_ob    =  $this->load('quiz_stud_control');
						$assign_stud_ob  =  $this->load('assign_stud_control');
						$assignment_ob   =  $this->load('assignment_control');
						$lecture_ob      =  $this->load("lecture");
						$cirtificate_ob  =  $this->load('cirtificate_manager');
						$funnel_id = $args['funnel_id'];
						$course_id = $args['product'];
						$loggedin = is_member_loggedin( $funnel_id);
						if( $loggedin==1)
						{
							$cirtificate_ob->export($funnel_id, $course_id);
								
							$mdata = get_current_member( $funnel_id);
							ob_start();
							$main_screen_ob->getMainScreeUI(  $course_id,  $mdata, $question_ob, $quiz_stud_ob , $lecture_ob , $assign_stud_ob,$assignment_ob,"s" );
							$course_data=ob_get_clean();
							if( strpos( $content, '{@-course-@}') !==false )
							{
								$content= str_replace('{@-course-@}', $course_data, $content);
							}
							else
							{
								$content .= $course_data;
							}
						}
					}else if( $category == "membership" )
					{
						$member_script = "<script src='".COURSE_PLUGIN_URL."/assets/js/member_script.js' ></script>";
						$content .=$member_script;
						
					}
					
				}
				return $content;
			});
			
			add_action('cf_footer',function($a, $b ){

				if( $a['is_membership'] == "membership" )
				{
					$category = $a['category'];
					$product  = intval( $a['product'] );
					if(isset($_GET['cfapreview']) )
					{
						self::loadJSinFront("a");
						
					}elseif( $category=="course" ){
						self::loadJSinFront("s");
					}
				}else{
					echo "<script src='".COURSE_PLUGIN_URL."/assets/js/jquery.star-rating-svg.js' ></script>";
				}
			});

			if(isset($_GET['page']) && in_array($_GET['page'],array('cfcourse_all_course','cfcourse_quiz_response', 'cfcourse_notes','cfcourse_manage_memebr', 'course_setting','cfcourse_manage_comment','cfcourse_assignment','cfcourse_test','cfcourse_manage_review','cfcourse_create_review','cfcourse_manage_notes','cfcourse_view_assignment','cfcourse_view_quiz','cfcourse_manage_lecture','cfcourse_popup_course','cfcourse_manage_course','cfcourse_manage_quiz','cfcourse_assign_response','cfcourse_manage_assignment','cfcourse_manage_test', 'cfcourse_manage_certificates') ))
            {
				add_action("admin_head", [ $this,"addStyle" ] );
				add_action("admin_footer",[ $this, "addScript" ] );
			}

		}

		function addLanguage()
		{
			$file = COURSE_PLUGIN_DIR_PATH."/assets/lang/hindi_hi.json";
			$file1 = COURSE_PLUGIN_DIR_PATH."/assets/lang/arabic_ar.json";
			$file2 = COURSE_PLUGIN_DIR_PATH."/assets/lang/danish_da.json";
			$file4 = COURSE_PLUGIN_DIR_PATH."/assets/lang/dutch_nl.json";
			$file5 = COURSE_PLUGIN_DIR_PATH."/assets/lang/english_en.json";
			$file6 = COURSE_PLUGIN_DIR_PATH."/assets/lang/french_fr.json";
			$file7 = COURSE_PLUGIN_DIR_PATH."/assets/lang/german_de.json";
			$file8 = COURSE_PLUGIN_DIR_PATH."/assets/lang/greek_gr.json";
			$file9 = COURSE_PLUGIN_DIR_PATH."/assets/lang/italian_itl.json";
			$file10 = COURSE_PLUGIN_DIR_PATH."/assets/lang/japanese_ja.json";
			$file11 = COURSE_PLUGIN_DIR_PATH."/assets/lang/korean_ko.json";
			$file12 = COURSE_PLUGIN_DIR_PATH."/assets/lang/malay_ml.json";
			$file13 = COURSE_PLUGIN_DIR_PATH."/assets/lang/norwegian_no.json";
			$file14 = COURSE_PLUGIN_DIR_PATH."/assets/lang/polish_pl.json";
			$file15 = COURSE_PLUGIN_DIR_PATH."/assets/lang/portuguese_po.json";
			$file16 = COURSE_PLUGIN_DIR_PATH."/assets/lang/romanian_ro.json";
			$file17 = COURSE_PLUGIN_DIR_PATH."/assets/lang/spanish_sp.json";
			
			register_custom_lang(array(
				"lang_hindi_hi"=>array('file'=>$file),
				"lang_arabic_ar"=>array('file'=>$file1),
				"lang_danish_da"=>array('file'=>$file2),
				"lang_dutch_nl"=>array('file'=>$file4),
				"lang_english_en"=>array('file'=>$file5),
				"lang_french_fr"=>array('file'=>$file6),
				"lang_german_de"=>array('file'=>$file7),
				"lang_greek_gr"=>array('file'=>$file8),
				"lang_italian_itl"=>array('file'=>$file9),
				"lang_japanese_ja"=>array('file'=>$file10),
				"lang_korean_ko"=>array('file'=>$file11),
				"lang_malay_ml"=>array('file'=>$file12),
				"lang_norwegian_no"=>array('file'=>$file13),
				"lang_polish_pl"=>array('file'=>$file14),
				"lang_portuguese_po"=>array('file'=>$file15),
				"lang_romanian_ro"=>array('file'=>$file16),
				"lang_spanish_sp"=>array('file'=>$file17)
			),function($stat, $par){
			});
		}
		function generateLanguage()
		{
			if(!get_option("cf_custom_language_init"))
			{
				$current= get_option('app_language');
				if($current && strlen(trim($current))>0)
				{
					generate_custom_lang();
					add_option("cf_custom_language_init",1);
				}
			}
		}

		function desolveCertPosts()
		{
			if(isset($_POST['export_cert_for_completion'])|| isset($_POST['export_cert_for_exam']))
			{
				$GLOBALS['cf_post_cert_data']= $_POST;
				$_POST= array();
				$_SERVER['REQUEST_METHOD']='GET';
			}
		}
		public function loadGlobelScript()
		{

		}
		
		function loadCSSinFront()
		{
			
			echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/course_screen.css'>";
			$theme="a";
			if(isset($_COOKIE['cfCourseUserChooseTheme'])){
				$theme=$_COOKIE['cfCourseUserChooseTheme'];
				echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/theme_".$theme.".css' />";

			}else{
				if(isset($_COOKIE['cfCourseTheme']))
				{
					$theme=$_COOKIE['cfCourseTheme'];
					if($theme!="a")
					{
						echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/theme_".$theme.".css' />";
					}
				}else{
					echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/theme_".$theme.".css' />";
				}
			}
			
			echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/progress.css'>";
			echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."/assets/css/student_quiz_questions.css'>";
			echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."/assets/css/student_assign_questions.css'>";


			$plugin_url = plugin_dir_url( dirname( __FILE__,2 ) );
			
			$plugin_url = rtrim($plugin_url,"/");
			echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/star-rating-svg.css'>";
			echo "<script src='".COURSE_PLUGIN_URL."/assets/js/jquery.star-rating-svg.js' ></script>";
			echo '<link rel="stylesheet" href="'.$plugin_url.'/assets/fontawesome/css/all.css">';
			echo "<link rel='stylesheet' href='".$plugin_url."/assets/css/prism.css'>";
			echo "<script src='".COURSE_PLUGIN_URL."/assets/js/cf_course_fscript.js' ></script>";
			echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."assets/css/manage_quiz.css'>";
			
		}
		function loadJSinFront($p="s")
		{
			$plugin_url = plugin_dir_url( dirname( __FILE__,2 ) );
			$plugin_url = rtrim($plugin_url,"/");

			echo "<script type='text/javascript' src='".$plugin_url."/assets/js/jquery-3.4.1.min.js'></script>";
			echo "<script src='".COURSE_PLUGIN_URL."/assets/js/circle-progress.js' ></script>";
			echo "<script type='text/javascript' src='".$plugin_url."/assets/js/jscolor.js'></script>";
			echo " <script type='text/javascript' src='".$plugin_url."/assets/js/tinymce/tinymce.min.js'></script>
			<script type='text/javascript' src='".$plugin_url."/assets/js/tinymce/jquery.tinymce.min.js'></script>";
			echo "
			<script defer src='".$plugin_url."/assets/js/prism.js' ></script>";
	
			if( isset( $_GET['cf_vid'] )  )
			{
				$get_url = json_decode( base64_decode($_GET['cf_vid'] ), true);

				if(isset($get_url['type']) && $get_url['type']=="quiz")
				{
					echo "<script src='".COURSE_PLUGIN_URL."/assets/js/user_quiz_question_student.js' ></script>";
				}
				if( isset($get_url['type']) && $get_url['type']=="assignment"  )
				{
					echo "<script src='".COURSE_PLUGIN_URL."/assets/js/assignment_student.js' ></script>";
				}
				if( isset($get_url['type']) &&  $get_url['type']=="test" )
				{
					echo "<script src='".COURSE_PLUGIN_URL."/assets/js/test_student.js' ></script>";
				}
			}
			if( $p=="s" ){

				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/course_screen.js' ></script>";
			
			
			
			}elseif($p=="a"){

				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/course_screen.js' ></script>";
			
			}

		}
		function getConfig()
        {
            if(!$this->config)
            {
                $file=plugin_dir_path(__FILE__);
                $fp=fopen($file.'config.json','r');
                $data=json_decode(fread($fp,filesize($file.'config.json')));
                fclose($fp);
                if(isset($data->version))
                {
                    $this->config=$data;
                }
            }
        }
		function createMenu()
		{
			add_action('admin_menu',function(){
				
				add_menu_page('Courses','Courses','cfcourse_all_course',function(){
					$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_course";
					require_once('views/allcourse.php');
				},'','All Setups');

				add_submenu_page('cfcourse_all_course','Course','Course','cfcourse_popup_course',function(){require_once('views/popupSetting.php');});
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_manage_course')
				{
					if( isset( $_GET['cfcourse_id'] ) && !empty($_GET['cfcourse_id']) && $_GET['cfcourse_id'] != 0 )
					{	
						if( is_numeric( $_GET['cfcourse_id'] ) )
						{
							$course_id = $_GET['cfcourse_id'];
						}
						global $mysqli;
						$course_id = $mysqli->real_escape_string( $course_id );
						$section   = $this->load("section");
						$s_data    = $section->getSectionData( $course_id  );
						$course_d  = $section->getCourseDetails( $course_id  );
						add_submenu_page("cfcourse_all_course",$course_d['title'],$course_d['title'],'cfcourse_manage_course',function(){
						$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_course_content";
						require_once('views/manage_courses.php');});
					}
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_manage_comment')
				{
					add_submenu_page("cfcourse_all_course",'Manage Comments','Manage Comments','cfcourse_manage_comment',function(){
						$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
					require_once('views/manage_comment.php');});
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_assignment')
				{
					add_submenu_page("cfcourse_all_course",'Manage Assignments Response','Manage Assignments Response','cfcourse_assignment',function(){
						$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
					require_once('views/assignment.php');});
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_test')
				{
					add_submenu_page("cfcourse_all_course",'Manage Tests Response','Manage Tests Response','cfcourse_test',function(){
						$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
					require_once('views/tests.php');});
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_manage_review')
				{
					add_submenu_page("cfcourse_all_course",'Manage Reviews','Manage Reviews','cfcourse_manage_review',function(){
					$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
					require_once('views/reviews.php');});
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_manage_notes')
				{
					add_submenu_page("cfcourse_all_course",'Manage Notes','Manage Notes','cfcourse_manage_notes',function(){
						$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
					require_once('views/manage_notes.php');});
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_manage_quiz')
				{
				add_submenu_page("cfcourse_all_course",'Manage Quiz','Manage Quiz','cfcourse_manage_quiz',function(){
					$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_course_content";
					require_once('views/add_quiz_questions.php');});
			    }
			    if(isset($_GET['page']) && $_GET['page']=='cfcourse_quiz_response')
				{
				add_submenu_page("cfcourse_all_course",'Manage Quizzes Response','Manage Quizzes Response','cfcourse_quiz_response',function(){
					$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
					require_once('views/quizzes.php');});
			    }
			    if(isset($_GET['page']) && $_GET['page']=='cfcourse_assign_response')
				{
				add_submenu_page("cfcourse_all_course",'Manage Assignments Response','Manage Assignments Response','cfcourse_assign_response',function(){
					$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
					require_once('views/view_assign_response.php');});
			    }
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_manage_assignment')
				{
				add_submenu_page("cfcourse_all_course",'Manage Assignment','Manage Assignment','cfcourse_manage_assignment',function(){
					$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_course_content";
					require_once('views/manage_assignment.php');});
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_manage_test')
				{
				add_submenu_page("cfcourse_all_course",'Manage Test','Manage Test','cfcourse_manage_test',function(){
					$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_course_content";
					require_once('views/manage_test.php');});
				}
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_notes')
				{
					add_submenu_page("cfcourse_all_course",'Manage Notes','Manage Notes','cfcourse_notes',function(){
						$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_communication";
						require_once('views/manage_notes.php'); 
					});
				}
				
					add_submenu_page('cfcourse_all_course', 'Manage Certificates', 'Manage Certificates', 'cfcourse_manage_certificates', function(){
						$GLOBALS['cf_plugin_tutorial_link']= "https://coursefunnels.in/membership/members#tutorials_certification";
						$cirti_ob= $this->load('cirtificate_manager');
						$cirti_ob->openManager();
					});
				
				if(isset($_GET['page']) && $_GET['page']=='cfcourse_preview')
				{
					
						$loggedin_mem = get_loggedin_user();
						global $mysqli;
						global $dbpref;
						$main_screen_ob  =  $this->load('course_control');
						$question_ob     =  $this->load('quiz_questions_control');
						$quiz_stud_ob    =  $this->load('quiz_stud_control');
						$assign_stud_ob  =  $this->load('assign_stud_control');
						$assignment_ob   =  $this->load('assignment_control');
						$lecture_ob      =  $this->load("lecture");
						if( $loggedin_mem['permission'][0] == "admin")
						{

							$sql = "SELECT * FROM `".$dbpref."quick_member` WHERE `email`=".$loggedin_mem['id'];
							$get_row = $mysqli->query($sql);
							$mdata = $get_row->fetch_assoc();
							$preview   = json_decode(base64_decode($_GET['cfapreview']),true);

							$course_id = $mysqli->real_escape_string( $preview['course_id'] );

							$cdata = $main_screen_ob->get_course_by_id( $course_id );
							if($cdata)
							{
								$theme = $cdata['theme'];
							}else{
								$theme="a";
							}
							$plugin_url = plugin_dir_url( dirname( __FILE__,2 ) );
							$plugin_url = rtrim($plugin_url,"/");
							ob_start();
							echo '	<!doctype html><html><head>
							<meta name="viewport" content="width=device-width, initial-scale=1"><!--@cfbootstrap@--><link rel="stylesheet" href="assets/bootstrap/css/bootstrap.min.css">
							<script src="assets/js/jquery-3.4.1.min.js"></script><script src="assets/bootstrap/js/popper.min.js"></script><script src="assets/bootstrap/js/bootstrap.min.js"></script>
							<!--/@cfbootstrap@--><meta charset="utf-8" /><meta name="viewport" content="width=device-width,minimum-scale=1,initial-scale=1">';
							echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/course_screen.css'>";
							
							if(isset($_COOKIE['cfCourseUserChooseTheme'])){
								$theme=$_COOKIE['cfCourseUserChooseTheme'];
								echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/theme_".$theme.".css' />";
				
							}else{
								if(isset($_COOKIE['cfCourseTheme']))
								{
									$theme=$_COOKIE['cfCourseTheme'];
									if($theme!="a")
									{
										echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/theme_".$theme.".css' />";
									}else{
									echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/theme_".$theme.".css' />";

									}
								}else{
									echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/theme_".$theme.".css' />";
								}
							}
							echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/progress.css'>";
							echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."/assets/css/student_quiz_questions.css'>";
							echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."/assets/css/student_assign_questions.css'>";
							echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/star-rating-svg.css'>";
							echo "<script src='".COURSE_PLUGIN_URL."/assets/js/jquery.star-rating-svg.js' ></script>";
							echo '<link rel="stylesheet" href="'.$plugin_url.'/assets/fontawesome/css/all.css">';
							echo "<link rel='stylesheet' href='assets/css/prism.css'>";
							echo "<script src='".COURSE_PLUGIN_URL."/assets/js/cf_course_fscript.js' ></script>";
							echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."assets/css/manage_quiz.css'>
							</head>
							<body>
							<!-- Blank -->";
							$main_screen_ob->getMainScreeUI( $course_id,  $mdata,  $question_ob, $quiz_stud_ob , $lecture_ob , $assign_stud_ob,$assignment_ob,"a" );
							
							echo "<script type='text/javascript' src='".$plugin_url."/assets/js/jquery-3.4.1.min.js'></script>";
							echo "<script src='".COURSE_PLUGIN_URL."/assets/js/circle-progress.js' ></script>";
							echo "<script type='text/javascript' src='".$plugin_url."/assets/js/jscolor.js'></script>";
							echo " <script type='text/javascript' src='".$plugin_url."/assets/js/tinymce/tinymce.min.js'></script>
							<script type='text/javascript' src='".$plugin_url."/assets/js/tinymce/jquery.tinymce.min.js'></script>";
							echo "<script defer src='assets/js/prism.js' ></script>";
							if( isset( $_GET['cf_vid'] )  )
							{
								$get_url = json_decode( base64_decode($_GET['cf_vid'] ), true);

								if(isset($get_url['type']) && $get_url['type']=="quiz")
								{
									echo "<script src='".COURSE_PLUGIN_URL."/assets/js/user_quiz_question_student.js' ></script>";
								}
								if( isset($get_url['type']) && $get_url['type']=="assignment")
								{
									echo "<script src='".COURSE_PLUGIN_URL."/assets/js/assignment_student.js' ></script>";
								}
							}

							echo "<script src='".COURSE_PLUGIN_URL."/assets/js/course_screen_a.js' ></script>
							
							</body>
							</html>";
							$course_data=ob_get_clean();
							echo $course_data;

						}
				}
			});
		}
		
		function loadScripts()
		{
			$valid_pages=array('cfcourse_all_course','cfcourse_notes','cfcourse_quiz_response', 'cfcourse_popup_course','cfcourse_assignment','cfcourse_test','cfcourse_manage_review','cfcourse_manage_comment','cfcourse_create_review','cfcourse_manage_notes','cfcourse_view_assignment','cfcourse_view_quiz','cfcourse_manage_lecture','course_setting','cfcourse_manage_assignment','cfcourse_manage_test','cfcourse_quiz_response','cfcourse_assign_response','cfcourse_manage_quiz','cfcourse_manage_course');
			if(isset($_GET['page']) && in_array($_GET['page'], $valid_pages))
			{
				echo "<script src='assets/js/node_modules/js-base64/base64.js?v=".get_option('qfnl_current_version')."'></script>";
				echo "<script src='assets/js/request.js?v=".get_option('qfnl_current_version')."'></script>";
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/jquery.star-rating-svg.js' ></script>";
			}
			if(isset($_GET['page']) &&  $_GET['page']=="cfcourse_manage_course")
			{
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/jquery-ui.js'></script>";
			}
		}
		function addScriptsinSiglePage()
		{
			$valid_pages=array( 'cfcourse_popup_course','cfcourse_manage_lecture','course_setting','cfcourse_manage_assignment','cfcourse_manage_test','cfcourse_manage_quiz','cfcourse_manage_course');
			if(isset($_GET['page']) && in_array($_GET['page'], $valid_pages))
			{
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/leave.js' ></script>";
			}
		}


		public function addScript(){
			$v=0;
			if(isset($this->config->version))
			{
				$v=$this->config->version;
			}
			echo "
			<script type='text/javascript' src='assets/js/jscolor.js'></script>
			<script type='text/javascript' src='assets/js/tinymce/jquery.tinymce.min.js'></script>
			<script type='text/javascript' src='assets/js/tinymce/tinymce.min.js'></script>
			<script src='".COURSE_PLUGIN_URL."/assets/js/cf_course_script.js' ></script>";
			if(isset($_GET['page']) && $_GET['page']== "cfcourse_manage_course")
			{
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/section.js' ></script>
				<script src='".COURSE_PLUGIN_URL."/assets/js/lecture.js' ></script>
				<script src='".COURSE_PLUGIN_URL."/assets/js/quiz.js' ></script>
				<script src='".COURSE_PLUGIN_URL."/assets/js/assign.js' ></script>";	
			}

			$valid_pages=array('cfcourse_manage_assignment','cfcourse_manage_test','cfcourse_manage_quiz','cfcourse_quiz_response','cfcourse_assignment','cfcourse_test');

			if(isset($_GET['page']) &&  in_array($_GET['page'], $valid_pages))
			{
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/user_quiz_question_admin.js'></script>";
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/assignment.js'></script>";
				echo "<script defer src='assets/js/prism.js' ></script>";
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/assign.js' ></script>";
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/quiz.js' ></script>";
			}
			if (isset($_GET['page']) &&  $_GET['page']=="cfcourse_manage_certificates")
			{
				echo "<script src='".COURSE_PLUGIN_URL."/assets/js/manage_cirtificate.js'></script>";
			}

		}
		public function addStyle(){
			$v=0;
			if(isset($this->config->version))
			{
				$v=$this->config->version;
			}

			echo "<link rel='preconnect' href='https://fonts.gstatic.com'>
			<link href='".plugin_dir_url(__FILE__)."assets/css/vollkorn-font.css' rel='stylesheet'>";
			echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."assets/css/manage_course.css'>";
			echo "<link rel='stylesheet' href='".plugin_dir_url(__FILE__)."assets/css/manage_quiz.css'>";
			echo "<link rel='stylesheet' href='assets/css/prism.css'>";
			echo "<link rel='stylesheet' href ='".COURSE_PLUGIN_URL."/assets/css/star-rating-svg.css'>";
		}  

		public function takleAjaxRequest(){
			
			add_action( 'cf_ajax_myPopupCourseAjax', function(){
			 $course_ob=$this->load('training_control');
             $course_ob->getAjaxRequest( $_REQUEST );
			});
			add_action( 'cf_ajax_cfcourse_delete_content', function(){
				$lecture_ob=$this->load('lecture');
				$lecture_ob->deleteContent( $_REQUEST );
			   });
			
			add_action( 'cf_ajax_cfcourse_fetch_reply', function(){
				print_r($_REQUEST);
				$training_ob=$this->load('training_control');
				$course_ob=$this->load('course_control');
				$training_ob->getAllCommentsReply( $_REQUEST, $course_ob );
			   });

			add_action( 'cf_ajax_myPopupCourseAjax_category', function(){
			 $course_ob=$this->load('training_control');
             $course_ob->getAjaxRequestCategory( $_REQUEST );
			});

			add_action( 'cf_ajax_cfbulkAction', function(){
				$course_ob=$this->load('training_control');
				global $mysqli;
				
				$bulk = $mysqli->real_escape_string($_REQUEST['bulk']);

				if($bulk=="comment")// this is for comment delete
				{
					$course_ob->commentDelete( $_REQUEST,true );
				}else if($bulk=="appr")
				{
					$course_ob->commentApproved($_REQUEST,"all",true );
				}
				else if($bulk=="read")
				{
					$course_ob->commentMarkasRead($_REQUEST,"all",true );
				}
				else if($bulk=="all_data")
				{
					$course_ob->BulkCommentAction( $_REQUEST );

				}
			});
			add_action( 'cf_ajax_cfbulkActionNotes', function(){
				$course_ob=$this->load('training_control');
				global $mysqli;
				
				$bulk = $mysqli->real_escape_string($_REQUEST['bulk']);

				if($bulk=="notes")// this is for notes delete
				{
					$course_ob->NotesDelete( $_REQUEST,true );
				}
				else if($bulk=="read")
				{
					$course_ob->notesMarkasRead($_REQUEST,"all",true );
				}
				else if($bulk=="all_data")
				{
					$course_ob->BulkNotesAction( $_REQUEST );

				}
			});
			add_action( 'cf_ajax_cfAssignementbulkAction', function(){
				$assign_ob=$this->load('assignment_control');
				global $mysqli;
				$bulk = $mysqli->real_escape_string($_REQUEST['bulk']);

				if($bulk=="reply_assign")
				{
					$assign_ob->replyCheckedAssignment($_REQUEST );
				}
				else if($bulk=="reply_assign_bulk")
				{
					$assign_ob->replyBulkCheckedAssignment($_REQUEST );
				}else if($bulk=="check_assign")
				{
					$assign_ob->assignChecked($_REQUEST,"all",true );
				}
				else if($bulk=="delete_assign")
				{
					$assign_ob->assignDelete($_REQUEST,true );
				}
				else if($bulk=="all_data")
				{
					$assign_ob->BulkAssignAction( $_REQUEST );

				}
			});
			add_action( 'cf_ajax_cfQuizbulkAction', function(){
				$quiz_ob=$this->load('quiz_stud_control');
			
				global $mysqli;
				$bulk = $mysqli->real_escape_string($_REQUEST['bulk']);

				if($bulk=="reply_quiz")
				{
					$quiz_ob->replyCheckedQuiz($_REQUEST );
				}
				else if($bulk=="reply_quiz_bulk")
				{
					$quiz_ob->replyBulkCheckedQuiz($_REQUEST );
				}else if($bulk=="check_quiz")
				{
					$quiz_ob->quizChecked($_REQUEST,"all",true );
				}
				else if($bulk=="delete_quiz")
				{
					$quiz_ob->quizDelete($_REQUEST,true );
				}
				else if($bulk=="all_data")
				{
					$quiz_ob->BulkQuizAction( $_REQUEST );

				}else if($bulk=="quiz_response")
				{
					$quiz_ob->ShowQuizResponse( $_REQUEST );

				}
				else if($bulk=="store_check_quiz")
				{
					$quiz_ob->addCheckQuiz( $_REQUEST );
				}
			});

			add_action( 'cf_ajax_cfbulkReviewAction', function(){
				$training_ob=$this->load('training_control');
				global $mysqli;
				$bulk = $mysqli->real_escape_string($_REQUEST['bulk']);

				if($bulk=="delete_assign")
				{
					$training_ob->reviewDelete($_REQUEST,true );
				}
				else if($bulk=="read")
				{
					$training_ob->reviewMarkasRead($_REQUEST,"all",true );
				}
				else if($bulk=="all_data")
				{
					$training_ob->BulkReviewAction( $_REQUEST );

				}
			});

			add_action( 'cf_ajax_nopriv_cfcoursse_quiz_stud_Ajax', function(){
			 $quiz_stud_ob=$this->load('quiz_stud_control');
             $quiz_stud_ob->getAjaxRequest( $_REQUEST );
			});
			
			add_action( 'cf_ajax_cfcoursse_quiz_stud_Ajax', function(){
				$quiz_stud_ob=$this->load('quiz_stud_control');
				$quiz_stud_ob->getAjaxRequest( $_REQUEST );
			});

			add_action( 'cf_ajax_nopriv_cfFetchSentEmail', function(){
				$assign_ob=$this->load('assignment_control');
				$assign_ob->getSentEmial( $_REQUEST );
			   });
			   
			   add_action( 'cf_ajax_cfFetchSentEmail', function(){
				$assign_ob=$this->load('assignment_control');
				   $assign_ob->getSentEmial( $_REQUEST );
			   });
			add_action( 'cf_ajax_nopriv_cfcourse_add_rating', function(){
				$addrating_ob=$this->load('course_control');
				$addrating_ob->addRating( $_REQUEST );
			   });
			   
			add_action( 'cf_ajax_cfcourse_add_rating', function(){
				$addrating_ob=$this->load('course_control');
				$addrating_ob->addRating( $_REQUEST );
			});

			add_action( 'cf_ajax_cfcoursecheck_assignment', function(){
				$addrating_ob=$this->load('assign_stud_control');
				$addrating_ob->addCheckAssignment( $_REQUEST );
			});
			add_action( 'cf_ajax_cfcourse_add_content', function(){
				$lecture_ob=$this->load('lecture');
				$lecture_ob->addLectureContent( $_REQUEST );
			});
			add_action( 'cf_ajax_cfcourse_edit_content', function(){
				$lecture_ob=$this->load('lecture');
				$lecture_ob->editContent( $_REQUEST );
			});			
			add_action( 'cf_ajax_cfcourse_show_review_res', function(){
				$show_ob = $this->load('assign_stud_control');
				$show_ob->showAssignmentReponse( $_REQUEST );
			});
			add_action( 'cf_ajax_cfcourse_load_section', function(){
				$section_ob = $this->load('section');
				$section_ob->getSectionDataAjax( $_REQUEST );
			});

			add_action( 'cf_ajax_nopriv_assign_stud_Ajax', function(){
			 $assignment_ob   =  $this->load('assignment_control');
			 $quiz_stud_ob=$this->load('assign_stud_control');
             $quiz_stud_ob->getAjaxRequest( $_REQUEST, $assignment_ob );
			});
			
			add_action( 'cf_ajax_assign_stud_Ajax', function(){
				$assignment_ob   =  $this->load('assignment_control');
				$quiz_stud_ob=$this->load('assign_stud_control');
				$quiz_stud_ob->getAjaxRequest( $_REQUEST,$assignment_ob  );
			   });

			add_action( 'cf_ajax_myAssignmentAjax', function(){
			$course_ob=$this->load('assignment_control');
             $course_ob->getAjaxRequest( $_REQUEST );
			});

			add_action( 'cf_ajax_myAssignmentQueAjax', function(){
				$course_ob=$this->load('assignment_control');
             	$course_ob->getAjaxRequestQue( $_REQUEST );
			});

			add_action( 'cf_ajax_cfmyQuizQuestionAjax', function(){
				$quiz_ob=$this->load('quiz_questions_control');
				$quiz_ob->addQuizQuestion( $_REQUEST );
			});

			add_action( 'cf_ajax_cfmyQuizAddAjax', function(){
				$quiz_ob=$this->load('quiz_questions_control');
				$quiz_ob->AddBasicSettingsforQuiz( $_REQUEST );
			});
			add_action( 'cf_ajax_cfCourseQuizRemoveQuestion', function(){
				$quiz_ob=$this->load('quiz_questions_control');
				$quiz_ob->delete_a_question( $_REQUEST );
			});

			add_action( 'cf_ajax_cfCourseRemoveQuestion', function(){
				$course_ob=$this->load('assignment_control');
				 $course_ob->delete_question( $_REQUEST );
			});		

			add_action("cf_ajax_cfcourse_add_section", function(){
				$section = $this->load("section");
				$section->handleSectionData( $_REQUEST );
			});

			add_action("cf_ajax_cfcourse_add_lecture", function(){
				$lecture = $this->load("lecture");
				$lecture->addLectureContent( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_quiz", function(){

				$quiz = $this->load("quiz");
				$quiz->handleQuizData( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_assign", function(){

				$assign = $this->load("assignment");
				$assign->handleAssignmentData( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_pos", function(){

				$assign = $this->load("section");
				$assign->addPosition( $_REQUEST );
			});
			add_action("cf_ajax_cfcourse_copy_course", function(){

				$copy_ob = $this->load("training_control");
				$copy_ob->copyFullCourse( $_REQUEST );
			});
			
			add_action("cf_ajax_nopriv_cfcourse_add_progress", function(){
				$addWatch = $this->load("lecture");
				$addWatch->addWatched( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_progress", function(){
				$addWatch = $this->load("lecture");
				$addWatch->addWatched( $_REQUEST );
			
			});
			
			add_action("cf_ajax_nopriv_cfcourse_check_like_dislike", function(){
				$addWatch = $this->load("lecture");
				$addWatch->checkLikeStatus( $_REQUEST );
			});
			add_action("cf_ajax_cfcourse_check_like_dislike", function(){
				$addWatch = $this->load("lecture");
				$addWatch->checkLikeStatus( $_REQUEST );
			});
			add_action("cf_ajax_nopriv_cfcourse_add_like", function(){
				$addWatch = $this->load("lecture");
				$addWatch->addLike( $_REQUEST );
			});
			add_action("cf_ajax_cfcourse_add_like", function(){
				$addWatch = $this->load("lecture");
				$addWatch->addLike( $_REQUEST );
			});
			add_action("cf_ajax_nopriv_cfcourse_add_dislike", function(){
				$addWatch = $this->load("lecture");
				$addWatch->addDisLike( $_REQUEST );
			});
			add_action("cf_ajax_cfcourse_add_dislike", function(){
				$addWatch = $this->load("lecture");
				$addWatch->addDisLike( $_REQUEST );
			});
			add_action("cf_ajax_nopriv_cfcourse_add_notes", function(){
				$addNotes = $this->load("lecture");
				$addNotes->addNotes( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_notes", function(){
				$addNotes = $this->load("lecture");
				$addNotes->addNotes( $_REQUEST );
			
			});
			add_action("cf_ajax_nopriv_cfcourse_add_comment", function(){
				$addComment = $this->load("lecture");
				$addComment->addComment( $_REQUEST );
				
			
			});
			add_action("cf_ajax_cfcourse_add_comment", function(){
				
				$addComment = $this->load("lecture");
				$addComment->addComment( $_REQUEST );
			
			});
			
			add_action("cf_ajax_nopriv_cfcourse_add_video_time", function(){
				$addDuration = $this->load("assignment");
				$addDuration->addDuration( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_video_time", function(){
				$addDuration = $this->load("assignment");
				$addDuration->addDuration( $_REQUEST );
			
			});
			add_action("cf_ajax_nopriv_cfcourse_total_video_time", function(){
				
				$addTotalWatched = $this->load("assignment");
				$addTotalWatched->totalWached( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_total_video_time", function(){
				
				$addTotalWatched = $this->load("assignment");
				$addTotalWatched->totalWached( $_REQUEST );
			
			});
			add_action("cf_ajax_nopriv_cfcourse_add_comment_like", function(){
				
				$addCLike = $this->load("lecture");
				$addCLike->addCommentLike( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_comment_like", function(){
				
				$addCLike = $this->load("lecture");
				$addCLike->addCommentLike( $_REQUEST );
			
			});
			add_action("cf_ajax_nopriv_cfcourse_add_comment_dislike", function(){
				
				$addCLike = $this->load("lecture");
				$addCLike->addCommentDislike( $_REQUEST );
			
			});
			add_action("cf_ajax_cfcourse_add_comment_dislike", function(){
				
				$addCLike = $this->load("lecture");
				$addCLike->addCommentDislike( $_REQUEST );
			
			});
			add_action("cf_ajax_nopriv_cfcourse_show_comment", function(){
				$addDuration = $this->load("lecture");
				global $mysqli;
				$cid   = $mysqli->real_escape_string( trim( $_REQUEST['cid'] ) );
				$sid   = $mysqli->real_escape_string( trim( $_REQUEST['sid'] ) );
				$oid   = $mysqli->real_escape_string( trim( $_REQUEST['oid'] ) );
				$mid   = $mysqli->real_escape_string( trim( $_REQUEST['mid'] ) );
				$today   = $mysqli->real_escape_string( trim( $_REQUEST['date_a'] ) );
				$addDuration->getAllComment( $oid,  $mid, $last_id=0,"all", "yes",$today );
				
			
			});
			add_action("cf_ajax_cfcourse_show_comment", function(){
				$addDuration = $this->load("lecture");
				global $mysqli;
				$cid   = $mysqli->real_escape_string( trim( $_REQUEST['cid'] ) );
				$sid   = $mysqli->real_escape_string( trim( $_REQUEST['sid'] ) );
				$oid   = $mysqli->real_escape_string( trim( $_REQUEST['oid'] ) );
				$mid   = $mysqli->real_escape_string( trim( $_REQUEST['mid'] ) );
				$today   = $mysqli->real_escape_string( trim( $_REQUEST['date_a'] ) );
				$addDuration->getAllComment( $oid,  $mid, $last_id=0,"all", "yes",$today );
			
			});
		}
		//});//end of takle ajax request.. 
		
		public function createShortCode( )
		{

			add_shortcode( "cfcourse_shortcode", function($params){
				global $mysqli;
				if(isset($params['id']))
				{
				$v=0;
				if(isset($this->config->version))
				{
					$v=$this->config->version;
				}
					$id=$mysqli->real_escape_string( trim( $params['id'] ) );
					ob_start();
					$course_ob=$this->load('course_control');
					$course_ob->getcourseUI($id,$v);
					$data=ob_get_clean();
					return $data;
				}
			});

			add_shortcode( "cfcourse_allcourse_shortcode", function(){
				$v=0;
				global $mysqli;
				if(isset($this->config->version))
				{
					$v=$this->config->version;
				}
					ob_start();
					$allcourse_ob=$this->load('course_control');
					$allcourse_ob->getallcourseUI($v);
					$data=ob_get_clean();
					return $data;
			});
			add_shortcode("cfcourse_review", function($params){
				if(isset($params['id']))
				{

					$v=0;
				if(isset($this->config->version))
				{
					$v=$this->config->version;
				}
				global $mysqli;
				$id=$mysqli->real_escape_string( trim( $params['id'] ) );
					ob_start();
					$review_ob = $this->load('training_control');
					$review_ob->getAllReviewUI( $id, $v );
					$data      = ob_get_clean();
					return $data;
				}
			});
			add_shortcode("cfcourse_dropdown", function($params){
				$v=0;
				if(isset($this->config->version))
				{
					$v=$this->config->version;
				}
				if(isset($params['id']))
				{
					ob_start();
					$review_ob = $this->load('training_control');
					$review_ob->getAllShortCode( $params, $v,"dropdown" );
					$data      = ob_get_clean();
					return $data;
				}else{
					$params['id']=0;
					$params['position']="";
					ob_start();
					$review_ob = $this->load('training_control');
					$review_ob->getAllShortCode( $params, $v,"dropdown" );
					$data      = ob_get_clean();
					return $data;
				}
			});
			add_shortcode("cfcourse_student_progress", function($params){
				$v=0;
				if(isset($this->config->version))
				{
					$v=$this->config->version;
				}
				if(isset($params['id']))
				{
					ob_start();
					$review_ob = $this->load('training_control');
					$review_ob->getAllShortCode( $params, $v,"progress" );
					$data      = ob_get_clean();
					return $data;
				}else{
					$params['id']=0;
					$params['position']="";
					ob_start();
					$review_ob = $this->load('training_control');
					$review_ob->getAllShortCode( $params, $v,"progress" );
					$data      = ob_get_clean();
					return $data;
				}
			});
			add_shortcode("cfcourse_member_progress", function($params){
				$v=0;
				if(isset($this->config->version))
				{
					$v=$this->config->version;
				}
				if(isset($params['id']))
				{
					ob_start();
					$review_ob = $this->load('training_control');
					$review_ob->getAllShortCode( $params, $v,"progress" );
					$data      = ob_get_clean();
					return $data;
				}else{
					$params['id']=0;
					$params['position']="";
					ob_start();
					$review_ob = $this->load('training_control');
					$review_ob->getAllShortCode( $params, $v,"progress" );
					$data      = ob_get_clean();
					return $data;
				}
			});
		}

}//end class
new CFcourse_base();
}//end if
?>