<div class="container app-guide">
    <div class="row">
        <div class="col-md-12">

            <div class="accordion" id="accordionExample">
                <div class="card z-depth-0 bordered">
                    <div class="card-header card-header-copy" id="headingOne">
                        <h5 class="mb-0">
                            <button class="btn btn-link text-white" type="button" data-toggle="collapse" data-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                                <i class="fas fa-arrow-right"></i> <?php w("Course templating for email & students area"); ?>
                            </button>
                        </h5>
                    </div>
                    <div id="collapseOne" class="collapse" aria-labelledby="headingOne" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="alert alert-info">
                                <div class="row">
                                    <div class="col-md-1"><i class="fas fa-info-circle fa-3x"></i>
                                    </div>
                                    <div class="col-md-11 pt-8">
                                        <span class="mt-2">
                                   <?php w("You can customize the course access email as well as the student's area. The details are written below."); ?>
                                        </span>
                                    </div>
                                </div>
                            </div>
                            <span class="total-data"><?php w("Display Single Course"); ?></span>
                                <pre>
                                <code class="language-js">
                                {course.id} -<?php w("For course ID"); echo "\n"; ?>
                                {course.title} -<?php w("Course Title"); echo "\n"; ?>
                                {course.show_url} -<?php w("Course URL"); echo "\n"; ?>
                                {course.membership_url} -<?php w("Membership Page URL"); echo "\n"; ?>
                                {course.currency} -<?php w("Course Currency"); echo "\n"; ?>
                                {course.tax} -<?php w("Course Tax"); echo "\n"; ?>
                                {course.category} -<?php w("Course Category"); echo "\n"; ?>
                                {course.level} -<?php w("Course Level"); echo "\n"; ?>
                                {course.date} -<?php w("Only for course certificate generation date"); echo"\n"; ?>
                                </code>
                            </pre>

                            <span class="total-data"><?php w("Multiple courses Looping"); ?></span>
                            <pre>
                                <code class="language-js">
                                {courses}
                                    {course.id}
                                    {course.title}
                                    {course.currency}
                                    {course.show_url} 
                                    {course.membership_url}
                                {/courses}
                                </code>
                            </pre>
    
                            <span class="total-data"><?php w("Example"); ?></span>
                            <pre>
                                <code class="language-html">
                                <?= t('Hi, Your Purchased courses are'); ?> 
                                {courses}
                                    (#{course.id}) {course.title} URL: {course.url}
                                {/courses}
                                </code>
                            </pre>
                            <span class="total-data ml-5"><?php w("Expected Output (Let's assume we have two courses)") ?></span>
                            <pre class="mt-0 ml-5">
                                <code class="language-css mt-0">
                                <?= t('Hi, Your Purchased courses are'); ?> 
                                (#12345) course1 url: http://courseurl.com
                                (#123456) course2 url: http://courseurl.com
                                </code>
                            </pre>
                            <p></p>
                        </div>
                    </div>
                </div>
                <div class="card z-depth-0 bordered">
                    <div class="card-header card-header-copy" id="headingOneSub">
                        <h5 class="mb-0">
                            <button class="btn btn-link text-white" type="button" data-toggle="collapse" data-target="#collapseOneSub" aria-expanded="true" aria-controls="collapseOne">
                                <i class="fas fa-arrow-right"></i> <?php w("Course template for checkout page"); ?>
                            </button>
                        </h5>
                    </div>
                    <div id="collapseOneSub" class="collapse" aria-labelledby="headingOneSub" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="alert alert-info">
                                <div class="row">
                                    <div class="col-md-1"><i class="fas fa-info-circle fa-3x"></i>
                                    </div>
                                    <div class="col-md-11 pt-8">
                                        <span class="mt-2">
                                        <?php w("The templating process for the checkout page is the same as 'Course templating for email & students area'. Here on the checkout page, we have a few more independent variable support"); ?>
                                        </span>
                                    </div>
                                </div>
                            </div>
                            <span class="total-data"><?php w("Additional Variables"); ?></span>
                                <pre>
                                <code class="language-js">
                                {shipping_charge} -<?php w("To display the total shipping charge"); echo "\n"; ?>
                                {tax_amount} -<?php w("To display the total tax amount"); echo "\n"; ?>
                                {subtotal_price} -<?php w("Total product price"); echo "\n"; ?>
                                {total_price} -<?php w("Total product price including tax and shipping charges"); echo "\n"; ?>
                                {payment_currency} -<?php w("To display currency that's going to be applied"); echo "\n"; ?> 
                                </code>
                            </pre>
    
                            <span class="total-data"><?php w("Example"); ?></span>
                            <p><?php w("Please watch our Checkout related templates for a better understanding"); ?></p>
                            <p></p>
                        </div>
                    </div>
                </div>
                <div class="card z-depth-0 bordered">
                    <div class="card-header card-header-copy" id="headingTwo">
                        <h5 class="mb-0">
                            <button class="btn btn-link collapsed text-white" type="button" data-toggle="collapse" data-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
                                <i class="fas fa-arrow-right"></i><?php w("Templating with students details"); ?>
                            </button>
                        </h5>
                    </div>
                    <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="alert alert-info">
                                <div class="row">
                                    <div class="col-md-1"><i class="fas fa-info-circle fa-3x"></i>
                                    </div>
                                    <div class="col-md-11 pt-8"><span class="">
                                            <?php w("Student's email & students area customization."); ?>
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <span class="total-data"><?php w("Display Single Variables"); ?></span>
                            <pre>
                                <code class="language-js">
                                {name} -<?php w("Student's name"); echo "\n"; ?>
                                {email} -<?php w("Student's Email"); echo "\n"; ?>
                                //--<?php w("Example of dynamic variables"); ?>--<?php echo "\n"; ?>
                                    {Any_Stored_Entity} - /*--<?php w("You can display variable added for the relevant student that came through Order Form, Registration Forms, IPN Requests"); ?>--*/ <?php echo "\n"; ?>
                                    //<?php w("Example"); echo "\n"; ?>
                                    {address} - <?php w("Address that stored through any method mentioned above"); ?> 
                                
                                //<?php w("Display payment data"); ?> 
                                    {payment_id} - <?php w("Payment id"); ?> 
                                    {total_paid} -<?php w("Total payment amount"); ?> 
                                    {payer_name} -<?php w("Payer name"); ?> 
                                    {payer_email} -<?php w("Payer email"); echo "\n"; ?>

                                // <?php w("No-conflict rule"); echo "\n"; ?>
                                    /*--<?php w("To avoid unwanted replacement append \${1} with variables",array('`student`')); ?>--*/
                                    //<?php w("Example"); echo "\n"; ?>
                                    {student.name} -<?php w("Student's name"); ?> 
                                    {student.address} -<?php w("Student's address"); echo "\n"; ?>
                                </code>
                            </pre>

                            <span class="total-data text-lg"><?php w("Multiple students detail Looping With Mail Content"); ?></span>
                            <pre>
                                <code class="language-js">
                                {students}
                                    {student.payment_id}
                                    {student.login_url} 
                                    {student.email} 
                                    {student.password} 
                                    {student.payer_name} 
                                    {student.payer_email}
                                    {student.total_paid}
                                    //...<?php w("For dynamic variables write"); ?> {student.your_variable_name}
                                {/students}
                                </code>
                            </pre>
                            
                            <span class="total-data text-lg"><?php w("Example"); ?>:</span>
                            <pre>
                                <code class="language-html">
                                <?php w('Hi, Your membership credentials for {course.title} written below'); ?>

                                {students}
                                    Login URL: {student.login_url} 
                                    Email: {student.email} 
                                    Password: {student.password}
                                {/students}
                                </code>
                            </pre>
                            <span class="total-data text-lg ml-5"><?php w("The expected output is written below (Let's assume the buyer has one course `My Course` and you are creating two course funnel's access for it"); ?></span>
                            <pre class="ml-5">
                                <code class="language-html">
                                <?php w('Hi, Your membership credentials for My Course written below'); ?>

                                Login URL: http://yoursite.com/path/login_page 
                                Email: user@host.com 
                                Password: @aedvhb545tf

                                Login URL: http://yoursite.com/path/login_page_2 
                                Email: user@host.com 
                                Password: @dfg2455545-
                                </code>
                            </pre>
                            <span class="total-data"><?php w("Logout Link On Membership area and course pages"); ?></span>
                            <pre>
                                <code class="language-js">
                                {logout_url} -<?php w("Log out URL"); echo "\n"; ?> 
                                {logout_link} -<?php w("Linked logout text."); echo "\n"; ?>
                                </code>
                            </pre>

                        </div>
                    </div>
                </div>
                <div class="card z-depth-0 bordered">
                    <div class="card-header card-header-copy" id="headingThree">
                        <h5 class="mb-0">
                            <button class="btn btn-link text-white collapsed" type="button" data-toggle="collapse" data-target="#collapseThree" aria-expanded="false" aria-controls="collapseThree">
                                <i class="fas fa-arrow-right"></i> <?php w("Add Optional courses In Order Form To Sell"); ?>
                            </button>
                        </h5>
                    </div>
                    <div id="collapseThree" class="collapse" aria-labelledby="headingThree" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="alert alert-info">
                                <div class="row">
                                    <div class="col-md-1"><i class="fas fa-info-circle fa-3x"></i>
                                    </div>
                                    <div class="col-md-11 my-auto"><span class="">
                                            <?php w("Add Optional courses In Order Form"); ?>
                                        </span>
                                    </div>
                                </div>
                            </div>
   
                            <p><?php w("You can add optional courses on the order form that people can buy alongside the main course."); ?><br>
                            (** <?php w("You can do the same with our editor without writing HTML manually"); ?>)<br>
                            </p>
                            <span class="total-data"><?php w("Example"); ?></span>
                            <pre style="margin-bottom:2px">
                                <code class="language-html">
                                   <?php w("Single Course"); echo "\n"; ?>
                                   <?php w("Field name \${1} and value should be preferred course id",array("`optional_courses`")); echo "\n"; ?>

                                   <?php w("Example"); ?>:
                                   <span><</span>input type="checkbox" name="optional_courses" value="12345">


                                   <?php w("Multiple Courses"); echo "\n"; ?>
                                   <?php w("Field name \${1} and value should be preferred course ids",array('`optional_courses[]`')); echo "\n"; ?>

                                   <?php w("Example") ?>:
                                   <span><</span>input type="checkbox" name="optional_courses[]" value="123445">
                                   <span><</span>input type="checkbox" name="optional_courses[]" value="123445">
                                </code>
                            </pre>
                        </div>
                    </div>
                </div>

                <div class="card z-depth-0 bordered">
                    <div class="card-header card-header-copy" id="heading4">
                        <h5 class="mb-0">
                            <button class="btn btn-link text-white collapsed" type="button" data-toggle="collapse" data-target="#collapse4" aria-expanded="false" aria-controls="collapseThree">
                                <i class="fas fa-arrow-right"></i> <?php w("Validation Errors"); ?></button>
                        </h5>
                    </div>
                    <div id="collapse4" class="collapse" aria-labelledby="headingThree" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="alert alert-info">
                                <div class="row">
                                    <div class="col-md-1"><i class="fas fa-info-circle fa-3x"></i>
                                    </div>
                                    <div class="col-md-11 my-auto"><span class="">
                                            <?php w("Display Validation Error For Login, Register and Forgot Password pages"); ?>
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <pre>
                                <code class="language-html">
                                    {validation_error} - <?php w("Use this to display validation errors"); echo "\n"; ?> 
                                    <?php w("Example Output"); ?>:
                                    `student already exists`, `Invalid email id` etc
                                </code>
                            </pre>
                        </div>
                    </div>
                </div>


                <div class="card z-depth-0 bordered">
                    <div class="card-header card-header-copy" id="heading5">
                        <h5 class="mb-0">
                            <button class="btn btn-link text-white collapsed" type="button" data-toggle="collapse" data-target="#collapse5" aria-expanded="false" aria-controls="collapseThree">
                                <i class="fas fa-arrow-right"></i> <?php w("Template Creation Guide For Forgot Password Page"); ?>
                            </button>
                        </h5>
                    </div>
                    <div id="collapse5" class="collapse" aria-labelledby="headingThree" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="alert alert-info">
                                <div class="row">
                                    <div class="col-md-1"><i class="fas fa-info-circle fa-3x"></i>
                                    </div>
                                    <div class="col-md-11 my-auto"><span class="">
                                    <?php w("Template Creation Guide For Forgot Password Page"); ?>
                                        </span>
                                    </div>
                                </div>
                            </div>
                            <pre>
                                <code class="language-html">
                                    <?php w("Email Input"); echo "\n"; ?> 
                                    {insert_email}<?php w("content"); ?>{/insert_email}

                                    <?php w("Confirmation Message and OTP Input"); echo "\n"; ?>
                                    {confirmation_message}<?php w("content"); ?>{/confirmation_message}
                                    
                                    <?php w("Update password fields"); echo "\n"; ?>
                                    {update_password}<?php w("content"); ?>{/update_password}

                                    <span><<span>--! <?php w("For detail see our inbuilt templates"); ?> -->
                                </code>
                            </pre>
                        </div>
                    </div>
                </div>

                <div class="card z-depth-0 bordered">
                    <div class="card-header card-header-copy" id="heading5">
                        <h5 class="mb-0">
                            <button class="btn btn-link text-white collapsed" type="button" data-toggle="collapse" data-target="#collapse6" aria-expanded="false" aria-controls="collapseThree">
                                <i class="fas fa-arrow-right"></i> <?php w("Template Creation Guide For Completion and Exam certificates."); ?>
                            </button>
                        </h5>
                    </div>
                    <div id="collapse6" class="collapse" aria-labelledby="headingThree" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="alert alert-info">
                                <div class="row">
                                    <div class="col-md-1"><i class="fas fa-info-circle fa-3x"></i>
                                    </div>
                                    <div class="col-md-11 my-auto"><span class="">
                                    <?php w("The templating process for a certificate is almost the same as creating a template for showing products and membership data. In this case, the only thing that we don't need is a product or membership loop. Also here we have few more variables for an exam certificate to display data like grade, correct answers, percentage, etc exam and result in related data."); ?>
                                        </span>
                                    </div>
                                </div>
                            </div>
                            
                            <div>
                            <?php w("For both kind of cases Completion & Exam certificate, if you want to attach student detail for example student name, email etc just follow the section \${1} present in \${2}. Similarly, if you want to attach course detail like course name price etc just follow the section \${3} present in \${4}",array('<strong>'.t('Display single variables').'</strong>','<strong>'.t('Templating with students details').'</strong>','<strong>'.t('Display Single Course').'</strong>','<strong>'.t('Course templating for email & students area').'</strong>') ); ?>
                            </div><br>

                            <span class="total-data"><?php w('Detail of additional data that can be used with exam certificates for showing exam and result related data'); ?></span>
                            <pre>
                                <code class="language-html">
                                    {candidate_id} - <?php w("A unique id that use to be generated for each student during the exam (It's not the same as student id)"); ?><br>
                                    {student_id} - <?php w('This is the student id'); ?><br>
                                    {candidate_name} - <?php w('Candidate name used during the exam'); ?><br>
                                    {candidate_email} - <?php w('Candidate email used during the exam'); ?><br>
                                    {exam_name} - <?php w('Exam name'); ?><br>
                                    {exam_description} - <?php w('Description for the exam'); ?><br>
                                    {exam_id} - <?php w('Exam Id'); ?><br>
                                    {correct_answers} - <?php w('Number of correct answers'); ?><br>
                                    {total_questions} - <?php w('Number of total questions'); ?><br>
                                    {number_of_attempts} - <?php w('Number of total attempts'); ?><br>
                                    {number_of_unanswerd} - <?php w('Number of questions that were not answered'); ?><br>
                                    {result_in_percentage} - <?php w('Result in percentage.'); ?><br>
                                    {result_status} - <?php w('Progress status text that you have arranged for the exam depending on the mark.');?> <br>
                                    {time_spent} - <?php w('Time spent by the candidate for the exam'); ?><br>
                                    {result_out_date}- <?php w('Result out date'); ?><br>
                                </code>
                            </pre>
                        </div>
                    </div>
                </div>


            </div>
            <!-- product detail-->




        </div>

    </div>
</div>